/*
	decl.h
		Type declarations
		this file is part of Vegas
		last modified 30 Aug 07 th
*/


#include "stddecl.h"

#define MAXGRIDS 10

#define MAXSTATESIZE 128

#define NBINS 128

typedef unsigned char bin_t;
/* Note: bin_t must be wide enough to hold the numbers 0..NBINS */

typedef const bin_t cbin_t;

typedef real Grid[NBINS];

typedef struct {
  real sum, sqsum;
  real weightsum, avgsum;
  real chisum, chisqsum, guess;
  real avg, err, chisq;
} Cumulants;

void flushCumulant(Cumulants* c) {
  c->sum=0.0;
  c->sqsum=0.0;
  c->weightsum=0.0;
  c->avgsum=0.0;
  c->chisum=0.0;
  c->chisqsum=0.0;
  c->guess=0.0;
  c->avg=0.0;
  c->err=0.0;
  c->chisq=0.0;
};

typedef const Cumulants cCumulants;

typedef void (*Integrand)(ccount *, creal *, ccount *, real *, creal *);

