
*******************************************************************************

      double complex function zx(x)
      
      implicit none
      double complex x

      zx = 4d0/( sqrt(x+4d0)+sqrt(x) )**2
      
      end

*******************************************************************************

      double complex function Hm1(x)

      implicit none
      double complex x

      Hm1 = log(1d0+x)

      end

*******************************************************************************

      double complex function Hmr(x)

      implicit none
      double complex x, z, zx

      z = zx(x)

      Hmr = - log(z)

      end

*******************************************************************************

      double complex function H0m1(x)

      implicit none
      double complex x
      double complex xspenz
      
      H0m1 = - xspenz(-x)

      end

********************************************************************************

      double complex function Hmrmr(x)

      implicit none
      double complex x, z, zx

      z = zx(x)

      Hmrmr = 1d0/2d0*log(z)**2

      end

*******************************************************************************

      double complex function H00m1(x)

      implicit none
      double complex x
      double complex xli3

      H00m1 = - xli3(-x)
      
      end

********************************************************************************

      double complex function Hmrmrmr(x)

      implicit none
      double complex x, z, zx

      z = zx(x)

      Hmrmrmr = - 1d0/6d0*log(z)**3
      
      end

*******************************************************************************

      double complex function H0mrmr(x) 

      implicit none
      double complex x, z, zx
      double complex xspenz, xli3
      double precision zeta3
      
      z = zx(x)
      zeta3 =  1.202056903159594285399738161511449990765d0

      H0mrmr = - 1d0/6d0*log(z)**3 + log(1d0-z)*log(z)**2
     &         + 2d0*Log(z)*xspenz(z) - 2d0*xli3(z) 
     &         + 2d0*zeta3

      end

*******************************************************************************

      double complex function Hmrm1(x)

      implicit none
      double complex x, z, zx
      double complex xspenz
      double complex la
      double precision pi   
      
      pi = 3.141592653589793238462643383279502884197d0
      
      z = zx(x)
      la = exp(dcmplx(0d0,pi/3d0))
      
      Hmrm1 = xspenz(z*la) + xspenz(z/la) + 1d0/2d0*log(z)**2
     &      - xspenz(la) - xspenz(1d0/la)  
      
      end

*******************************************************************************

      double complex function Hmrmrm1(x)

      implicit none
      double complex x, z, zx
      double complex xspenz, xli3
      double complex la
      double precision pi   
      
      pi = 3.141592653589793238462643383279502884197d0
 
      z = zx(x)
      la = exp(dcmplx(0d0,pi/3d0))

      Hmrmrm1 = - xli3(z*la) - xli3(z/la) - 1d0/6d0*log(z)**3
     &          + log(z)*(xspenz(la) + xspenz(1d0/la)) + xli3(la) 
     &          + xli3(1d0/la)

      end

*******************************************************************************

      double complex function Hm4mrm1(x)

      implicit none
      double complex x, z, zx
      double complex xspenz, xli3
      double complex la
      double precision pi   
      
      pi = 3.141592653589793238462643383279502884197d0
 
      z = zx(x)
      la = exp(dcmplx(0d0,pi/3d0))

      Hm4mrm1 = -2.834251639572615d0+log(1.d0+la)*log((la-1.d0*z)/la)**2
     & -0.16666666666666666d0*log(z)**3-2.d0*log(1.d0+la)*log((la-1.d0*z
     & )/la)*log(1.d0+z)-2.d0*log((la-1.d0*z)/la)**2*log(1.d0+z)+log(z)*
     & *2*log(1.d0+z)+log(1.d0+la)*log(1.d0+z)**2+log((1.d0+la)/la)*log(
     & 1.d0+z)**2+3.d0*log((la-1.d0*z)/la)*log(1.d0+z)**2-3.333333333333
     & 3335d0*log(1.d0+z)**3-2.d0*log((1.d0+la)/la)*log(1.d0+z)*log(1.d0
     & -1.d0*la*z)+3.d0*log(1.d0+z)**2*log(1.d0-1.d0*la*z)+log((1.d0+la)
     & /la)*log(1.d0-1.d0*la*z)**2-2.d0*log(1.d0+z)*log(1.d0-1.d0*la*z)*
     & *2+2.d0*xli3(-1.d0*z)+xli3(z/la)+xli3(la*z)+2.d0*xli3((-1.d0*z)/(
     & la-1.d0*z))-2.d0*xli3((-1.d0*(1.d0+la)*z)/(la-1.d0*z))-2.d0*xli3(
     & (-1.d0*(la-1.d0*z))/(1.d0+z))+4.d0*xli3(z/(1.d0+z))-2.d0*xli3(((1
     & .d0+la)*z)/(1.d0+z))-2.d0*xli3(((1.d0+la)*z)/(la*(1.d0+z)))+2.d0*
     & xli3((la*z)/(-1.d0+la*z))-2.d0*xli3(((1.d0+la)*z)/(-1.d0+la*z))-2
     & .d0*xli3((-1.d0+la*z)/(la*(1.d0+z)))+log(z)*xspenz(1/la)-2.d0*log
     & (1.d0+z)*xspenz(1/la)+log(z)*xspenz(la)-2.d0*log(1.d0+z)*xspenz(l
     & a)+2.d0*log(z)*xspenz(-1.d0*z)-4.d0*log(1.d0+z)*xspenz(-1.d0*z)-2
     & .d0*log((la-1.d0*z)/la)*xspenz(z/la)+2.d0*log(1.d0+z)*xspenz(z/la
     & )+2.d0*log(1.d0+z)*xspenz(la*z)-2.d0*log(1.d0-1.d0*la*z)*xspenz(l
     & a*z)+2.d0*log((la-1.d0*z)/la)*xspenz((-1.d0*(la-1.d0*z))/(1.d0+z)
     & )-2.d0*log(1.d0+z)*xspenz((-1.d0*(la-1.d0*z))/(1.d0+z))-2.d0*log(
     & 1.d0+z)*xspenz(((1.d0+la)*z)/(1.d0+z))+2.d0*log(1.d0-1.d0*la*z)*x
     & spenz(((1.d0+la)*z)/(1.d0+z))+2.d0*log((la-1.d0*z)/la)*xspenz(((1
     & .d0+la)*z)/(la*(1.d0+z)))-2.d0*log(1.d0+z)*xspenz(((1.d0+la)*z)/(
     & la*(1.d0+z)))-2.d0*log(1.d0+z)*xspenz((-1.d0+la*z)/(la*(1.d0+z)))
     & +2.d0*log(1.d0-1.d0*la*z)*xspenz((-1.d0+la*z)/(la*(1.d0+z)))


      end

*******************************************************************************

      double complex function Hmr0m1(x)

      implicit none
      double complex x, z, zx
      double complex xspenz, xli3
      double complex la
      double precision pi   
      
      pi = 3.141592653589793238462643383279502884197d0
 
      z = zx(x)
      la = exp(dcmplx(0d0,pi/3d0))


      Hmr0m1 = 2.404113806319189d0-2.d0*log(la)**2*log((la-1.d0*z)/la)+l
     & og(la)*log((la-1.d0*z)/la)**2+2.d0*log(1.d0-1.d0*z)*log((la-1.d0*
     & z)/la)*log(z)-2.d0*log(1.d0-1.d0*z)*log(z)**2+0.3333333333333333d
     & 0*log(z)**3-2.d0*log(la)**2*log(1.d0-1.d0*la*z)+2.d0*log(1.d0-1.d
     & 0*z)*log(z)*log(1.d0-1.d0*la*z)-1.d0*log(la)*log(1.d0-1.d0*la*z)*
     & *2-2.d0*xli3((la-1.d0*z)/(-1.d0+la))-1.d0*xli3(z/la)-1.d0*xli3(la
     & *z)-2.d0*xli3((-1.d0*z)/(la-1.d0*z))+2.d0*xli3(((-1.d0+la)*z)/(la
     & -1.d0*z))+2.d0*xli3(((-1.d0+la)*z)/(-1.d0+la*z))-2.d0*xli3((la*z)
     & /(-1.d0+la*z))-2.d0*xli3((-1.d0+la*z)/(-1.d0+la))+log(z)*xspenz(-
     & 1.d0*x)-2.d0*log(la)*xspenz((la-1.d0*z)/(-1.d0+la))+2.d0*log((la-
     & 1.d0*z)/la)*xspenz((la-1.d0*z)/(-1.d0+la))+log(z)*xspenz(z/la)+lo
     & g(z)*xspenz(la*z)+2.d0*log(la)*xspenz((-1.d0*z)/(la-1.d0*z))-2.d0
     & *log((la-1.d0*z)/la)*xspenz((-1.d0*z)/(la-1.d0*z))+2.d0*log(z)*xs
     & penz((-1.d0*z)/(la-1.d0*z))-2.d0*log(la)*xspenz(((-1.d0+la)*z)/(l
     & a-1.d0*z))+2.d0*log((la-1.d0*z)/la)*xspenz(((-1.d0+la)*z)/(la-1.d
     & 0*z))-2.d0*log(z)*xspenz(((-1.d0+la)*z)/(la-1.d0*z))+2.d0*log(la)
     & *xspenz(((-1.d0+la)*z)/(-1.d0+la*z))-2.d0*log(z)*xspenz(((-1.d0+l
     & a)*z)/(-1.d0+la*z))+2.d0*log(1.d0-1.d0*la*z)*xspenz(((-1.d0+la)*z
     & )/(-1.d0+la*z))-2.d0*log(la)*xspenz((la*z)/(-1.d0+la*z))+2.d0*log
     & (z)*xspenz((la*z)/(-1.d0+la*z))-2.d0*log(1.d0-1.d0*la*z)*xspenz((
     & la*z)/(-1.d0+la*z))+2.d0*log(la)*xspenz((-1.d0+la*z)/(-1.d0+la))+
     & 2.d0*log(1.d0-1.d0*la*z)*xspenz((-1.d0+la*z)/(-1.d0+la))


      end

*******************************************************************************
