      subroutine matrixelem(ndim,vars,order,maxwlo,minwlo,Nmax,xorki)
      implicit none
      INTEGER ndim,order,maxwlo,minwlo,Nmax
      double precision vars(ndim)
      double precision xorki(3*Nmax)

      character*60 collider, pdfset
      double precision sect1,sect2,sect3,sect4
      double precision sect5,sect6,sect7
      double precision x1, x2, tau, x, z, ris, tmp0, tmp1, tmp2, tmp

      double precision L, Lt, Lr, alphas, NF, meas
      double precision Rplus, Rdelta, Rreg
      
      double precision Lug(Nmax),Luub(Nmax),Ldg(Nmax),Lddb(Nmax)
      double precision Lgg(Nmax),Lqg(Nmax),Lqqb(Nmax),Lqq(Nmax)
      double precision Lq1q2(Nmax)
      double precision Lugo(Nmax),Luubo(Nmax),Ldgo(Nmax),Lddbo(Nmax)
      double precision Lggo(Nmax),Lqgo(Nmax),Lqqbo(Nmax),Lqqo(Nmax)
      double precision Lq1q2o(Nmax)

      double precision ggdelta, ggplus, ggreg 
      double precision qgreg, qqbreg, qqreg
      double precision q1q2reg
      common /hggtot_xsection/ L, Lt, Lr, alphas, NF 

      integer wlo,jj,isetval,counter
C      COMMON /kinem/ tau

C      COMMON /lumiB/ collider, pdfset, muf

C      external lumif

      include 'constants.f'
      include 'masses.f'

C      if (Nmax.gt.1) then
C         write(6,*)'matrixelem'
C      endif


      counter=0
      NF=5d0
      L=dlog(muf**2/m2)
      Lr=dlog(mur**2/m2)
      Lt=dlog(m2/mt**2)
      if (order.eq.0) alphas=asLO
      if (order.eq.1) alphas=asNLO
      if (order.eq.2) alphas=asNNLO
      tau=m2/scm

      Rplus=1d0
      Rdelta =1d0
      Rreg=1d0

C      alphas=4.23024265254434498d-02
C      write(6,*)'matrixelem: '
C      write(6,*)L,Lr,Lt
C      write(6,*)alphas
CCC--------------------------------------------------------------
      do jj=1,Nmax
         

         isetval=jj-1
         
C-------PARTONIC LUMINOSITIES -----------------
         x=vars(1)
         z = 1d0
         meas =1/x
         x1 = x
         x2 = tau/x1/z

C         write(6,*)'lumif - o',x1,x2,z,tau
C         write(6,*)'muf= ',muf,order
         call lumif(order,isetval,x1,x2,0d0,
     $        Lq1q2o(jj),Lqqo(jj),Luubo(jj),Lddbo(jj),Lggo(jj),
     $        Lugo(jj),Ldgo(jj))

         Lqqbo(jj)=Luubo(jj)+Lddbo(jj)
         Lqgo(jj)=Lugo(jj)+Ldgo(jj)
        
C         write(6,*)Lggo(jj),Lqgo(jj),Lqqbo(jj)
C         write(6,*)Lqqo(jj),Lq1q2o(jj)

         
C     Lq1q2o=1d0
C     Lqqo=1d0
C     Lqqbo=1d0
C     Lggo=1d0
C     Lqgo=1d0

C     call lumif(collider,x1,x2,muf,pdfset, isetval, Lggo,Lqgo,
C     &        Lqqbo,Lqqo,Lq1q2o)

C     write(6,*)Lq1q2o,Lqqo,Lqqbo,Lggo,Lqgo
         
         x=vars(1)
         z = vars(2)
         meas =1/x
         x1 = x
         x2 = tau/x1/z

C         write(6,*)'lumif',x1,x2,z,tau    
C         write(6,*)'lumif',x1,x2,z,tau
C         write(6,*)'muf= ',muf,order
         call lumif(order,isetval,x1,x2,0d0,
     $        Lq1q2(jj),Lqq(jj),Luub(jj),Lddb(jj),Lgg(jj),
     $        Lug(jj),Ldg(jj))

         Lqqb(jj)=Luub(jj)+Lddb(jj)
         Lqg(jj)=Lug(jj)+Ldg(jj)

C         write(6,*)Lgg(jj),Lqg(jj),Lqqb(jj)
C         write(6,*)Lqq(jj),Lq1q2(jj)
C     Lq1q2=1d0
C     Lqq=1d0
C     Lqqb=1d0
C     Lgg=1d0
C     Lqg=1d0

      enddo
C     call lumif(collider,x1,x2,muf,pdfset, isetval, Lgg,Lqg,
C     &        Lqqb,Lqq,Lq1q2)
         
C     write(6,*)Lq1q2,Lqq,Lqqb,Lgg,Lqg
         
C-------------------------------------------------------------
         




 
      counter=0
      do wlo=maxwlo,minwlo,-1
C---- Evaluate  functions in the two kinematic points ------ 
         x=vars(1)
         z = 1d0
         meas =1/x
         x1 = x
         x2 = tau/x1/z
         
         sect1 = ggdelta(z, wlo)


         x=vars(1)
         z = vars(2)
         meas =1/x
         x1 = x
         x2 = tau/x1/z
         
         sect2 = ggplus(z,wlo)


         sect3 = qgreg(z,wlo)
         sect4 = qqbreg(z,wlo)
         sect5 = qqreg(z,wlo)
         sect6 = q1q2reg(z,wlo)
         sect7 = ggreg(z,wlo)
c$$$
c$$$         write(6,*)'sect1= ',sect1
c$$$         write(6,*)'sect2= ',sect2
c$$$         write(6,*)'sect3= ',sect3
c$$$         write(6,*)'sect4= ',sect4
c$$$         write(6,*)'sect5= ',sect5
c$$$         write(6,*)'sect6= ',sect6
c$$$         write(6,*)'sect7= ',sect7


         do jj=1,Nmax
            ris=0d0
            counter=counter+1

C     -------- DELTA FUNCTION TERMS -------------
            x=vars(1)
            z = 1d0
            
            meas =1/x
            x1 = x
            x2 = tau/x1/z
         
            tmp = Lggo(jj)*meas*sect1
            tmp = Rdelta*tmp
            ris = ris +tmp
         
C            write(6,*)ris
C     -------- PLUS FUNCTION TERMS --------------
         
            tmp1 = Lggo(jj)*meas
         
            x=vars(1)
            z = vars(2)
         
            meas =1/x
            x1 = x
            x2 = tau/x1/z
            tmp2 = Lgg(jj)*meas
         
            tmp = (tmp2-tmp1)/(1d0-z)
         
            tmp = tmp*sect2
         
            tmp =Rplus*tmp
            ris = ris + tmp
C            write(6,*)ris
         
C     ----------- REGULAR TERMS -----------------
         
         
            x=vars(1)
            z = vars(2)
            meas =1/x
            x1 = x
            x2 = tau/x1/z

            tmp=0d0
            tmp = tmp+Lqg(jj)*sect3
            tmp = tmp+Lqqb(jj)*sect4
            tmp = tmp+Lqq(jj)*sect5
            tmp = tmp+Lq1q2(jj)*sect6
            tmp = tmp+Lgg(jj)*sect7

            tmp = tmp*meas
            tmp =Rreg*tmp
            ris =ris+tmp
C            write(6,*)wlo,counter,jj,ris
C            write(6,*)counter,wlo,jj,Lggo(jj),Lgg(jj)
            xorki(counter)=ris
         enddo
      enddo
C      stop
      return
      end


      double precision function ggreg(x,wlo)
      implicit none 
      double precision x, xggrN, xggrNN
      double precision tmp
      integer wlo
      if (wlo.EQ.0) then 
         tmp=0d0
      elseif (wlo.EQ.1) then 
         tmp = 1d0*xggrN(x)
      elseif (wlo.EQ.2) then 
         tmp = 1d0*xggrNN(x)
      endif
         
      ggreg = tmp     
      end






      double precision function qgreg(x,wlo)
      implicit none 
      double precision x, xqgN, xqgNN
      double precision tmp
      integer wlo
      
      if (wlo.EQ.0) then 
         tmp=0d0
      elseif (wlo.EQ.1) then 
         tmp = 1d0*xqgN(x)
      elseif (wlo.EQ.2) then 
         tmp = 1d0*xqgNN(x)
      endif
         
      qgreg = tmp     
      end




      double precision function qqbreg(x,wlo)
      implicit none 
      double precision x, xqqbN, xqqbNN
      double precision tmp
      integer wlo
      
      if (wlo.EQ.0) then 
         tmp=0d0
      elseif (wlo.EQ.1) then 
         tmp = 1d0*xqqbN(x)
      elseif (wlo.EQ.2) then 
         tmp = 1d0*xqqbNN(x)
      endif
         qqbreg = tmp     
      end




      double precision function qqreg(x,wlo)
      implicit none 
      double precision x, xqqNN
      double precision tmp
      integer wlo
      
      if (wlo.EQ.0) then 
         tmp=0d0
      elseif (wlo.EQ.1) then 
         tmp = 0d0
      elseif (wlo.EQ.2) then 
         tmp = xqqNN(x)*1d0
      endif
         qqreg = tmp     
      end




      double precision function q1q2reg(x,wlo)
      implicit none 
      double precision x, xqqprime
      double precision tmp
      integer wlo

      
      if (wlo.EQ.0) then 
         tmp=0d0
      elseif (wlo.EQ.1) then 
         tmp = 0d0
      elseif (wlo.EQ.2) then 
         tmp = xqqprime(x)*1d0
      endif
         q1q2reg = tmp     
      end



      double precision function ggdelta(z,wlo)
      implicit none 
      double precision tmp
      double precision z, tmp1, tmp2, tmp3, z4
      double precision L, Lt, Lr, alphas, NF, pi, z2, z3
      integer wlo


      common /hggtot_xsection/ L, Lt, Lr, alphas, NF 
C      common /consts/ pi, z2, z3
      parameter(pi=3.1415926535897D0)
      parameter(z2=1.6449340668481287d0)
      parameter(z3=1.2020569031595942854D0)
      parameter(z4=1.082323234d0)

      tmp1 = 1d0 
      tmp2 = (-23.D0/6.D0*L+23.D0/6.D0*Lr+6*z2+11.D0/2.D0)
      tmp3 =
     # ((529.D0/48.D0-18*z2)*L**2+(-23*z2-317.D0/12.D0-171.D0/2.D0*z
     #3)*L-529.D0/24.D0*Lr*L+137.D0/24.D0*Lt+349.D0/6.D0*z2-445.D0/12.D0
     #*z3+303.D0/8.D0-54*z2**2+1071.D0/8.D0*z4+529.D0/48.D0*Lr**2+(69.D0
     #/2.D0*z2+875.D0/24.D0)*Lr)
 

      if (wlo.EQ.0) then 
         tmp=tmp1
      elseif (wlo.EQ.1) then 
         tmp = tmp1*1d0+alphas*tmp2*1d0
      elseif (wlo.EQ.2) then 
         tmp = tmp1*1d0+alphas*tmp2*1d0+alphas**2*tmp3*1d0
      endif
      
      ggdelta = tmp

      end


      double precision function ggplus(z,wlo)
      implicit none 
      double precision z,x, LLz, DD0, DD1, DD2, DD3, taux
      double precision L, Lt, Lr, alphas, NF, tmp
      double precision tmp1, tmp2, tmp3, z4, pi, z2, z3

      integer wlo

      common /hggtot_xsection/ L, Lt, Lr, alphas, NF 
      parameter(pi=3.1415926535897D0)
      parameter(z2=1.6449340668481287d0)
      parameter(z3=1.2020569031595942854D0)
      parameter(z4=1.082323234d0)

      x=z

      LLz = dlog(1d0-z)

      DD0=1d0
      DD1=LLz
      DD2=LLz**2
      DD3=LLz**3

      tmp1=0d0      
      tmp2 = -6*L*DD0+12*DD1

      taux =115.D0/4.D0*L**2+(-349.D0/6.D0+45*z2)*L-69.D0/2.D0*Lr*L
     &     +23*z2-233.D0/9.D0+351.D0/2.D0*z3
      tmp3 =taux*DD0 
     &     +(349.D0/3.D0-90*z2+69*Lr-46*L+36*L**2)*DD1
     &     +(-23-108*L)*DD2 
     &     +72*DD3


      if (wlo.EQ.0) then 
         tmp=tmp1
      elseif (wlo.EQ.1) then 
         tmp = tmp1+alphas*tmp2*1d0
      elseif (wlo.EQ.2) then 
         tmp = tmp1+alphas*tmp2*1d0+alphas**2*tmp3*1d0
      endif

      
      ggplus = tmp
      end
