CCC   meborn.f
CCC   fermionic leading order matrix elements

C =============================
      subroutine mebornsp(x,hpl0r,hpl0i,mer,mei)
      implicit none
      double precision x
      double precision mer,mei
      double precision tmp1,tmp2
      double precision hpl0r,hpl0i
      double precision PI
      parameter (PI=3.14159265358979323846264d0)
      tmp1 = (-1.d0+x)**2
      tmp2 = (1.d0+x)**2
      mer = x*hpl0r**2 - x*(hpl0i*PI)**2
      mer = 2.d0*(tmp2*mer - 4.d0*x*tmp1)
      mer = mer/tmp1**2
      mei = 4.d0*(hpl0i*PI)*hpl0r*tmp2*x
      mei = mei/tmp1**2
      return
      end

C =============================

      subroutine mebornac(th,mer,mei)
      implicit none
      double precision th,mer,mei
      double precision t1,t4,t5,t6,t7,t8,t10,t11
      t1 = th**2
      t4 = th/2
      t5 = dsin(t4)
      t6 = t5**2
      t7 = t6**2
      t8 = 1/t7
      t10 = dcos(t4)
      t11 = t10**2
      mer = (-16-4*t1)*t8*t11/8+2*t8
      mei = 0d0
      return
      end

C =============================
      subroutine mederbornsp(x,hpl0r,hpl0i,mer,mei)
      implicit none
      doubleprecision x
      doubleprecision mer
      doubleprecision mei
      double precision hpl0r,hpl0i

      doubleprecision t10
      doubleprecision t11
      doubleprecision t12
      doubleprecision t17
      doubleprecision t19
      doubleprecision t23
      doubleprecision t26
      doubleprecision t33
      doubleprecision t5
      doubleprecision t6
      doubleprecision t8
      doubleprecision t9
      double precision PI
      parameter (PI=3.14159265358979323846264d0)

        t5 = x**2
        t6 = 1+6*x+t5
        t8 = -1+x
        t9 = t8**2
        t10 = t9**2
        t11 = 1/t10
        t12 = hpl0r**2
        t17 = 1/t9/t8
        t19 = 1+x
        t23 = PI**2
        t26 = hpl0i**2
        mer = 4*x*t6*t11*t12-8*x*t17*t19*hpl0r-4*t23*x*t6*t11*t26-16*x/t
     #9
        t33 = x*PI
        mei = 8*t33*t6*t11*hpl0i*hpl0r-8*t33*t19*t17*hpl0i
        return
      end



C =============================
      subroutine mederbornac(th,mer,mei)
      implicit none
      double precision th,mer,mei
      double precision t1,t2,t3
      t1=dsin(th/2.d0)
      t2=dcos(th/2d0)
      t3=th**2
      mer=4d0-t3-(4d0+t3)*t2**2+2d0*t1*t2*th
      mer=mer/t1**4
      mei=0.d0
      return
      end

C =============================
