CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   meggppm.f

      double complex function meggppm(s12,s13,s23,mh,m,bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      double complex ttrian(1:4)
      double complex bboxx(1:3)
      double complex ttriana(1:3)

      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)

      doublecomplex t10
      doublecomplex t13
      doublecomplex t18
      doublecomplex t25
      doublecomplex t32
      doublecomplex t5
      doublecomplex t6
      doublecomplex t8

      doublecomplex meggppmLim
      external meggppmLim

      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)
      ttrian(one)=r12*trian(one)
      ttrian(two)=r13*trian(two)
      ttrian(three)=r23*trian(three)
      ttrian(four)=tmh2*trian(four)
      ttriana(one)=(ttrian(four)-ttrian(one))
      ttriana(two)=(ttrian(four)-ttrian(two))
      ttriana(three)=(ttrian(four)-ttrian(three))
      bboxx(one)=r12*r13*boxx(one)
      bboxx(two)=r12*r23*boxx(two)
      bboxx(three)=r23*r13*boxx(three)
      

      pf=-4d0*tm2/zsqrt(r12*r13*r23)*dcmplx(0d0,1d0)


      if ((dabs(s13)/s12.lt.10d-6).or.(dabs(s23)/s12.lt.10d-6)) then
         meggppm=meggppmLim(s12,s13,s23,mh,m,bub,trian,boxx)
       else
         t5 = 2*tm2-r23/2-r13/2-r12/2
         t6 = bboxx(one)
         t8 = bboxx(two)
         t10 = bboxx(three)
         t13 = 4*tm2-r23-r13-r12
         t18 = ttriana(one)
         t25 = ttriana(two)
         t32 = ttriana(three)
         meggppm = t5*t6+t5*t8+t5*t10+t13*(r23+r13)/(tmh2-r12)*t18+t13*(
     $r23+r12)/(tmh2-r13)*t25+t13*(r13+r12)/(tmh2-r23)*t32+4*r12+4*r23+4
     $*r13
         meggppm = pf*meggppm
      endif
      
      return
      end

      double complex function meggppmLim(s12,s13,s23,mh,m,
     $     bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      double complex ttrian(1:4)
      double complex bboxx(1:3)
      double complex ttriana(1:3)

      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)


      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)

      meggppmLim=-2d0*tm2**2*(2d0/tmh2
     $     +(4d0*tm2/tmh2-1d0)*trian(four))
C      meggpppLim=-2d0/3d0*tm2
      meggppmLim=meggppmLim*dcmplx(0d0,1d0)/tm2*tmh2**2*4d0
      meggppmLim=meggppmLim/sqrt(abs(s12*s13*s23))


      return
      end

