CCC   smeborn.f
CCC   scalar leading order matrix elements gg->h

      subroutine smebornsp(x,hpl0r,hpl0i,mer,mei)
      implicit none
      real*8 x
      double precision mer,mei
      double precision tmp1,tmp2
      double precision hpl0r,hpl0i
      double precision PI
      parameter (PI=3.14159265358979323846264d0)
      tmp1=(1d0-x)
      tmp2=tmp1**4
      mer=2d0*x*(tmp1**2+x*((PI*hpl0i)**2-hpl0r**2))/tmp2
      mei=-4d0*x**2*hpl0r*hpl0i*PI/tmp2
      return
      end

C =============================
      subroutine smebornac(th,mer,mei)
      implicit none
      double precision th,mer,mei
      double precision tmp1
      tmp1=dsin(th/2.d0)**4
      mer=(-2d0+th**2+2d0*dcos(th))/8d0/tmp1
      mei=0d0
      return
      end

C =============================
      subroutine smederbornsp(x,hpl0r,hpl0i,mer,mei)
      implicit none
      doubleprecision x
      doubleprecision mer
      doubleprecision mei
      double precision hpl0r,hpl0i

      double precision t1
      double precision t2
      double precision t3
      double precision t4
      double precision t6
      double precision t7
      double precision t10
      double precision t11
      double precision PI
      parameter (PI=3.14159265358979323846264d0)

      t1 = x**2
      t2 = -1+x
      t3 = t2**2
      t4 = t3**2
      t6 = 1/t4*t1
      t7 = hpl0r**2
      t10 = PI**2
      t11 = hpl0i**2
      mer = -(8*t7*t6-8*t11*t10*t6-8*hpl0r*t1/t3/t2/(1+x)-4/t3*x)
      mei = -(16*hpl0r*PI*hpl0i/t4*t1-8*hpl0i*PI*t1/t3/t2/(1+x))

      return
      end

C =============================
      subroutine smederbornac(th,mer,mei)
      implicit none
      double precision th,mer,mei
      
      double precision t1
      double precision t2 
      double precision t3 
      double precision t6 
      double precision t10 
      double precision t14 
      double precision t15

      t1 = th/2
      t2 = dcos(t1)
      t3 = th**2
      t6 = dsin(t1)
      t10 = t2**2
      t14 = t6**2
      t15 = t14**2
      mer = 1/t2/t15*(4*t3*t2-4*th*t6-8*t2+8*t10*t2)/8
      mei = 0d0
      return
      end
C =============================
