CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   smeggppm.f

      double complex function smeggppm(s12,s13,s23,mh,m,bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      double complex ttrian(1:4)
      double complex bboxx(1:3)
      double complex ttriana(1:3)

      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)

      doublecomplex t1
      doublecomplex t14
      doublecomplex t21
      doublecomplex t28
      doublecomplex t4
      doublecomplex t7



      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)
      ttrian(one)=r12*trian(one)
      ttrian(two)=r13*trian(two)
      ttrian(three)=r23*trian(three)
      ttrian(four)=tmh2*trian(four)
      ttriana(one)=(ttrian(four)-ttrian(one))
      ttriana(two)=(ttrian(four)-ttrian(two))
      ttriana(three)=(ttrian(four)-ttrian(three))
      bboxx(one)=r12*r13*boxx(one)
      bboxx(two)=r12*r23*boxx(two)
      bboxx(three)=r23*r13*boxx(three)
      

      pf=-4d0*tm2/zsqrt(r12*r13*r23)*dcmplx(0d0,1d0)
      
        t1 = bboxx(one)
        t4 = bboxx(two)
        t7 = bboxx(three)
        t14 = ttriana(one)
        t21 = ttriana(two)
        t28 = ttriana(three)
        tmp = -tm2*t1/2-tm2*t4/2-tm2*t7/2-tm2*(r23+r13)/(tmh2-r12)*t
     #14-tm2*(r23+r12)/(tmh2-r13)*t21-tm2*(r13+r12)/(tmh2-r23)*t28-r12-r
     #23-r13

        smeggppm = pf*tmp

c$$$        write(6,*)'## smeggppm: ',s12,s13,s23,mh,m
c$$$        write(6,*)'##           ',smeggppm

      return
      end




      double complex function smeggppmo(s12,s13,s23,mh,m,bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s13
      doubleprecision s23
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)

      doublecomplex t11
      doublecomplex t16
      doublecomplex t2
      doublecomplex t22
      doublecomplex t27
      doublecomplex t3
      doublecomplex t32
      doublecomplex t4
      doublecomplex t5
      doublecomplex t6

      double complex r12,r13,r23,tm2,tmh2,pf,tmp

      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)
      triana(1)=1d0/(tmh2-r12)*(tmh2*trian(4)-r12*trian(1))
      triana(2)=1d0/(tmh2-r13)*(tmh2*trian(4)-r13*trian(2))
      triana(3)=1d0/(tmh2-r23)*(tmh2*trian(4)-r23*trian(3))
      pf=4d0*tm2*tmh2/zsqrt(r12*r13*r23)*dcmplx(0d0,1d0)

        t2 = tm2
        t3 = tmh2
        t4 = 1/t3
        t5 = t4*t2
        t6 = boxx(2)
        t11 = boxx(1)
        t16 = boxx(3)
        t22 = triana(2)
        t27 = triana(3)
        t32 = triana(1)
        tmp = t6*t5*r12*r23/2+t11*t5*r13*r12/2+t16*t5*r23*r13/2+t22
     #       *t4*(r23+r12)*t2+t27*t4*(r13+r12)*t2+1+t32*t4*t2*(r23+r13)
        smeggppmo = pf*tmp
        return
      end

