CCC   hpl.h
CCC   definitions for hpl etc.

CCC
      double precision PI
      parameter (PI=3.14159265358979323846264d0)

      double precision rho,theta,tmp
      double precision root1,root2

CCC   definitions for hplog
      integer n1,n2,nw
      parameter (n1=-1) 
      parameter (n2=1) 
      parameter (nw=4)
      complex*16 Hc1,Hc2,Hc3,Hc4 
      real*8     Hr1,Hr2,Hr3,Hr4 
      real*8     Hi1,Hi2,Hi3,Hi4
      real*8 x
      dimension Hc1(n1:n2),Hc2(n1:n2,n1:n2),Hc3(n1:n2,n1:n2,n1:n2),
     $          Hc4(n1:n2,n1:n2,n1:n2,n1:n2)
      dimension Hr1(n1:n2),Hr2(n1:n2,n1:n2),Hr3(n1:n2,n1:n2,n1:n2), 
     $          Hr4(n1:n2,n1:n2,n1:n2,n1:n2) 
      dimension Hi1(n1:n2),Hi2(n1:n2,n1:n2),Hi3(n1:n2,n1:n2,n1:n2), 
     $          Hi4(n1:n2,n1:n2,n1:n2,n1:n2) 

CCC   definitions for lsjk
      double precision acl1,acl2,als1,als2,als3,alsc1,alsc2,alsc3
      double precision alslsc1,alslsc2,alslsc3
      dimension als1(2:4,0:2),als2(2:4,0:2),als3(2:4,0:2)
      dimension alsc1(2:3,2:3),alsc2(2:3,2:3),alsc3(2:3,2:3)

      integer j1,j2,j3,j4

CCC   Initialize Hr,Hi
      do j1=n1,n2
	Hr1(j1)=0d0
	Hi1(j1)=0d0
	Hc1(j1)=(0d0,0d0)
        do j2=n1,n2
	  Hr2(j1,j2)=0d0
	  Hi2(j1,j2)=0d0
	  Hc2(j1,j2)=(0d0,0d0)
          do j3=n1,n2
	    Hr3(j1,j2,j3)=0d0
	    Hi3(j1,j2,j3)=0d0
	    Hc3(j1,j2,j3)=(0d0,0d0)
            do j4=n1,n2
	      Hr4(j1,j2,j3,j4)=0d0
	      Hi4(j1,j2,j3,j4)=0d0
	      Hc4(j1,j2,j3,j4)=(0d0,0d0)
            enddo
	  enddo
        enddo
      enddo

CCC   Initialize acl etc.  
      acl1=0d0
      acl2=0d0
      alslsc1=0d0
      alslsc2=0d0
      alslsc3=0d0	     
      do j1=2,4	     
        do j2=0,2
	  als1(j1,j2)=0d0
	  als2(j1,j2)=0d0
	  als3(j1,j2)=0d0
        enddo
      enddo
      do j1=2,3	     
        do j2=2,3
	  alsc1(j1,j2)=0d0
	  alsc2(j1,j2)=0d0
	  alsc3(j1,j2)=0d0
        enddo
      enddo	 

