      subroutine InitPDFs(ttmpdir,mur,mZ)
      implicit none
      character*1000 ttmpdir
      double precision mur,mZ

      include 'pdfcontrol.f'
      include 'constants.f'

      character*1000 tmpdir
      common/tempdir/tmpdir

      CHARACTER prefix*1024
      character*60 pdfset
      character*20 suffix
      common/pdfset/pdfset,suffix

      double precision SSC

      DOUBLE PRECISION GetOnePDF08,xg,ALPHAS,
     &     distance,tolerance,mCharm,mBottom,alphaSQ0,alphaSMZ
      INTEGER alphaSorder,alphaSnfmax
      COMMON/mstwCommon/distance,tolerance,
     &     mCharm,mBottom,alphaSQ0,alphaSMZ,alphaSorder,alphaSnfmax

      external ALPHAS,INITALPHAS,GetOnePDF08


      tmpdir=ttmpdir

CCC  === CHANGE FOR NEW PDF'S ==========================
CCC  Value of alpha strong at the mass of the Z
CCC  These values should be consistent with the fits
CCC  of the pdf's. 

      if(whichpdf.lt.1.5d0) then
C  LO:
         asZlo   =  0.130D0 
         pdfsetLO='MRSTLO'
C  NLO:
         asZnlo  =  0.119D0
         pdfsetNLO='MRST2001'
C  NNLO:
         asZnnlo =  0.1155D0
         pdfsetNNLO='MRSTNNLO'

         if (fPDFerror.eq.1) then
            write(6,*)'MRST 2001: no Error sets 
     $           implemented'
            write(6,*)'   running without determination 
     $           of PDF errors'
         endif
         fPDFerrorLO=0
         NPDFerrorLO=0
         fPDFerrorNLO=0
         NPDFerrorNLO=0
         fPDFerrorNNLO=0
         NPDFerrorNNLO=0

      elseif (whichpdf.lt.2.5d0) then
C  LO:
         asZlo   =  0.130D0
         pdfsetLO='MRSTLO'
C  NLO:
         asZnlo  =  0.1205D0
         pdfsetNLO='MRST2004NLO'
C  NNLO:
         asZnnlo =  0.1167D0
         pdfsetNNLO='MRST2004NNLO'
 
         if (fPDFerror.eq.1) then
            write(6,*)'MRST 2004: no Error sets 
     $           implemented'
            write(6,*)'   running without determination 
     $           of PDF errors'
         endif
         fPDFerrorLO=0
         NPDFerrorLO=0
         fPDFerrorNLO=0
         NPDFerrorNLO=0
         fPDFerrorNNLO=0
         NPDFerrorNNLO=0

      elseif (whichpdf.lt.3.5d0) then
C  LO:
         asZlo   =  0.130D0
         pdfsetLO='MRSTLO'
C  NLO:
         asZnlo  =  0.1205D0
         pdfsetNLO='MRST2004NLO'
C  NNLO:
         asZnnlo =  0.1191D0
         pdfsetNNLO='MRST2006NNLO'


         if (fPDFerror.eq.1) then
            if (porder.lt.2) then
               write(6,*)'MRST 2004: no Error sets 
     $              implemented'
               write(6,*)'   running without determination 
     $              of PDF errors'
            elseif (porder.eq.2) then
               fPDFerrorNNLO=1
               NPDFerrorNNLO=30
            endif
         else
            fPDFerrorNNLO=0
            NPDFerrorNNLO=0
         endif

         fPDFerrorLO=0
         NPDFerrorLO=0
         fPDFerrorNLO=0
         NPDFerrorNLO=0

      else
c$$$C  LO:
c$$$         asZlo  =  0.13939D0
         pdfsetLO='MSTW2008LO'
c$$$C  NLO:
c$$$         asZnLO  =  0.12018D0
         pdfsetNLO='MSTW2008NLO'
c$$$C  NNLO:
c$$$         asZnnlo  =  0.11707D0
         pdfsetNNLO='MSTW2008NNLO'


         if (fPDFerror.eq.1) then
            fPDFerrorLO=1
            NPDFerrorLO=40
            fPDFerrorNLO=1
            NPDFerrorNLO=40
            fPDFerrorNNLO=1
            NPDFerrorNNLO=40
         else
            fPDFerrorLO=0
            NPDFerrorLO=0
            fPDFerrorNLO=0
            NPDFerrorNLO=0
            fPDFerrorNNLO=0
            NPDFerrorNNLO=0
         endif

      endif

  
      if (NPDFerror.gt.NSMax) then
         write(6,*)'NPDFerror > NSMax !!!'
         stop
      endif

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Initialize alpha_s

      if (whichpdf.lt.3.5d0) then
         modeas=0
         asLO=SSC(mur,modeas)
         modeas=1
         asNLO=SSC(mur,modeas)
         modeas=2
         asNNLO=SSC(mur,modeas)
      else
         suffix=""

C         if (porder.gt.0) then
C            if (whichas.eq.0) then
C               suffix=""
C            elseif (whichas.eq.1) then
CC               suffix="_asmz-68cl"
C               suffix="_asmz-90cl"
C            elseif (whichas.eq.2) then
CC               suffix="_asmz-68clhalf"
C               suffix="_asmz-90clhalf"
C            elseif (whichas.eq.3) then
CC               suffix="_asmz+68clhalf"
C               suffix="_asmz+90clhalf"
C            elseif (whichas.eq.4) then
CC               suffix="_asmz+68cl"
C               suffix="_asmz+90cl"
C            endif
C         endif
C---------- *** the meaning of whichas is changed! 
C----------
C---------- whichas: 0  -> central grid
C---------- whichas: 1  -> -90% CF grid
C---------- whichas: 2  -> +90% CF grid
C---------- whichas: 3  -> -68% CF grid
C---------- whichas: 4  -> +68% CF grid
C---------- 
C---------- NB: no grids at half the interval used
C----------     in line with the MSTW paper observation that 
C----------     the envelope error is always found by the extreme grids



         if (porder.gt.0) then
            if (whichas.eq.0) then
               suffix=""
            elseif (whichas.eq.1) then
C               suffix="_asmz-68cl"
               suffix="_asmz-90cl"
            elseif (whichas.eq.2) then
C               suffix="_asmz-68clhalf"
               suffix="_asmz+90cl"
            elseif (whichas.eq.3) then
C               suffix="_asmz+68clhalf"
               suffix=""
            elseif (whichas.eq.4) then
C               suffix="_asmz+68clhalf"
               suffix="_asmz-68cl"
            elseif (whichas.eq.5) then
C               suffix="_asmz+68cl"
               suffix="_asmz+68cl"
            endif
         endif
C--   Initialise alpha_S automatically using value stored in PDF grids.

CCC   as_LO
         write(6,*)'Initializing LO alphas'
C         write(6,*)tmpdir(1:len_trim(tmpdir))
         prefix = tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mstw2008lo"
C         prefix = prefix(1:len_trim(prefix))//suffix(1:len_trim(suffix))
         print*,'calling pdfs: ',prefix
         xg = GetOnePDF08(prefix,0,0.1D0,10.D0,0) ! dummy call to initialise
C         write(6,*)alphaSorder,alphaSQ0,mCharm,mBottom
         CALL INITALPHAS(alphaSorder,1.D0,1.D0,alphaSQ0,
     &        mCharm,mBottom,1.D10)
         asZlo=alphaSMZ
         asLO=ALPHAS(mur)/ppi
CCC   as_NLO
         write(6,*)'Initializing NLO alphas'
         prefix=tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mstw2008nlo"
         prefix = prefix(1:len_trim(prefix))//suffix(1:len_trim(suffix))
         print*,'calling pdfs: ',prefix
         xg = GetOnePDF08(prefix,0,0.1D0,10.D0,0) ! dummy call to initialise
C         write(6,*)alphaSorder,alphaSQ0,mCharm,mBottom
         CALL INITALPHAS(alphaSorder,1.D0,1.D0,alphaSQ0,
     &        mCharm,mBottom,1.D10)
         asZnlo=alphaSMZ
         asNLO=ALPHAS(mur)/ppi
CCC   as_NNLO
         write(6,*)'Initializing NNLO alphas'
         prefix=tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mstw2008nnlo"
         prefix = prefix(1:len_trim(prefix))//suffix(1:len_trim(suffix))
         print*,'calling pdfs: ',prefix
         xg = GetOnePDF08(prefix,0,0.1D0,10.D0,0) ! dummy call to initialise
C         write(6,*)alphaSorder,alphaSQ0,mCharm,mBottom
         CALL INITALPHAS(alphaSorder,1.D0,1.D0,alphaSQ0,
     &        mCharm,mBottom,1.D10)
         asZnnlo=alphaSMZ
         asNNLO=ALPHAS(mur)/ppi

      endif



      return
      end

