      double precision function constraint(var,qqq,ndim,zdim,z,x1,x2,
     &s13,s23,s14,s24,s34,s1v,s2v,s3v,s4v,Tcoeff,lums)

      implicit none


C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. W+/Z1  /  Z1
C        3. l+     /  l1+
C        4. nu     /  l1-  
C        5. W-/Z1  /  Z2
C        6. l-     /  l2-
C        7. nu_bar /  l2+
C        8. part1  /  part1
C        9. part2  /  part2
C        10. jet1  /  jet1
C        11. jet2  /  jet2

      double precision part(11,4)
C      COMMON/particles/part
C --------------------------------------------------
      
      double precision externalCuts

      double precision Tcoeff

      INTEGER ndim,pass
      INTEGER zdim,prodim
      double precision var(ndim)
      double precision qqq(zdim)

      COMMON/blockprodim/Gf, prodim

      include 'masses.f'
      double precision mH2,mW,mZ
      
      double precision z,x1,x2,s13,s23,s14,s24,s34,s1v,s2v,s3v,s4v
      double precision mV2, gamV
      double precision z1min, z1max, z2min, z2max, z1, z2
      double precision zhmin,zhmax
      double precision pi, Gf

CCC   prpbably not necessary

      double precision p1p2, q1p2, p1q2, q1q2
      
CCC   Higgs and parton stuff ...
      double precision pt3, pt4, pT
      double precision En3, En4, En
      double precision pz3, pz4, pZ
      double precision Y, eta3, eta4, eta34
      double precision etar, ptr

CCC   buffers and flags
      double precision ptbuf, topflag
      double precision Vflag, lepflag1, lepflag2 

CCC   parton angles ...
      double precision cosr, cos3, cos4, cos34
      double precision phi3, phi4, phi34, phir
      double precision totphi3, totphi4, totphir
      
CCC   integration variables ...
      double precision y1, y2, lam1, lam2, gam1, gam2, del1, del2

CCC   invariant scalars ...
      double precision C1h, C2h, B1w, B2w, D1w, D2w
      double precision a11l, a12l, a21l, a22l
      double precision b11l, b12l, b21l, b22l

CCC   masses and stuff...
      double precision sz, szv1, szv2, zv1, zv2
      double precision mv12, mv22
      double precision delmpp, delmmm, delmpm, delmmp
      double precision prodelm, squdelm
      double precision ampli

CCC   VB momenta
      double precision EnV1, EnV2
      double precision pzV1, pzV2
      double precision ptV1, ptV2
      double precision yV1, yV2

CCC   lepton momenta
      double precision Enl11, Enl12, Enl21, Enl22
      double precision pzl11, pzl12, pzl21, pzl22
      double precision ptl11, ptl12, ptl21, ptl22
      double precision etal11, etal12, etal21, etal22

CCC   VB angles
      double precision cosV1, cosV2, cosV1V2
      double precision phiV1, phiV2, phiV1V2
      double precision totphiV1, totphiV2
      double precision phi3V1, phi4V1, phirV1
      double precision phi3V2, phi4V2, phirV2

CCC   lepton angles
      double precision cosV1l11, cosV1l12, cosV2l21, cosV2l22
      double precision phiV1l11, phiV1l12, phiV2l21, phiV2l22
      double precision cosl11l12, cosl21l22
      double precision phil11l12, phil21l22
      double precision phi3l11, phi3l12, phi3l21, phi3l22
      double precision phi4l11, phi4l12, phi4l21, phi4l22
      double precision phirl11, phirl12, phirl21, phirl22
      double precision totphil11, totphil12, totphil21, totphil22
      double precision phi11, phi12, phi21, phi22

CCC   vertices control ...
      double precision l1,l2,r1,r2,cv1,ca1,cv2,ca2

CCC   decay amplitudes
      double precision q23,q24,q25,q34,q35,q45
      double precision jac
      double complex zampli
      double complex MWWlnln,MZZlnln,MWWZZlnln,MZZllll,MZZeemm
      external MWWlnln,MZZlnln,MWWZZlnln,MZZllll,MZZeemm

      
      double precision dilepmass, dileppt, dilepptot,R34
      double precision neutpt, Risol, Rar, Rbr, R3a, R3b,R4a,R4b
      double precision Ethada, Ethadb, pt34

      


CCC   variable buffers
      double precision varbuf
      integer counter, numJets

      double precision ptjet, ptjet2, etajet, etajet2, phi
      double precision phijet, cosphijet, totphijet
      double precision phijet2, cosphijet2, totphijet2
      double precision EnJet, EnJet2, pzJet, pzJet2



C     ------------------------------------------------------------------
C     CUT CONTROL
C     ------------------------------------------------------------------

      include 'cutcontrol.f'

      double precision JetDefConeSizeNew


C     ------------------------ KINEMATIC VARIABLES ------------------------
      double precision L11px, L11py, L12px, L12py, 
     .     L21px, L21py, L22px, L22py, J1px, J1py, J2px, J2py, 
     .     METpx, METpy, minAngle, tempAngle


C     ------------------------ PDF errors ------------------------
      integer NSMax
      parameter(NSMax=50)

      double precision lums(0:NSMax,0:2)


      !print*,"----------------------------------------------- in constraint.F"
      !  print*,"constraint.F :: ",part(3,1)
C ------------------ set particle adat top zero (fool-proof)
      counter=1
      do while(counter.lt.12)
         part(counter,1)=0d0
         part(counter,2)=0d0
         part(counter,3)=0d0
         part(counter,4)=0d0
         counter=counter+1
      enddo


C -------- clear Jet Variables

C     =======================   VAR BUFFERS   ===============================
    ! all random variables have minimum values equal to 10E-5
    ! is this  a way to avoid real zeros or negative vegas weights ? 
      varbuf = 0.00001d0
      counter=1

      if (ndecay.gt.0) then
         do while (counter.le.11)
            if(var(prodim+counter).lt.varbuf) 
     %           var(prodim+counter)=varbuf
            if(var(prodim+counter).gt.1.0d0-varbuf) 
     %           var(prodim+counter)=1.0d0-varbuf
            counter=counter+1         
         end do
      endif
      
C     ==================== split up axial/vectors ===========================
      cv1 = -0.5d0+2d0*(1d0-mW2/mZ2)
      cv2 = -0.5d0+2d0*(1d0-mW2/mZ2)
      ca1 = -0.5d0
      ca2 = -0.5d0
      l1=cv1-ca1
      l2=cv2-ca2
      r1=cv1+ca1
      r2=cv2+ca2
      pi = 3.1415926536d0
      mH2 = m2

C     ----------------------------
C     start accepting the 'event'
C     ----------------------------
      constraint=1d0
      
C     ----------------- Higgs and gluon momenta ----------------------

      pt3 = dsqrt(dabs(x1*x2*scm*s13*s23)) !gluon 1
      pt4 = dsqrt(dabs(x1*x2*scm*s14*s24)) !gluon 2  --> s13 = -2p1*p3/s_hat with s_hat=x1*x2*S !!

C      write(*,*) pt3, pt4

      pT  = dsqrt(dabs(x1*x2*scm*((s1v-z)*(s2v-z)-z))) ! Higgs
      
      En3 = - 0.5d0*dsqrt(scm)*(x2*s13+x1*s23)
      En4 = - 0.5d0*dsqrt(scm)*(x2*s14+x1*s24)
      En  = - 0.5d0*dsqrt(scm)*(x2*(s1v-z)+x1*(s2v-z))


      pz3 = 0.5d0*dsqrt(scm)*(x2*s13-x1*s23) 
      pz4 = 0.5d0*dsqrt(scm)*(x2*s14-x1*s24) 
      pZ  = 0.5d0*dsqrt(scm)*((s1v-z)*x2-(s2v-z)*x1)
      
      Y = 0.5*dlog((En+pZ)/(En-pZ))
      eta3 = 0.5d0*dlog((En3+pz3)/(En3-pz3))
      eta4 = 0.5d0*dlog((En4+pz4)/(En4-pz4))

C      write(*,*) En3,En4
C      write(*,*) pz3,pz4
C      write(*,*) eta3, eta4

C     --------- PARTICLES FILL -----------
      part(1,1)=En
      part(1,4)=pZ
      part(8,1)=En3
      part(8,4)=pz3
      part(9,1)=En4
      part(9,4)=pz4
C     ------------------------------------
C
C
C
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
C     ~~~~~~~~~~~~~~~~~~~~~  CUT SECTION  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     ***   CUT on higgs pT
      
      if((constraint.gt.0.5d0).and.(CutHiggsPt.gt.0.5d0)) then
         if((pT.lt.HiggsPtMin).or.(pT.gt.HiggsPtMax)) then
            constraint=0d0
            return
         endif
      endif

C     ***   CUT on Higgs rapidity
      if((constraint.gt.0.5d0).and.(CutHiggsEta.gt.0.5d0)) then
         if(dabs(Y).gt.HiggsEtaMax) then
            constraint=0d0
            return
         endif
         if(dabs(Y).lt.HiggsEtaMin) then
            constraint=0d0
            return
         endif
      endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  

      
C     --------------- CREATE GLUON CONFIGURATION ----------------

      ptbuf = 0.1d0
      
C     This flag denotes the multiplicity in the final state
C     topflag:
C     0d0 -> Higgs (pT=0) + 0 hard partons
C     1d0 -> Higgs (pT>0) + 1 hard parton
C     2d0 -> Higgs (pT>0) + 2 hard partons
C     3d0 -> Higgs (pT=0) + 2 balancing hard partons
      
C : : : : : : : : : : : : : : : : : : : : : : :  H + 0 hard partons     
      
      if(((pt3.lt.ptbuf).and.(pt4.lt.ptbuf)).or. 
     .     ((pT.lt.ptbuf).and.((pt3.lt.ptbuf).or.(pt4.lt.ptbuf)))) then
C     ----------------------------------------------------------------
C     topflag = 0d0
C     --> Higgs pT=0
C     --> VB's back-to-back
C     --> VB1 phi-reference candidate
C     ----------------------------------------------------------------         
         topflag=0d0
         pT=0d0
         numJets=0
         
C     ***************  NO JET-VETO ********************************

C     ***************  NO TEV-VETO ********************************


C : : : : : : : : : : : : : : : : : : : : : : :  H + 1 hard partons     
      else if ((pt3.gt.ptbuf).and.(pt4.lt.ptbuf)) then
C     ----------------------------------------------------------------
C     topflag = 1d0
C     --> Higgs-gluon3 back-to-back
C     --> Higgs is phi-reference
C     ----------------------------------------------------------------         
         topflag=1d0
         ptr=pt3
         etar=eta3
         phir=pi
         totphir=pi         

C     --------- PARTCILES FILL -----------
         part(1,2)=pT
         part(1,3)=0d0
         part(8,2)=-ptr
         part(8,3)=0d0
         part(9,2)=0d0
         part(9,3)=0d0
C     ------------------------------------
         
C     --------------------  JET DEFINITION -----------------------------
         !print*,"jet definition: ",pt3,JetDefPtMin,dabs(eta3),JetDefEtaMax
         if((pt3.gt.JetDefPtMin).and.(dabs(eta3).lt.JetDefEtaMax)) then
            ptjet=pt3
            EnJet=En3
            pzJet=pz3
            etajet=0.5d0*dlog((En3+pz3)/(En3-pz3))
            phijet=pi
            cosphijet=-1d0
            totphijet=pi
            numJets=1
         else
            numJets=0
         endif
C     -------------------------------------------------------------------
         
C     ~~~~~~~~~~~~~~~~~~~~~  JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          !print*,constraint,CutJetVeto,numJets,ptjet,  JetVetoPtMax,dabs(etajet),JetVetoEtaMax
          if((constraint.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
            if(numJets.gt.0) then
               if((ptjet.gt.JetVetoPtMax).and.
     .              (dabs(etajet).lt.JetVetoEtaMax)) then
                  constraint=0d0
                  !print*,"event rejected"
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraint.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
            if(numJets.gt.maxNumJets) then
               constraint=0d0
               return
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         
         
C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraint.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
            if(numJets.eq.1) then
               if(ptjet.gt.TevJetOnePtMax) then
                  constraint=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C : : : : : : : : : : : : : : : : : : : : : : :  H + 1 hard partons     

      else if ((pt3.lt.ptbuf).and.(pt4.gt.ptbuf)) then
C     ----------------------------------------------------------------
C     topflag = 1d0
C     --> Higgs-gluon4 back-to-back
C     --> Higgs is phi-reference
C     ----------------------------------------------------------------         
         topflag=1d0
         ptr=pt4
         etar=eta4
         phir=pi
         totphir=pi
         
C     --------- PARTICLES FILL -----------
         part(1,2)=pT
         part(1,3)=0d0
         part(9,2)=-ptr
         part(9,3)=0d0
         part(8,2)=0d0
         part(8,3)=0d0
C     ------------------------------------
         
C     --------------------  JET DEFINITION -----------------------------
         if((pt4.gt.JetDefPtMin).and.(dabs(eta4).lt.JetDefEtaMax)) then
            ptjet=pt4
            EnJet=En4
            pzJet=pz4            
            etajet=eta4
            phijet=pi
            cosphijet=-1d0
            totphijet=pi
            numJets=1
         else
            numJets=0
         endif
C     -------------------------------------------------------------------
         
C     ~~~~~~~~~~~~~~~~~~~~~~ JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraint.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
            if(numJets.gt.0) then
               if((ptjet.gt.JetVetoPtMax).and. 
     .              (dabs(etajet).lt.JetVetoEtaMax)) then
                  constraint=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraint.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
            if(numJets.gt.maxNumJets) then
               constraint=0d0
               return
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraint.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
            if(numJets.eq.1) then
               if(ptjet.gt.TevJetOnePtMax) then
                  constraint=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C : : : : : : : : : : : : : : : : : : : : : : :  H + 2 hard partons     

      else
         if (pT.gt.(0.1d0*ptbuf)) then
C     ----------------------------------------------------------------
C     topflag = 2d0
C     --> both gluons and Higgs are hard
C     --> Higgs is phi-reference
C     ----------------------------------------------------------------         
            
            topflag=2d0
            cos3=(En3*En-pz3*pZ-0.5d0*(s3v-z)*x1*x2*scm)/pt3/pT
            cos4=(En4*En-pz4*pZ-0.5d0*(s4v-z)*x1*x2*scm)/pt4/pT
            cos34=(En3*En4-pz3*pz4-0.5d0*s34*x1*x2*scm)/pt3/pt4            
            if (cos3.lt.(-1d0)) then
               cos3=-1d0
            else if (cos3.gt.1d0) then
               cos3=1d0
            endif
            if (cos4.lt.(-1d0)) then
               cos4=-1d0
            else if (cos4.gt.1d0) then
               cos4=1d0
            endif
            if (cos34.lt.(-1d0)) then
               cos34=-1d0
            else if (cos34.gt.1d0) then
               cos34=1d0
            endif            
            phi3=dacos(cos3)
            phi4=dacos(cos4)
            phi34=dacos(cos34)
            totphi3=phi3
            totphi4=2d0*pi-phi4            

C     --------- PARTICLES FILL -----------
            part(1,2)=pT
            part(1,3)=0d0
            part(8,2)=pt3*dcos(totphi3)
            part(8,3)=pt3*dsin(totphi3)
            part(9,2)=pt4*dcos(totphi4)
            part(9,3)=pt4*dsin(totphi4)
C     ------------------------------------

            
C            write(*,*) '  phi43 = ',phi34
            
C'''' technical comment: we choose gluon 3 to go 'up': mirror-configuration ('down') also allowed
C'''' ---> already taken care for in production !
            
C     ---------------  JET DEFINITION ------------------------------------
            R34 = dsqrt(phi34**2d0+(eta3-eta4)**2d0)            
            
C            write(*,*) '  R34 = ',R34

            if(UseSISCone.gt.0.5d0) then
               if(pt3.lt.pt4) then 
                  JetDefConeSizeNew=(1.0+pt3/pt4)*JetDefConeSize
               else
                  JetDefConeSizeNew=(1.0+pt4/pt3)*JetDefConeSize
               endif
            else
               JetDefConeSizeNew=JetDefConeSize
            endif
 
C            write(*,*) 'Cone Size =',JetDefConeSizeNew
           
            if(R34.lt.JetDefConeSizeNew) then
               ptjet=dsqrt(pt3**2+pt4**2+2d0*pt3*pt4*cos34)
C               write(*,*) '  ptjet = ',ptjet
               etajet=0.5d0*dlog((En3+En4+pz3+pz4)/(En3+En4-pz3-pz4))
               EnJet=En3+En4
               pzJet=pz3+pz4


C     -- compute totphi jet combined ------- using the var. Jipj temporary

               J1px=pt3*dcos(totphi3)
               J2px=pt4*dcos(totphi4)
               J1px=J1px+J2px
               
C               write(*,*) ' ************** '

C               write(*,*) pt3, pt4, totphi3, totphi4

C               write(*,*) J1px, J2px

               J1py=pt3*dsin(totphi3)
               J2py=pt4*dsin(totphi4)
               J1py=J1py+J2py

C               write(*,*) J1py, J2py
               
               J1px=J1px/ptjet
               if(J1px.lt.-1d0) J1px=-1d0
               if(J1px.gt.1d0) J1px=1d0

               totphijet=dacos(J1px)
               if(J1py.lt.0d0) totphijet=2d0*pi-totphijet

               if((ptjet.gt.JetDefPtMin).and.
     .              (dabs(etajet).lt.JetDefEtaMax)) then
                  numJets=1
               else
                  numJets=0
               endif
            else
               numJets=0
               if((pt3.gt.JetDefPtMin).and.
     .              (dabs(eta3).lt.JetDefEtaMax)) then
                  ptjet=pt3
                  EnJet=En3
                  pzJet=pz3
                  etajet=eta3
                  numJets=1
                  totphijet=totphi3
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     ptjet2=pt4
                     EnJet2=En4
                     pzJet2=pz4
                     etajet2=eta4
                     totphijet2=totphi4
                     numJets=2
                  endif
               else
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     EnJet=En4
                     pzJet=pz4
                     ptjet=pt4
                     etajet=eta4
                     totphijet=totphi4
                     numJets=1
                  endif
               endif
            endif

C            write(*,*) ' test = ',ptjet

C     --------------------------------------------------------------------
            
C     ~~~~~~~~~~~~~~~~~~~~~  JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraint.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
               if(numJets.gt.0) then
                  if((ptjet.gt.JetVetoPtMax).and.
     .                 (dabs(etajet).lt.JetVetoEtaMax)) then
                     constraint=0d0
                     return
                  endif
                  if(numJets.eq.2) then
                     if((ptjet2.gt.JetVetoPtMax).and.
     .                    (dabs(etajet2).lt.JetVetoEtaMax)) then
                        constraint=0d0
                        return
                     endif
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraint.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
            if(numJets.gt.maxNumJets) then
               constraint=0d0
               return
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraint.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
               if(numJets.eq.1) then
                  if(ptjet.gt.TevJetOnePtMax) then
                     constraint=0d0
                     return
                  endif
               else if(numJets.eq.2) then
                  if(((ptjet.gt.TevJetTwoPtMax).or.
     .                 (ptjet2.gt.TevJetTwoPtMax))) then
                     constraint=0d0
                     return
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C : : : : : : : : : : : : : : : : : : : : : : :  H + 2 hard partons // hard partons back to back     

         else ! if 
C     ----------------------------------------------------------------
C     topflag = 3d0
C     --> both gluons, no Higgs pT
C     --> gluons back-to-back
C     --> gluon 3 is phi-reference
C     ----------------------------------------------------------------   
            topflag=3d0
            phi34=pi
            totphi3=0d0
            totphi4=phi34            
            
C     --------- PARTICLES FILL -----------
            part(1,2)=0d0
            part(1,3)=0d0
            part(8,2)=pt3
            part(8,3)=0d0
            part(9,2)=-pt4
            part(9,3)=0d0
C     ------------------------------------

C     ---------------  JET DEFINITION (probably silly, but foolproof) ---
            R34 = dsqrt(phi34**2d0+(eta3-eta4)**2d0)            
            
            if(UseSISCone.gt.0.5d0) then
               if(pt3.lt.pt4) then 
                  JetDefConeSizeNew=(1.0+pt3/pt4)*JetDefConeSize
               else
                  JetDefConeSizeNew=(1.0+pt4/pt3)*JetDefConeSize
               endif
            else
               JetDefConeSizeNew=JetDefConeSize
            endif
            
            if(R34.lt.JetDefConeSizeNew) then
               ptjet=dsqrt(pt3**2+pt4**2+2d0*pt3*pt4*cos34)
               etajet=0.5d0*dlog((En3+En4+pz3+pz4)/(En3+En4-pz3-pz4))


C     -- compute totphi jet combined ------- using the var. Jipj temporary

               J1px=pt3*dcos(totphi3)
               J2px=pt4*dcos(totphi4)
               J1px=J1px+J2px
               
C               write(*,*) ' ************** '

C               write(*,*) pt3, pt4, totphi3, totphi4

C               write(*,*) J1px, J2px

               J1py=pt3*dsin(totphi3)
               J2py=pt4*dsin(totphi4)
               J1py=J1py+J2py

C               write(*,*) J1py, J2py
               
               J1px=J1px/ptjet
               if(J1px.lt.-1d0) J1px=-1d0
               if(J1px.gt.1d0) J1px=1d0

               totphijet=dacos(J1px)
               if(J1py.lt.0d0) totphijet=2d0*pi-totphijet

               if((ptjet.gt.JetDefPtMin).and.
     .              (dabs(etajet).lt.JetDefEtaMax)) then
                  numJets=1
               else
                  numJets=0
               endif
            else
               numJets=0
               if((pt3.gt.JetDefPtMin).and.
     .              (dabs(eta3).lt.JetDefEtaMax)) then
                  ptjet=pt3
                  etajet=eta3
                  totphijet=totphi3
                  numJets=1
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     ptjet2=pt4
                     etajet2=eta4
                     totphijet2=totphi4
                     numJets=2
                  endif
               else
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     ptjet=pt4
                     etajet=eta4
                     totphijet=totphi4
                     numJets=1
                  endif
               endif
            endif
C     --------------------------------------------------------------------
            
C     ~~~~~~~~~~~~~~~~~~~~~  JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraint.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
               if(numJets.gt.0) then
                  if((ptjet.gt.JetVetoPtMax).and.
     .                 (dabs(etajet).lt.JetVetoEtaMax)) then
                     constraint=0d0
                     return
                  endif
                  if(numJets.eq.2) then
                     if((ptjet2.gt.JetVetoPtMax).and.
     .                    (dabs(etajet2).lt.JetVetoEtaMax)) then
                        constraint=0d0
                        return
                     endif
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraint.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
               if(numJets.gt.maxNumJets) then
                  constraint=0d0
                  return
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraint.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
               if(numJets.eq.1) then
                  if(ptjet.gt.TevJetOnePtMax) then
                     constraint=0d0
                     return
                  endif
               else if(numJets.eq.2) then
                  if(((ptjet.gt.TevJetTwoPtMax).or.
     .                 (ptjet2.gt.TevJetTwoPtMax))) then
                     constraint=0d0
                     return
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
         endif
      endif


C     --------- PARTICLES FILL -----------
      if(numJets.eq.1) then
         part(10,1)=EnJet
         part(10,2)=ptjet*dcos(totphijet)
         part(10,3)=ptjet*dsin(totphijet)
         part(10,4)=pzJet
      endif

      if(numJets.eq.2) then
         if(ptjet.gt.ptjet2) then
            part(10,1)=EnJet
            part(10,2)=ptjet*dcos(totphijet)
            part(10,3)=ptjet*dsin(totphijet)
            part(10,4)=pzJet
            part(11,1)=EnJet2
            part(11,2)=ptjet2*dcos(totphijet2)
            part(11,3)=ptjet2*dsin(totphijet2)
            part(11,4)=pzJet2
         else
            part(11,1)=EnJet
            part(11,2)=ptjet*dcos(totphijet)
            part(11,3)=ptjet*dsin(totphijet)
            part(11,4)=pzJet
            part(10,1)=EnJet2
            part(10,2)=ptjet2*dcos(totphijet2)
            part(10,3)=ptjet2*dsin(totphijet2)
            part(10,4)=pzJet2
         endif
      endif
C     ------------------------------------

      
C     ------------------------------------------------------------------------
C     if there is no decay --> return
      if(ndecay.eq.0) then
C         write(6,*)'constraint: ',Tcoeff
      constraint=constraint*
     &     externalCuts(part,constraint*Tcoeff,lums)
         return
      endif
C     ------------------------------------------------------------------------
      
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x


C                                   DECAY BELOW

C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x
C x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x x

C     -------------------------------------------------------
C     decide wether Z or W decay ...
      if(ndecay.gt.2) then ! ZZ  (gamma gamma is in another file: constraintgg.F)
         gamV=gamZ
         mV2=mZ2
      else  ! WW or WW/ZZ
         gamV=gamW
         mV2=mW2
      endif
      
C     --------------- CREATE MASSES OF VB's  ---------------------------------
      y1 = var(prodim+1)
      y2 = var(prodim+2)      
      if(zerowidth.eq.0) then
         z1min = datan(-mV2/gamV/dsqrt(mV2))
         z1max = datan((mH2-mV2)/gamV/dsqrt(mV2))
         z1 = z1min + y1*(z1max-z1min)
         mv12 = dsqrt(mV2)*gamV*dtan(z1)+mV2
         z2min = z1min
         z2max=datan(((dsqrt(mH2)-dsqrt(mv12))**2-mV2)/dsqrt(mV2)/gamV)
         z2 = z2min + y2*(z2max-z2min)
         mv22 = dsqrt(mV2)*gamV*dtan(z2)+mV2
      else
         z1min=-pi/2d0
         z1max=pi/2d0
         z2min=-pi/2d0
         z2max=pi/2d0   
         mv12=mV2
         mv22=mV2
      endif

C     ------------- pre-factor from Higgs propagator -------------
      
      if(higgswidth.gt.0) then
         zhmin=datan(-nomm2/gamH/dsqrt(nomm2))
         zhmax=datan((scm-nomm2)/gamH/dsqrt(nomm2))
      else
         zhmin=-pi/2d0
         zhmax=pi/2d0
      endif



C     ~~~~~~~~~~~~~~~~~~~~~  CUT SECTION  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     ***  CUT on the mass of V1
        !print*,"In constraint"
      if((constraint.gt.0.5d0).and.(CutMassV1.gt.0.5d0)) then
            !print*,"in cut on the mass of V1"
         if((sqrt(mv12).lt.MinMassV1).or.(sqrt(mv12).gt.MaxMassV1)) then
            constraint=0d0
            !print *,"event cut: mv12=",sqrt(mv12)
         endif
      endif

C     ***  CUT on the mass of V2
      if((constraint.gt.0.5d0).and.(CutMassV1.gt.0.5d0)) then
         if((sqrt(mv12).lt.MinMassV1).or.(sqrt(mv12).gt.MaxMassV1)) then
            constraint=0d0
         endif
      endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      sz = dsqrt(z)
      zv1=mv12/scm/x1/x2
      zv2=mv22/scm/x1/x2
      szv1=dsqrt(zv1)
      szv2=dsqrt(zv2)
      delmpp = szv1+szv2+sz
      delmmm = szv1-szv2-sz
      delmpm = szv1+szv2-sz
      delmmp = szv1-szv2+sz
      prodelm = delmpp*delmmm*delmmp*delmpm
      squdelm = dsqrt(prodelm)
      
C     -------------------------------------------------------
C     now calculate the B1w and B2w for the decay H->VV
C     -------------------------------------------------------
      lam2 = var(prodim+7)
      lam1 = var(prodim+8)
      C1h = z-s1v
      C2h = z-s2v
      B2w = C2h/2d0/z*(zv2-zv1-z-(1d0-2d0*lam2)*squdelm)
      B1w=(1d0-2d0*lam2)*squdelm/C2h+C1h/2d0/z*(zv2-zv1+(-1d0+2d0*lam2)*
     &squdelm)-C1h/2d0+2d0/C2h**2*cos(pi*lam1)*dsqrt(dabs(C2h**2/z*lam2*
     & (1d0-lam2)*(C1h*C2h-z)))*squdelm
      D2w = -C2h-B2w
      D1w = -C1h-B1w

C     ------------------------------------------------------
C     create lepton invariant masses
C     ------------------------------------------------------
      gam2 = var(prodim+3)
      gam1 = var(prodim+4)
      a12l=(1d0-gam2)*B2w
      a11l=B1w*(1d0-gam2)+(-1d0+2d0*gam2)*zv1/B2w+2d0*dcos(pi*gam1)*
     & dsqrt((-1d0+gam2)*gam2*zv1*(-B1w*B2w+zv1)/B2w**2) 
     
      
      a22l = B2w-a12l
      a21l = B1w-a11l

      del2 = var(prodim+5)
      del1 = var(prodim+6)
      b12l=(1d0-del2)*D2w
      b11l=D1w*(1d0-del2)+(-1d0+2d0*del2)*zv2/D2w+2d0*dcos(pi*del1)*
     & dsqrt((-1d0+del2)*del2*zv2*(-D1w*D2w+zv2)/D2w**2) 
      b22l = D2w-b12l
      b21l = D1w-b11l

C     ------------------------------------------------------
C     form VB kinematic variables
C     ------------------------------------------------------
      
      EnV1 = - 0.5d0*dsqrt(scm)*(x1*B2w+x2*B1w)
      EnV2 = - 0.5d0*dsqrt(scm)*(x1*D2w+x2*D1w)
      
      pzV1 = 0.5d0*dsqrt(scm)*(x2*B1w-x1*B2w)
      pzV2 = 0.5d0*dsqrt(scm)*(x2*D1w-x1*D2w)
      
      ptV1 = dsqrt(x1*x2*scm*(B1w*B2w-zv1))
      ptV2 = dsqrt(x1*x2*scm*(D1w*D2w-zv2))
      
      yV1 = 0.5*dlog((EnV1+pzV1)/(EnV1-pzV1))
      yV2 = 0.5*dlog((EnV2+pzV2)/(EnV2-pzV2))

      if ((pTV1.ne.pTV1).or.(pTV2.ne.pTV2)) then 
        print*,"error in constraint.F \t\t\t\t\tpTV1=",pTV1,"\tpTV2=",pTV2
      endif  
C      write(*,*) '  VBs = ',EnV1, EnV2
C      write(*,*) '        ',ptV1, ptV2
C      write(*,*) '        ',dsqrt(mv12), dsqrt(mv22)


C     --------- PARTICLES FILL -----------
      part(2,1)=EnV1
      part(2,4)=pzV1
      part(5,1)=EnV2
      part(5,4)=pzV2
C     ------------------------------------

C     ~~~~~~~~~~~~~~~~~~~~~  CUT SECTION  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
C     ***   CUT on VB1 pt
      if((constraint.gt.0.5d0).and.(CutVB1Pt.gt.0.5d0)) then
         if((ptV1.lt.VB1PtMin).or.(ptV1.gt.VB1PtMax)) then
            constraint=0d0
            return
         endif
      endif

C     ***   CUT on VB2 pt
      if((constraint.gt.0.5d0).and.(CutVB2Pt.gt.0.5d0)) then
         if((ptV2.lt.VB2PtMin).or.(ptV2.gt.VB2PtMax)) then
            constraint=0d0
            return
         endif
      endif

C     ***   CUT on eta VB1
      if((constraint.gt.0.5d0).and.(CutVB1Eta.gt.0.5d0)) then
         if(dabs(yV1).gt.VB1EtaMax) then
            constraint=0d0
            return
         endif
      endif

C     ***   CUT on eta VB2
      if((constraint.gt.0.5d0).and.(CutVB2Eta.gt.0.5d0)) then
         if(dabs(yV2).gt.VB2EtaMax) then
            constraint=0d0
            return
         endif
      endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      

C     ----------------------------------------------------------------
C     form final state leptons kinematic
C     V1 -> l11 l12
C     V2 -> l21 l22
C     ----------------------------------------------------------------
      Enl11 = - 0.5d0*dsqrt(scm)*(x2*a11l+x1*a12l)
      Enl12 = - 0.5d0*dsqrt(scm)*(x2*a21l+x1*a22l)
      Enl21 = - 0.5d0*dsqrt(scm)*(x2*b11l+x1*b12l)
      Enl22 = - 0.5d0*dsqrt(scm)*(x2*b21l+x1*b22l)
     
      pzl11 = 0.5d0*dsqrt(scm)*(x2*a11l-x1*a12l)
      pzl12 = 0.5d0*dsqrt(scm)*(x2*a21l-x1*a22l)
      pzl21 = 0.5d0*dsqrt(scm)*(x2*b11l-x1*b12l)
      pzl22 = 0.5d0*dsqrt(scm)*(x2*b21l-x1*b22l)
      
      ptl11 = dsqrt(x1*x2*scm*a11l*a12l)
      ptl12 = dsqrt(x1*x2*scm*a21l*a22l)
      ptl21 = dsqrt(x1*x2*scm*b11l*b12l)
      ptl22 = dsqrt(x1*x2*scm*b21l*b22l)

      etal11=0.5d0*dlog((Enl11+pzl11)/(Enl11-pzl11))
      etal12=0.5d0*dlog((Enl12+pzl12)/(Enl12-pzl12))
      etal21=0.5d0*dlog((Enl21+pzl21)/(Enl21-pzl21))
      etal22=0.5d0*dlog((Enl22+pzl22)/(Enl22-pzl22))

C      write(*,*) Enl11, Enl12
C      write(*,*) Enl21, Enl22
C      write(*,*) ptl11, ptl12
C      write(*,*) ptl21, ptl22


C     --------- PARTICLES FILL -----------
      part(3,1)=Enl11
      part(3,4)=pzl11
      part(4,1)=Enl12
      part(4,4)=pzl12
      part(6,1)=Enl21
      part(6,4)=pzl21
      part(7,1)=Enl22
      part(7,4)=pzl22
      
C     ------------------------------------      
      
      
      
C     ~~~~~~~~~~~~~~~~~~~~~  CUT SECTION  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      

C :::::::::::::::::::::::: added ZZ-> leptons cuts

C     cut_on_pt_of_all_leptons
      if ((constraint.gt.0.5d0).and.(cut_on_pt_of_all_leptons.eq.1.0d0))  then
        if ( (ptl11.lt.all_leptons_minimum_pt).or.(ptl12.lt.all_leptons_minimum_pt).or.(ptl21.lt.all_leptons_minimum_pt).or.(ptl22.lt.all_leptons_minimum_pt) ) then 
            !print*,"event cut due to PT cut: ",ptl11,ptl12,ptl21,ptl22
            constraint=0d0
            return
        endif
      endif 
      
C     cut_on_rapidity_of_all_leptons
      if ((constraint.gt.0.5d0).and.(cut_on_rapidity_of_all_leptons.eq.1.0d0))  then
        if ( (etal11.gt.all_leptons_maximum_y).or.(etal12.gt.all_leptons_maximum_y).or.(etal21.gt.all_leptons_maximum_y).or.(etal22.gt.all_leptons_maximum_y) ) then 
            !print*,"event cut due to rapidity cut: ",etal11,etal12,etal21,etal22
            constraint=0d0
            return
        endif
      endif   
C :::::::::::::::::::::::: end of "added ZZ-> leptons cuts"

C     ***   CUT on min pt of harder lepton
      if((constraint.gt.0.5d0).and.(CutHardLeptPtMin.gt.0.5d0)) then
         if(ptl11.gt.ptl21) then
            if(ptl11.lt.HardLeptPtMin) then
               constraint=0d0
               return
            endif
         else
            if(ptl21.lt.HardLeptPtMin) then
               constraint=0d0
               return
            endif
         endif
      endif
      
C     ***   CUT on max pt of harder lepton
      if((constraint.gt.0.5d0).and.(CutHardLeptPtMax.gt.0.5d0)) then
         if(ptl11.gt.ptl21) then
            if(ptl11.gt.HardLeptPtMax) then
               constraint=0d0
               return
            endif
         else
            if(ptl21.gt.HardLeptPtMax) then
               constraint=0d0
               return
            endif
         endif
      endif
      
C     ***   CUT on min pt of softer lepton
      if((constraint.gt.0.5d0).and.(CutSoftLeptPtMin.gt.0.5d0)) then
         if(ptl11.lt.ptl21) then
            if(ptl11.lt.SoftLeptPtMin) then
               constraint=0d0
               return
            endif
         else
            if(ptl21.lt.SoftLeptPtMin) then
               constraint=0d0
               return
            endif
         endif
      endif

C     ***   CUT on max pt of softer lepton
      if((constraint.gt.0.5d0).and.(CutSoftLeptPtMax.gt.0.5d0)) then
         if(ptl11.lt.ptl21) then
            if(ptl11.gt.SoftLeptPtMax) then
               constraint=0d0
               return
            endif
         else
            if(ptl21.gt.SoftLeptPtMax) then
               constraint=0d0
               return
            endif
         endif
      endif
      
C     ***   CUT on |eta| of harder lepton
      if((constraint.gt.0.5d0).and.(CutHardLeptEta.gt.0.5d0)) then
         if(ptl11.gt.ptl21) then
            if(dabs(etal11).gt.HardLeptEtaMax) then
               constraint=0.0d0
               return
            endif
         else
            if(dabs(etal21).gt.HardLeptEtaMax) then
               constraint=0.0d0
               return
            endif
         endif
      endif

C     ***   CUT on |eta| of softer lepton
      if((constraint.gt.0.5d0).and.(CutSoftLeptEta.gt.0.5d0)) then
         if(ptl11.lt.ptl21) then
            if(dabs(etal11).gt.SoftLeptEtaMax) then
               constraint=0.0d0
               return
            endif
         else
            if(dabs(etal21).gt.SoftLeptEtaMax) then
               constraint=0.0d0
               return
            endif
         endif
      endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~            
      
CCCC ----------------  VECTOR BOSON CONFIGURATION ----------------------

C     Vflag:
C     0d0 -> no hard V (ptVi=0, pT=0)
C     1d0 -> V1 is hard, V2 soft (ptV1>0, ptV2=0, pT>0)
C     2d0 -> V2 is hard, V1 soft (ptV2>0, ptV1=0, pT>0)
C     3d0 -> both V's hard (ptVi>0, pT>0)
C     4d0 -> balancing hard V's (ptVi>0, pT=0)
      !print*,"z=",z," =? ",mH2/x1/x2/scm,"\tptV1=",ptV1,"\tptV2=",ptV2
      if ((ptV1.lt.ptbuf).and.(ptV2.lt.ptbuf)) then
C     ----------------------------------------------------------------
C     topflag = 0d0
C     --> both VB soft
C     --> both lepton pairs back-to-back
C     ----------------------------------------------------------------           
         Vflag=0d0

C     --------- PARTICLES FILL -----------
      part(2,2)=0d0
      part(2,3)=0d0
      part(5,2)=0d0
      part(5,3)=0d0
C     ------------------------------------
      
      else if ((ptV1.gt.ptbuf).and.(ptV2.lt.ptbuf)) then
C     ----------------------------------------------------------------
C     topflag = 1d0
C     --> VB1 hard, VB2 soft
C     --> VB1 and Higgs colinear
C     ----------------------------------------------------------------
C     ------------ safety check --------------------------------------
C     Higgs pT not to small, otherwise set VB's both to zero
         if(pT.lt.(0.1d0*ptbuf)) then
            Vflag=0.0d0

C     --------- PARTICLES FILL -----------
            part(2,2)=0d0
            part(2,3)=0d0
            part(5,2)=0d0
            part(5,3)=0d0
C     ------------------------------------

C     ----------------------------------------------------------------
         else
            Vflag=1d0
            cosV1=(EnV1*En-pzV1*pZ+(mv22-mv12-mh2)/2d0)/ptV1/pT
            if (cosV1.lt.(-1d0)) then
               cosV1=-1d0
            else if (cosV1.gt.1d0) then
               cosV1=1d0
            endif
            totphiV1=0d0
            if(topflag.eq.1d0) then
               phirV1=phir
            else 
               phi3V1=phi3
               phi4V1=phi4
            endif
         
C     --------- PARTICLES FILL -----------
            part(2,2)=ptV1*dcos(totphiV1)
            part(2,3)=ptV1*dsin(totphiV1)
            part(5,2)=0d0
            part(5,3)=0d0
C     ------------------------------------
         endif

      else if ((ptV1.lt.ptbuf).and.(ptV2.gt.ptbuf)) then
C     ----------------------------------------------------------------
C     Vflag = 2d0
C     --> VB2 hard, VB1 soft
C     --> VB2 and Higgs colinear
C     ----------------------------------------------------------------
         
C     ------------ safety check --------------------------------------
C     Higgs pT not to small, otherwise set VB's both to zero
         if(pT.lt.(0.1d0*ptbuf)) then
            Vflag=0.0d0

C     --------- PARTICLES FILL -----------
            part(2,2)=0d0
            part(2,3)=0d0
            part(5,2)=0d0
            part(5,3)=0d0
C     ------------------------------------

C     ----------------------------------------------------------------
         else
            Vflag=2d0
            cosV2=(EnV2*En-pzV2*pZ+(mv12-mv22-mh2)/2d0)/ptV2/pT
            if (cosV2.lt.(-1d0)) then
               cosV2=-1d0
            else if (cosV2.gt.1d0) then
               cosV2=1d0
            endif
            totphiV2=0d0
            if(topflag.eq.1d0) then
               phirV2=phir
            else 
               phi3V2=phi3
               phi4V2=phi4
            endif

C     --------- PARTICLES FILL -----------
            part(2,2)=0d0
            part(2,3)=0d0
            part(5,2)=ptV2*dcos(totphiV2)
            part(5,3)=ptV2*dsin(totphiV2)
C     ------------------------------------

         endif


      else
C     ------------------------------------------------------------
C     Here we know, both VB's are hard ....
         if(pT.gt.(0.1d0*ptbuf)) then
C     Vflag=3d0
C     Higgs and both VB's are hard
C     ------------------------------------------------------------
            Vflag=3d0
            cosV1=(EnV1*En-pzV1*pZ+(mv22-mv12-mh2)/2d0)/ptV1/pT
            cosV2=(EnV2*En-pzV2*pZ+(mv12-mv22-mh2)/2d0)/ptV2/pT
            cosV1V2=(EnV1*EnV2-pzV1*pzV2+(mv12+mv22-mh2)/2d0)/ptV1/ptV2
            if (cosV1.lt.(-1d0)) then
               cosV1=-1d0
            else if (cosV1.gt.1d0) then
               cosV1=1d0
            endif
            if (cosV2.lt.(-1d0)) then
               cosV2=-1d0
            else if (cosV2.gt.1d0) then
               cosV2=1d0
            endif
            if (cosV1V2.lt.(-1d0)) then
               cosV1V2=-1d0
            else if (cosV1V2.gt.1d0) then
               cosV1V2=1d0
            endif            
            phiV1=dacos(cosV1)
            phiV2=dacos(cosV2)
            phiV1V2=dacos(cosV1V2)

C     --------------------------------------------------
C     here we decide which V goes 'up'
C     --------------------------------------------------
            if(var(prodim+9).gt.0.5d0) then
               totphiV1=phiV1
               totphiV2=2d0*pi-phiV2
            else
               totphiV1=2d0*pi-phiV1
               totphiV2=phiV2
            endif
            if (topflag.eq.1d0) then
               phirV1=pi-phiV1
               phirV2=pi-phiV2
            else 
               phi3V1=dabs(totphi3-totphiV1)
               if(phi3V1.gt.pi) then
                  phi3V1=2d0*pi-dabs(totphi3-totphiV1)
               endif
               phi4V1=dabs(totphi4-totphiV1)
               if(phi4V1.gt.pi) then
                  phi4V1=2d0*pi-dabs(totphi4-totphiV1)
               endif
               phi3V2=dabs(totphi3-totphiV2)
               if(phi3V2.gt.pi) then
                  phi3V2=2d0*pi-dabs(totphi3-totphiV2)
               endif
               phi4V2=dabs(totphi4-totphiV2)
               if(phi4V2.gt.pi) then
                  phi4V2=2d0*pi-dabs(totphi4-totphiV2)
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(2,2)=ptV1*dcos(totphiV1)
            part(2,3)=ptV1*dsin(totphiV1)
            part(5,2)=ptV2*dcos(totphiV2)
            part(5,3)=ptV2*dsin(totphiV2)
C     ------------------------------------
            
         else
C     ------------------------------------------------------------
C     Vflag=4d0
C     Higgs soft, and both VB's are hard
C     ------------------------------------------------------------
            Vflag=4d0
            phiV1V2=pi
            if (topflag.eq.0d0) then
C     ------------------------------------------------------------
C     means: no hard partons ==> reference is V1 !
C     ------------------------------------------------------------
               totphiV1=0d0
               totphiV2=pi
            else if (topflag.eq.3d0) then
C     ------------------------------------------------------------               
C     in this case totphi3=0 is reference !
C     ------------------------------------------------------------               
               totphiV1=var(prodim+9)*2d0*pi
               totphiV2=totphiV1+pi
               if(totphiV2.gt.2d0*pi) then
                  totphiV2=totphiV1-pi
               endif
               if(totphiV1.lt.pi) then
                  phi3V1=totphiV1
               else
                  phi3V1=2d0*pi-totphiV1
               endif
               phi4V1=pi-phi3V1
               phi3V2=phi4V1
               phi4V2=phi3V1
            endif

C     --------- PARTICLES FILL -----------
            part(2,2)=ptV1*dcos(totphiV1)
            part(2,3)=ptV1*dsin(totphiV1)
            part(5,2)=ptV2*dcos(totphiV2)
            part(5,3)=ptV2*dsin(totphiV2)
C     ------------------------------------
            
         endif
      endif


C     ----------------- LEPTON CONFIGURATION FROM VB1 ----------------
C     lepflag1:
C     0d0 -> no hard leptons (ptV1=0)
C     1d0 -> l11 hard, l12 soft (ptl11>0, ptl12=0, ptV1>0)
C     2d0 -> l12 hard, l11 soft (ptl12>0, ptl11=0, ptV1>0)
C     3d0 -> two hard leptons (ptl1i>0, ptV1>0)
C     4d0 -> two balancing leptons (ptl1i>0, ptV1=0)
      
      if ((ptl11.lt.(ptbuf)).and.(ptl12.lt.(ptbuf))) then
C     ------------------------------------------
C     lepflag1=0d0
C     both leptons from VB1 are soft
C     ------------------------------------------
         lepflag1=0d0

C     --------- PARTICLES FILL -----------
         part(3,2)=0d0
         part(3,3)=0d0
         part(4,2)=0d0
         part(4,3)=0d0
C     ------------------------------------

      else if((ptl11.gt.(ptbuf)).and.(ptl12.lt.(ptbuf))) then
C     ------------------------------------------
C     lepflag1=1d0
C     lepton 1 is hard, lepton 2 is soft
C     ------------------------------------------
         
C     ------------ safety check --------------------------------------
C     VB1 pT not to small, otherwise set leptons both to zero
         if(ptV1.lt.ptbuf) then
            lepflag1=0.0d0

C     --------- PARTICLES FILL -----------
         part(3,2)=0d0
         part(3,3)=0d0
         part(4,2)=0d0
         part(4,3)=0d0
C     ------------------------------------

C     ----------------------------------------------------------------
         else
            lepflag1=1d0

C     set pt of lepton to pt of VB (momentum conservation...)
            ptl11=ptV1

            cosV1l11=(EnV1*Enl11-pzV1*pzl11-mv12/2)/ptV1/ptl11
            if (cosV1l11.lt.(-1d0)) then
               cosV1l11=-1d0
            else if (cosV1l11.gt.1d0) then
               cosV1l11=1d0
            endif
            phiV1l11=dacos(cosV1l11)
            totphil11=totphiV1
            if (topflag.eq.1d0) then
               phirl11=dabs(totphir-totphil11)
               if(phirl11.gt.pi) then
                  phirl11=2d0*pi-dabs(totphir-totphil11)
               endif
            else 
               phi3l11=dabs(totphi3-totphil11)
               if(phi3l11.gt.pi) then
                  phi3l11=2d0*pi-dabs(totphi3-totphil11)
               endif
               phi4l11=dabs(totphi4-totphil11)
               if(phi4l11.gt.pi) then
                  phi4l11=2d0*pi-dabs(totphi4-totphil11)
               endif
            endif

C     --------- PARTICLES FILL -----------
         part(3,2)=ptl11*dcos(totphil11)
         part(3,3)=ptl11*dsin(totphil11)
         part(4,2)=0d0
         part(4,3)=0d0
C     ------------------------------------

         endif
      else if((ptl11.lt.(ptbuf)).and.(ptl12.gt.(ptbuf))) then
C     ------------------------------------------
C     lepflag1=2d0
C     lepton 1 is soft, lepton 2 is hard
C     ------------------------------------------
         
C     ------------ safety check --------------------------------------
C     VB1 pT not to small, otherwise set leptons both to zero
         if(ptV1.lt.ptbuf) then
            lepflag1=0.0d0

C     --------- PARTICLES FILL -----------
         part(3,2)=0d0
         part(3,3)=0d0
         part(4,2)=0d0
         part(4,3)=0d0
C     ------------------------------------

C     ----------------------------------------------------------------
         else
            lepflag1=2d0

C     to ensure momentum conservation, set pt of lepton to pt of VB
            ptl12=ptV1

            cosV1l12=(EnV1*Enl12-pzV1*pzl12-mv12/2)/ptV1/ptl12
            if (cosV1l12.lt.(-1d0)) then
               cosV1l12=-1d0
            else if (cosV1l12.gt.1d0) then
               cosV1l12=1d0
            endif
            phiV1l12=dacos(cosV1l12)
            totphil12=totphiV1
            if (topflag.eq.1d0) then
               phirl12=dabs(totphir-totphil12)
               if(phirl12.gt.pi) then
                  phirl12=2d0*pi-dabs(totphir-totphil12)
               endif
            else 
               phi3l12=dabs(totphi3-totphil12)
               if(phi3l12.gt.pi) then
                  phi3l12=2d0*pi-dabs(totphi3-totphil12)
               endif
               phi4l12=dabs(totphi4-totphil12)
               if(phi4l12.gt.pi) then
                  phi4l12=2d0*pi-dabs(totphi4-totphil12)
               endif
            endif

C     --------- PARTICLES FILL -----------
         part(3,2)=0d0
         part(3,3)=0d0
         part(4,2)=ptl12*dcos(totphil12)
         part(4,3)=ptl12*dsin(totphil12)
C     ------------------------------------

         endif
      else
C     -----------------------------------------------------------------
C     here we know, both leptons from VB1 are hard
         if (ptV1.gt.ptbuf) then
C     lepflag1=3d0
C     VB1 is also hard
C     -----------------------------------------------------------------
            lepflag1=3d0
            cosV1l11=(EnV1*Enl11-pzV1*pzl11-mv12/2d0)/ptV1/ptl11
            cosV1l12=(EnV1*Enl12-pzV1*pzl12-mv12/2d0)/ptV1/ptl12
            cosl11l12=(Enl11*Enl12-pzl11*pzl12-mv12/2d0)/ptl11/ptl12
            if (cosV1l11.lt.(-1d0)) then
               cosV1l11=-1d0
            else if (cosV1l11.gt.1d0) then
               cosV1l11=1d0
            endif
            if (cosV1l12.lt.(-1d0)) then
               cosV1l12=-1d0
            else if (cosV1l12.gt.1d0) then
               cosV1l12=1d0
            endif
            if (cosl11l12.gt.1d0) then
               cosl11l12=1d0
            else if(cosl11l12.lt.(-1d0)) then
               cosl11l12=-1d0
            endif
            phiV1l11=dacos(cosV1l11)
            phiV1l12=dacos(cosV1l12)
            phil11l12=dacos(cosl11l12)
C     -----------------------------------------------------------------            
C     here we decide which lepton goes 'up'
C     -----------------------------------------------------------------
            if(var(prodim+10).gt.0.5d0) then
               totphil11=totphiV1+phiV1l11
               if(totphil11.gt.2d0*pi) then
                  totphil11=totphiV1+phiV1l11-2d0*pi
               endif
               totphil12=totphiV1-phiV1l12
               if(totphil12.lt.0d0) then
                  totphil12=totphiV1-phiV1l12+2d0*pi
               endif
            else
               totphil11=totphiV1-phiV1l11
               if(totphil11.lt.0d0) then
                  totphil11=totphiV1-phiV1l11+2d0*pi
               endif
               totphil12=totphiV1+phiV1l12
               if(totphil12.gt.2d0*pi) then
                  totphil12=totphiV1+phiV1l12-2d0*pi
               endif
            endif
            
            if(topflag.eq.1d0) then
               phirl11=dabs(totphir-totphil11)
               if(phirl11.gt.pi) then
                  phirl11=2d0*pi-dabs(totphir-totphil11)
               endif
               phirl12=dabs(totphir-totphil12)
               if(phirl12.gt.pi) then
                  phirl12=2d0*pi-dabs(totphir-totphil12)
               endif
            else 
               phi3l11=dabs(totphi3-totphil11)
               if(phi3l11.gt.pi) then
                  phi3l11=2d0*pi-dabs(totphi3-totphil11)
               endif
               phi3l12=dabs(totphi3-totphil12)
               if(phi3l12.gt.pi) then
                  phi3l12=2d0*pi-dabs(totphi3-totphil12)
               endif
               phi4l11=dabs(totphi4-totphil11)
               if(phi4l11.gt.pi) then
                  phi4l11=2d0*pi-dabs(totphi4-totphil11)
               endif
               phi4l12=dabs(totphi4-totphil12)
               if(phi4l12.gt.pi) then
                  phi4l12=2d0*pi-dabs(totphi4-totphil12)
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(3,2)=ptl11*dcos(totphil11)
            part(3,3)=ptl11*dsin(totphil11)
            part(4,2)=ptl12*dcos(totphil12)
            part(4,3)=ptl12*dsin(totphil12)
C     ------------------------------------            
            
         else
C     -----------------------------------------------------------------
C     lepflag1=4d0
C     both leptons hard, VB1 is soft
C     --->  leptons are back-to-back
C     -----------------------------------------------------------------
            lepflag1=4d0
            phil11l12=pi


C   to ensure mom. conservation, set ptl12=ptl11

            ptl12=ptl11

            if(topflag.eq.0d0) then
C     ---------------------------------
C     reference is totphil11=0
C     ---------------------------------
               totphil11=0d0
               totphil12=pi
            else 
               totphil11=var(prodim+10)*2d0*pi
               totphil12=totphil11+pi
               if(totphil12.gt.2d0*pi) then
                  totphil12=totphil11-pi
               endif
               if(topflag.eq.1d0) then
                  phirl11=dabs(totphir-totphil11)
                  if(phirl11.gt.pi) then
                     phirl11=2d0*pi-dabs(totphir-totphil11)
                  endif
                  phirl12=dabs(totphir-totphil12)
                  if(phirl12.gt.pi) then
                     phirl12=2d0*pi-dabs(totphir-totphil12)
                  endif
               else if(topflag.gt.1d0) then
                  phi3l11=dabs(totphi3-totphil11)
                  if(phi3l11.gt.pi) then
                     phi3l11=2d0*pi-dabs(totphi3-totphil11)
                  endif
                  phi4l11=dabs(totphi4-totphil11)
                  if(phi4l11.gt.pi) then
                     phi4l11=2d0*pi-dabs(totphi4-totphil11)
                  endif
                  phi3l12=dabs(totphi3-totphil12)
                  if(phi3l12.gt.pi) then
                     phi3l12=2d0*pi-dabs(totphi3-totphil12)
                  endif
                  phi4l12=dabs(totphi4-totphil12)
                  if(phi4l12.gt.pi) then
                     phi4l12=2d0*pi-dabs(totphi4-totphil12)
                  endif
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(3,2)=ptl11*dcos(totphil11)
            part(3,3)=ptl11*dsin(totphil11)
            part(4,2)=ptl12*dcos(totphil12)
            part(4,3)=ptl12*dsin(totphil12)
C     ------------------------------------

         endif
      endif
            
C     ----------------- LEPTON CONFIGURATION FROM VB2 ----------------
C     lepflag2:
C     0d0 -> no hard leptons (ptV2=0)
C     1d0 -> l21 hard, l22 soft (ptl21>0, ptl22=0, ptV2>0)
C     2d0 -> l22 hard, l21 soft (ptl22>0, ptl21=0, ptV2>0)
C     3d0 -> two hard leptons (ptl2i>0, ptV2>0)
C     4d0 -> two balancing leptons (ptl2i>0, ptV2=0)

      if ((ptl21.lt.(ptbuf)).and.(ptl22.lt.(ptbuf))) then
C     -----------------------------------------------------------------
C     lepflag2=0d0
C     both leptons from VB2 soft
C     -----------------------------------------------------------------
         lepflag2=0d0
         
C     --------- PARTICLES FILL -----------
            part(6,2)=0d0
            part(6,3)=0d0
            part(7,2)=0d0
            part(7,3)=0d0
C     ------------------------------------

      else if((ptl21.gt.(ptbuf)).and.(ptl22.lt.(ptbuf))) then
C     ------------------------------------------
C     lepflag2=1d0
C     lepton 1 is hard, lepton 2 is soft
C     ------------------------------------------
         
C     ------------ safety check --------------------------------------
C     VB2 pT not to small, otherwise set leptons both to zero
         if(ptV2.lt.ptbuf) then
            lepflag2=0.0d0

C     --------- PARTICLES FILL -----------
            part(6,2)=0d0
            part(6,3)=0d0
            part(7,2)=0d0
            part(7,3)=0d0
C     ------------------------------------

C     ----------------------------------------------------------------
         else
            lepflag2=1d0

C     to ensure momentum conservation, set pt of lepton to pt of VB
            ptl21=ptV2

            cosV2l21=(EnV2*Enl21-pzV2*pzl21-mv22/2)/ptV2/ptl21
            if (cosV2l21.lt.(-1d0)) then
               cosV2l21=-1d0
            else if (cosV2l21.gt.1d0) then
               cosV2l21=1d0
            endif
            phiV2l21=dacos(cosV2l21)
            totphil21=totphiV2
            if (topflag.eq.1d0) then
               phirl21=dabs(totphir-totphil21)
               if(phirl21.gt.pi) then
                  phirl21=2d0*pi-dabs(totphir-totphil21)
               endif
            else 
               phi3l21=dabs(totphi3-totphil21)
               if(phi3l21.gt.pi) then
                  phi3l21=2d0*pi-dabs(totphi3-totphil21)
               endif
               phi4l21=dabs(totphi4-totphil21)
               if(phi4l21.gt.pi) then
                  phi4l21=2d0*pi-dabs(totphi4-totphil21)
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(6,2)=ptl21*dcos(totphil21)
            part(6,3)=ptl21*dsin(totphil21)
            part(7,2)=0d0
            part(7,3)=0d0
C     ------------------------------------

         endif
         
      else if((ptl21.lt.(ptbuf)).and.(ptl22.gt.(ptbuf))) then
C     ------------------------------------------
C     lepflag2=2d0
C     lepton 2 is hard, lepton 1 is soft
C     ------------------------------------------
         
C     ------------ safety check --------------------------------------
C     VB2 pT not to small, otherwise set leptons both to zero
         if(ptV2.lt.ptbuf) then
            lepflag2=0.0d0

C     --------- PARTICLES FILL -----------
            part(6,2)=0d0
            part(6,3)=0d0
            part(7,2)=0d0
            part(7,3)=0d0
C     ------------------------------------

C     ----------------------------------------------------------------
         else
            lepflag2=2d0

C     to ensure momentum conservation, set pt of lepton to pt of VB
            ptl22=ptV2

            cosV2l22=(EnV2*Enl22-pzV2*pzl22-mv22/2)/ptV2/ptl22
            if (cosV2l22.lt.(-1d0)) then
               cosV2l22=-1d0
            else if (cosV2l22.gt.1d0) then
               cosV2l22=1d0
            endif
            phiV2l22=dacos(cosV2l22)
            totphil22=totphiV2
            if (topflag.eq.1d0) then
               phirl22=dabs(totphir-totphil22)
               if(phirl22.gt.pi) then
                  phirl22=2d0*pi-dabs(totphir-totphil22)
               endif
            else 
               phi3l22=dabs(totphi3-totphil22)
               if(phi3l22.gt.pi) then
                  phi3l22=2d0*pi-dabs(totphi3-totphil22)
               endif
               phi4l22=dabs(totphi4-totphil22)
               if(phi4l22.gt.pi) then
                  phi4l12=2d0*pi-dabs(totphi4-totphil12)
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(6,2)=0d0
            part(6,3)=0d0
            part(7,2)=ptl22*dcos(totphil22)
            part(7,3)=ptl22*dsin(totphil22)
C     ------------------------------------

         endif         
      else
C     -----------------------------------------------------------------
C     we know, both leptons from VB2 are hard
         if (ptV2.gt.ptbuf) then
C     lepflag2=3d0
C     VB2 is also hard
C     -----------------------------------------------------------------
            lepflag2=3d0
            cosV2l21=(EnV2*Enl21-pzV2*pzl21-mv22/2)/ptV2/ptl21
            cosV2l22=(EnV2*Enl22-pzV2*pzl22-mv22/2)/ptV2/ptl22
            cosl21l22=(Enl21*Enl22-pzl21*pzl22-mv22/2d0)/ptl21/ptl22
            if (cosV2l21.lt.(-1d0)) then
               cosV2l21=-1d0
            else if (cosV2l21.gt.1d0) then
               cosV2l21=1d0
            endif
            if (cosV2l22.lt.(-1d0)) then
               cosV2l22=-1d0
            else if (cosV2l22.gt.1d0) then
               cosV2l22=1d0
            endif
            if (cosl21l22.gt.1d0) then
               cosl21l22=1d0
            else if(cosl21l22.lt.(-1d0)) then
               cosl11l12=-1d0
            endif
            phiV2l21=dacos(cosV2l21)
            phiV2l22=dacos(cosV2l22)
            phil21l22=dacos(cosl21l22)
C     --------------------------------------------------
C     here we decide which lepton goes 'up'
C     --------------------------------------------------
            if(var(prodim+11).gt.0.5d0) then
               totphil21=totphiV2+phiV2l21
               if(totphil21.gt.2d0*pi) then
                  totphil21=totphiV2+phiV2l21-2d0*pi
               endif
               totphil22=totphiV2-phiV2l22
               if(totphil22.lt.0d0) then
                  totphil22=totphiV2-phiV2l22+2d0*pi
               endif
            else
               totphil21=totphiV2-phiV2l21
               if(totphil21.lt.0d0) then
                  totphil21=totphiV2-phiV2l21+2d0*pi
               endif
               totphil22=totphiV2+phiV2l22
               if(totphil22.gt.2d0*pi) then
                  totphil22=totphiV2+phiV2l22-2d0*pi
               endif
            endif
            if(topflag.eq.1d0) then
               phirl21=dabs(totphir-totphil21)
               if(phirl21.gt.pi) then
                  phirl21=2d0*pi-dabs(totphir-totphil21)
               endif
               phirl22=dabs(totphir-totphil22)
               if(phirl22.gt.pi) then
                  phirl22=2d0*pi-dabs(totphir-totphil22)
               endif
            else 
               phi3l21=dabs(totphi3-totphil21)
               if(phi3l21.gt.pi) then
                  phi3l21=2d0*pi-dabs(totphi3-totphil21)
               endif
               phi3l22=dabs(totphi3-totphil22)
               if(phi3l22.gt.pi) then
                  phi3l22=2d0*pi-dabs(totphi3-totphil22)
               endif
               phi4l21=dabs(totphi4-totphil21)
               if(phi4l21.gt.pi) then
                  phi4l21=2d0*pi-dabs(totphi4-totphil21)
               endif
               phi4l22=dabs(totphi4-totphil22)
               if(phi4l22.gt.pi) then
                  phi4l22=2d0*pi-dabs(totphi4-totphil22)
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(6,2)=ptl21*dcos(totphil21)
            part(6,3)=ptl21*dsin(totphil21)
            part(7,2)=ptl22*dcos(totphil22)
            part(7,3)=ptl22*dsin(totphil22)
C     ------------------------------------

         else
C     ----------------------------------------------------------------
C     lepflag2=4d0
C     VB2 is soft
C     leptons from VB2 are back-to-back
C     ----------------------------------------------------------------
            lepflag2=4d0
            phil21l22=pi

C     ensure mom. conservation
            ptl22=ptl21

            if((topflag.eq.0d0).and.(lepflag1.eq.0d0)) then
C     ----------------------------
C     reference is totphil21=0
C     ----------------------------
               totphil21=0d0
               totphil22=pi               
            else 
               totphil21=var(prodim+11)*2d0*pi
               totphil22=totphil21+pi
               if(totphil22.gt.2d0*pi) then
                  totphil22=totphil21-pi
               endif
               if(topflag.eq.1d0) then
                  phirl21=dabs(totphir-totphil21)
                  if(phirl21.gt.pi) then
                     phirl21=2d0*pi-dabs(totphir-totphil21)
                  endif
                  phirl22=dabs(totphir-totphil22)
                  if(phirl22.gt.pi) then
                     phirl22=2d0*pi-dabs(totphir-totphil22)
                  endif                  
               else 
                  phi3l21=dabs(totphi3-totphil21)
                  if(phi3l21.gt.pi) then
                     phi3l21=2d0*pi-dabs(totphi3-totphil21)
                  endif
                  phi4l21=dabs(totphi4-totphil21)
                  if(phi4l21.gt.pi) then
                     phi4l21=2d0*pi-dabs(totphi4-totphil21)
                  endif
                  phi3l22=dabs(totphi3-totphil22)
                  if(phi3l22.gt.pi) then
                     phi3l22=2d0*pi-dabs(totphi3-totphil22)
                  endif
                  phi4l22=dabs(totphi4-totphil22)
                  if(phi4l22.gt.pi) then
                     phi4l22=2d0*pi-dabs(totphi4-totphil22)
                  endif
               endif
            endif

C     --------- PARTICLES FILL -----------
            part(6,2)=ptl21*dcos(totphil21)
            part(6,3)=ptl21*dsin(totphil21)
            part(7,2)=ptl22*dcos(totphil22)
            part(7,3)=ptl22*dsin(totphil22)
C     ------------------------------------
            
         endif
      endif

C      write(*,*) '--------------'
C      write(*,*) topflag
C      write(*,*) 'Jets: ',numJets
C      write(*,*) lepflag1, lepflag2
C      write(*,*) phirl11, phirl12, phirl21, phirl22
C      write(*,*) phi3l11, phi3l12, phi3l21, phi3l22
C      write(*,*) phi4l11, phi4l12, phi4l21, phi4l22
         
      
C     -----------   ANGULAR CONFIGURATION ----------------------------
C     we decide here, which leptons are the charged ones (only in H->WW)
C     ptl11 is charged lepton from VB1
C     ptl12 is neutrino from VB1
C     ptl21 is charged lepton from VB1
C     ptl22 is neutrino from VB1
C     
C     in H->ZZ case .... (TODO)
C
C     we need the following angles in order to perform the cuts and
C     to compute the weight of the 'event':
C     - phi11       (angle between lepton 1 from VB1 and lepton 1 from VB2
C     - phi12       (        "     lepton 1         "    lepton 2    "
C     - phi21       (        "     lepton 2         "    lepton 1    "
C     - phi22       (        "     lepton 2         "    lepton 2    "
C     - phijet(2)1  (        "     lepton 1     "    and jet(s)    
C     - phijet(2)2  (        "     lepton 1   "  VB2 and jet(s)    
C     ----------------------------------------------------------------

      if((lepflag1.gt.0d0).and.(lepflag2.gt.0d0)) then
         if(lepflag1.eq.1d0) then
            if(lepflag2.eq.1d0) then
               phi11=dabs(totphil11-totphil21)
               if(phi11.gt.pi) then
                  phi11=2d0*pi-dabs(totphil11-totphil21)
               endif
            else if(lepflag2.eq.2d0) then
               phi12=dabs(totphil11-totphil22)
               if(phi12.gt.pi) then
                  phi12=2d0*pi-dabs(totphil11-totphil22)
               endif
            else
               phi11=dabs(totphil11-totphil21)
               if(phi11.gt.pi) then
                  phi11=2d0*pi-dabs(totphil11-totphil21)
               endif
               phi12=dabs(totphil11-totphil22)
               if(phi12.gt.pi) then
                  phi12=2d0*pi-dabs(totphil11-totphil22)
               endif
            endif
         else if(lepflag1.eq.2d0) then
            if(lepflag2.eq.1d0) then
               phi21=dabs(totphil12-totphil21)
               if(phi21.gt.pi) then
                  phi21=2d0*pi-dabs(totphil12-totphil21)
               endif
            else if(lepflag2.eq.2d0) then
               phi22=dabs(totphil12-totphil22)
               if(phi22.gt.pi) then
                  phi22=2d0*pi-dabs(totphil12-totphil22)
               endif
            else
               phi21=dabs(totphil12-totphil21)
               if(phi21.gt.pi) then
                  phi21=2d0*pi-dabs(totphil12-totphil21)
               endif
               phi22=dabs(totphil12-totphil22)
               if(phi22.gt.pi) then
                  phi22=2d0*pi-dabs(totphil12-totphil22)
               endif
            endif
         else
            if(lepflag2.eq.1d0) then
               phi11=dabs(totphil11-totphil21)
               if(phi11.gt.pi) then
                  phi11=2d0*pi-dabs(totphil11-totphil21)
               endif
               phi21=dabs(totphil12-totphil21)
               if(phi21.gt.pi) then
                  phi21=2d0*pi-dabs(totphil12-totphil21)
               endif

            else if(lepflag2.eq.2d0) then
               phi12=dabs(totphil11-totphil22)
               if(phi12.gt.pi) then
                  phi12=2d0*pi-dabs(totphil11-totphil22)
               endif
               phi22=dabs(totphil12-totphil22)
               if(phi22.gt.pi) then
                  phi22=2d0*pi-dabs(totphil12-totphil22)
               endif
            else
               phi11=dabs(totphil11-totphil21)
               if(phi11.gt.pi) then
                  phi11=2d0*pi-dabs(totphil11-totphil21)
               endif
               phi12=dabs(totphil11-totphil22)
               if(phi12.gt.pi) then
                  phi12=2d0*pi-dabs(totphil11-totphil22)
               endif
               phi21=dabs(totphil12-totphil21)
               if(phi21.gt.pi) then
                  phi21=2d0*pi-dabs(totphil12-totphil21)
               endif
               phi22=dabs(totphil12-totphil22)
               if(phi22.gt.pi) then
                  phi22=2d0*pi-dabs(totphil12-totphil22)
               endif
            endif
         endif
      endif


C ------------------ COMPUTE REAL KINEMATICS -----------------
      if(2d0.gt.1d0) then
         L11px=0.0
         L11py=0.0
         L12px=0.0
         L12py=0.0
         L21px=0.0
         L21py=0.0
         L22px=0.0
         L22py=0.0
         J1px=0.0
         J1py=0.0
         J2px=0.0
         J2py=0.0
         if(lepflag1.gt.0) then
            if(lepflag1.gt.1) then
               L12px=ptl12*dcos(totphil12)
               L12py=ptl12*dsin(totphil12)
               if(lepflag1.gt.2) then
                  L11px=ptl11*dcos(totphil11)
                  L11py=ptl11*dsin(totphil11)
               endif
            else
               L11px=ptl11*dcos(totphil11)
               L11py=ptl11*dsin(totphil11)
            endif
         endif
         if(lepflag2.gt.0) then
            if(lepflag2.gt.1) then
               L22px=ptl22*dcos(totphil22)
               L22py=ptl22*dsin(totphil22)
               if(lepflag2.gt.2) then
                  L21px=ptl21*dcos(totphil21)
                  L21py=ptl21*dsin(totphil21)
               endif
            else
               L21px=ptl21*dcos(totphil21)
               L21py=ptl21*dsin(totphil21)
            endif
         endif
         if(numJets.eq.1) then
            J1px=ptjet*dcos(totphijet)
            J1py=ptjet*dsin(totphijet)
         endif
         if(numJets.eq.2) then
            J1px=pt3*dcos(totphi3)
            J1py=pt3*dsin(totphi3)
            J2px=pt4*dcos(totphi4)
            J2py=pt4*dsin(totphi4)
         endif
         
C     ------ MET kinematics --------
         METpx=L22px+L12px
         METpy=L22py+L12py
C     ------------------------------


         if(0d0.gt.1d0) then
            write(*,*) '------------------------'
            write(*,*) 'Charged Lepton 1:'
            write(*,*) ' px = ',L11px
            write(*,*) ' py = ',L11py
            write(*,*) 'Un-Charged Lepton 1:'
            write(*,*) ' px = ',L12px
            write(*,*) ' py = ',L12py
            write(*,*) 'Charged Lepton 2:'
            write(*,*) ' px = ',L21px
            write(*,*) ' py = ',L21py
            write(*,*) 'Un-Charged Lepton 2:'
            write(*,*) ' px = ',L22px
            write(*,*) ' py = ',L22py
            write(*,*) 'Missing Pt:'
            write(*,*) ' px = ',L22px+L12px
            write(*,*) ' py = ',L22py+L12py
            write(*,*) ' MET= ',dsqrt(METpx*METpx+METpy*METpy)
            write(*,*) 'Higgs: '
            write(*,*) ' pt = ',pT
            write(*,*) 'Number of Jets:',numJets
            if(numJets.gt.0) then
               write(*,*) 'Jet Number 1:'
               write(*,*) ' px = ',J1px
               write(*,*) ' py = ',J1py
               write(*,*) ' pt = ',ptjet
               write(*,*) ' phi= ',totphijet
               if(numJets.gt.1) then
                  write(*,*) 'Jet Number 2:'
                  write(*,*) ' px = ',J2px
                  write(*,*) ' py = ',J2py
               endif
            endif
         endif
      endif
      
C     ~~~~~~~~~~~~~~~~~~~~~  CUT SECTION  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     ***   TRIGGER LEPTONS
      if(TriggerCut.gt.0.5d0) then
         if((ptl11.lt.TriggerPt.or.dabs(etal11).gt.TriggerEta)
     .        .and.
     .        (ptl21.lt.TriggerPt.or.dabs(etal21)
     .        .gt.TriggerEta))
     .        then
            constraint=0d0
            return
         endif
      endif      

C     ***   PHILL CUT
      if((constraint.gt.0.5d0).and.(CutPhiLL.gt.0.5d0)) then
         if((lepflag1.lt.1.0d0).or.(lepflag2.lt.1.0d0)) then
            constraint=0d0
            return
         elseif((lepflag1.eq.2.0d0).or.(lepflag2.lt.2.0d0)) then
            constraint=0d0
            return
         elseif((phi11.lt.PhiLLMin*pi/180.0d0).or.
     %           (phi11.gt.PhiLLMax/180.0d0*pi)) then
            constraint=0d0
            return
         endif
      endif

C     ***   MISSING PT CUT
      if((constraint.gt.0.5d0).and.(CutMissPt.gt.0.5d0)) then
         neutpt=0d0
         if(lepflag1.gt.1d0) then
            neutpt=ptl12**2
            if(lepflag2.gt.1d0) then
               neutpt=neutpt+ptl22*(ptl22+2d0*ptl12*dcos(phi22))
            endif
         else
            if(lepflag2.gt.1d0) then
               neutpt=ptl22**2
            endif
         endif
         neutpt=dsqrt(neutpt)
C         write(*,*) 'second MET = ',neutpt
         if((neutpt.lt.MissPtMin).or.(neutpt.gt.MissPtMax)) then
            constraint=0d0
            return
         endif
      endif

      
C     *** SPECIAL CDF MET CUT
      if((constraint.gt.0.5d0).and.(CutSpecMet.gt.0.5d0)) then
C     ----- first compute MET
         neutpt=0d0      
         if(lepflag1.gt.1d0) then
            neutpt=ptl12**2
            if(lepflag2.gt.1d0) then
               neutpt=neutpt+ptl22*(ptl22+2d0*ptl12*dcos(phi22))
            endif
         else
            if(lepflag2.gt.1d0) then
               neutpt=ptl22**2
            endif
         endif
         neutpt=dsqrt(neutpt)
C     ----- find angle between MET and nearest object
         if(neutpt.gt.0.0001d0) then
            minAngle=100d0
            if((lepflag1.eq.1).or.(lepflag1.gt.2)) then
               tempAngle=dacos((METpx*L11px+METpy*L11py)/
     .              ptl11/neutpt)
C               write(*,*) 'Angles:'
C               write(*,*) '  lepton 1:',tempAngle
               if(tempAngle.lt.minAngle) then
                  minAngle=tempAngle
               endif
            endif
            if((lepflag2.eq.1).or.(lepflag2.gt.2)) then
               tempAngle=dacos((METpx*L21px+METpy*L21py)/
     .              ptl21/neutpt)
C              write(*,*) '  lepton 2:',tempAngle
               if(tempAngle.lt.minAngle) then
                  minAngle=tempAngle
               endif
            endif
            if(numJets.gt.0) then
C               write(*,*) '=----------------='
               tempAngle=dacos((METpx*J1px+METpy*J1py)/
     .              dsqrt(J1px*J1px+J1py*J1py)/neutpt)
C               write(*,*) '  jet    1:',tempAngle               
               if(tempAngle.lt.minAngle) then
                  minAngle=tempAngle
               endif
               if(numJets.gt.1) then
                  tempAngle=dacos((METpx*J2px+METpy*J2py)/
     .                 dsqrt(J2px*J2px+J2py*J2py)/neutpt)
C                  write(*,*) '  jet    2:',tempAngle                     
                  if(tempAngle.lt.minAngle) then
                     minAngle=tempAngle
                  endif
               endif
            endif
C            write(*,*) ' min Angle = ',minAngle
            if(minAngle.lt.pi/2d0) then
C     write(*,*) ' dsin(minAngle) =',dsin(minAngle)
C----------------uncomment this ---------------------
               neutpt=dabs(neutpt*dsin(minAngle))
            endif
C            write(*,*) ' new MET = ',neutpt
            if(neutpt.lt.SpecMetMin) then
C               write(*,*) ' REJECTED !'
               constraint=0d0
               return
            endif
         else
            write(*,*) '****'
            constraint=0d0
            return
         endif
      endif
      

C     ***   SUM PT CUT
      if((constraint.gt.0.5d0).and.(CutSumPt.gt.0.5d0)) then
         neutpt=0d0
         if(lepflag1.gt.1d0) then
            neutpt=ptl12**2
            if(lepflag2.gt.1d0) then
               neutpt=neutpt+ptl22*(ptl22+2d0*ptl12*dcos(phi22))
            endif
         else
            if(lepflag2.gt.1d0) then
               neutpt=ptl22**2
            endif
         endif
         neutpt=dsqrt(neutpt)
         if(lepflag1.gt.1d0) then
            neutpt=neutpt+ptl12
            if(lepflag2.gt.1d0) then
               neutpt=neutpt+ptl22
            endif
         else
            if(lepflag2.gt.1d0) then
               neutpt=neutpt+ptl22
            endif
         endif
         if((neutpt.lt.SumPtMin).or.(neutpt.gt.SumPtMax)) then
            constraint=0d0
            return
         endif
      endif         

C     ***   ISOLATION
      if((constraint.gt.0.5d0).and.(CutIsolation.gt.0.5d0)) then
         Risol=IsolationCone
         pt34=pt3+pt4
         if (topflag.eq.1d0) then 
            Rar = dsqrt(phirl11**2 +(etal11-etar)**2)
            Rbr = dsqrt(phirl21**2 +(etal21-etar)**2)
            if((Rar.lt.Risol).and.(ptr.ge.(Isolation*ptl11))) then
               constraint=0d0
               return
            elseif ((Rbr.lt.Risol).and.(ptr.ge.(Isolation*ptl21))) then
               constraint=0d0
               return
            endif
         elseif (topflag.gt.1d0) then                              
            R3a=dsqrt(phi3l11**2+(eta3-etal11)**2)
            R3b=dsqrt(phi3l21**2+(eta3-etal21)**2)
            R4a=dsqrt(phi4l11**2+(eta4-etal11)**2)
            R4b=dsqrt(phi4l21**2+(eta4-etal21)**2)               
            if ((R3a.lt.Risol).and.(R4a.lt.Risol)) then 
               Ethada = pt3+pt4
            elseif  ((R3a.lt.Risol).and.(R4a.gt.Risol)) then 
               Ethada = pt3 
            elseif  ((R4a.lt.Risol).and.(R3a.gt.Risol)) then 
               Ethada = pt4
            else 
               Ethada =0d0
            endif                              
            if ((R3b.lt.Risol).and.(R4b.lt.Risol)) then 
               Ethadb = pt3+pt4
            elseif  ((R3b.lt.Risol).and.(R4b.gt.Risol)) then 
               Ethadb = pt3 
            elseif  ((R4b.lt.Risol).and.(R3b.gt.Risol)) then 
               Ethadb = pt4
            else 
               Ethadb =0d0
            endif
            if ((Ethada.gt.(Isolation*ptl11)).or.
     .           (Ethadb.gt.(Isolation*ptl21))) then 
               constraint = 0d0
               return
            endif
         endif
      endif

C     ***   INVARIANT MASS CUT
      if((constraint.gt.0.5d0).and.(CutInvMass.gt.0.5d0)) then
         dilepmass = (Enl11+Enl21)**2-(pzl11+pzl21)**2
         if((lepflag1.eq.1d0).or.(lepflag1.gt.2d0)) then
            dilepmass=dilepmass-ptl11**2
            if((lepflag2.eq.1d0).or.(lepflag2.gt.2d0)) then
               dilepmass=dilepmass-ptl21**2
               dilepmass=dilepmass-2d0*ptl11*ptl21*dcos(phi11)
            endif
         elseif((lepflag2.eq.1d0).or.(lepflag2.gt.2d0)) then
            dilepmass=dilepmass-ptl21**2
         endif
         dilepmass=dsqrt(dilepmass)
         if((dilepmass.ge.InvMassMax).or.(dilepmass.lt.InvMassMin)) then
            constraint=0d0
            return
         endif
      endif
      


C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      
C     ------------------------ COMPUTE THE AMPLITUDE --------------------------
      if(((lepflag1.eq.1d0).or.(lepflag1.gt.2d0)).and.
     &     (lepflag2.ge.2d0)) then
         p1q2=Enl11*Enl22-pzl11*pzl22-ptl11*ptl22*dcos(phi12)
      else
         p1q2=Enl11*Enl22-pzl11*pzl22
      endif
      if(((lepflag1.eq.1d0).or.(lepflag1.gt.2d0)).and.
     &     ((lepflag2.eq.1d0).or.(lepflag2.gt.2d0))) then
         p1p2=Enl11*Enl21-pzl11*pzl21-ptl11*ptl21*dcos(phi11)
      else
         p1p2=Enl11*Enl21-pzl11*pzl21
      endif
      if((lepflag1.ge.2d0).and.((lepflag2.eq.1d0).or.
     &     (lepflag2.gt.2d0))) then
         q1p2=Enl12*Enl21-pzl12*pzl21-ptl12*ptl21*dcos(phi21)
      else
         q1p2=Enl12*Enl21-pzl12*pzl21
      endif
      if((lepflag1.ge.2d0).and.(lepflag2.ge.2d0)) then
         q1q2=Enl12*Enl22-pzl12*pzl22-ptl12*ptl22*dcos(phi22)
      else
         q1q2=Enl12*Enl22-pzl12*pzl22
      endif



      mW=dsqrt(mW2)
      mZ=dsqrt(mZ2)

      if(ndecay.eq.4) then !ZZ->l l l' l'
C     ---------------------------
C     H->ZZ->l1 l1bar l2 l2bar amplitude
C     ---------------------------
CCC   Fabian's original implementation -> not fully tested yet
c$$$         ampli=(l2**2*r1**2+l1**2*r2**2)*p1q2*q1p2
c$$$         ampli=ampli+(l1**2*l2**2+r1**2*r2**2)*p1p2*q1q2
c$$$         ampli=ampli*dsqrt(2d0)*(Gf*mZ2)**3/z/gamZ**2/pi**6/2d0**5
c$$$         ampli=ampli*pi/dsqrt(nomm2)/gamH
c$$$         ampli=ampli*squdelm*(z1max-z1min)*(z2max-z2min)
c$$$         constraint=constraint*ampli

         q23=mv12
         q24=2d0*p1p2
         q34=2d0*q1p2
         q25=2d0*p1q2
         q35=2d0*q1q2
         q45=mv22
        

         zampli=MZZeemm(Gf,mW,gamW,mZ,gamZ,q23,q24,q25,q34,q35,q45)
         jac=1d0/(2048d0*mZ2*gamZ**2*pi**3)
         jac=jac*(mv12**2+(gamZ**2-2d0*mv12)*mZ2+mZ2**2)
         jac=jac*(mv22**2+(gamZ**2-2d0*mv22)*mZ2+mZ2**2)
         jac=jac/z*squdelm*(z1max-z1min)*(z2max-z2min)
         jac=jac*(zhmax-zhmin)/dsqrt(nomm2)/gamH

         ampli=jac*dreal(zampli)
CCC   Symmetry factor: Fabian has 1/2, I believe it's 1 ???
         constraint=ampli*constraint
      elseif(ndecay.eq.3) then !l1 l1bar l1 l1bar
C     ---------------------------
C     H->ZZ->l1 l1bar l1 l1bar amplitude
C     ---------------------------

         q23=mv12
         q24=2d0*p1p2
         q25=2d0*q1p2
         q34=2d0*p1q2
         q35=2d0*q1q2
         q45=mv22


         zampli=MZZllll(Gf,mW,gamW,mZ,gamZ,q23,q24,q25,q34,q35,q45)
         jac=1d0/(2048d0*mZ2*gamZ**2*pi**3)
         jac=jac*(mv12**2+(gamZ**2-2d0*mv12)*mZ2+mZ2**2)
         jac=jac*(mv22**2+(gamZ**2-2d0*mv22)*mZ2+mZ2**2)
         jac=jac/z*squdelm*(z1max-z1min)*(z2max-z2min)
         jac=jac*(zhmax-zhmin)/dsqrt(nomm2)/gamH

         ampli=jac*dreal(zampli)
CCC   Symmetry factor: I believe it's 1/4 ???
         constraint=ampli/4d0*constraint

      elseif (ndecay.eq.1.or.ndecay.eq.2) then
C     ---------------------------
C     H->WW/ZZ->lnulnu amplitude
C     ---------------------------
CCC   Fabian's original implementation
c$$$         ampli=p1q2*q1p2        
c$$$         ampli=ampli*dsqrt(2d0)*(Gf*mW2)**3/z/gamW**2/pi**6/2d0**3
c$$$         ampli=ampli*squdelm*(z1max-z1min)*(z2max-z2min)
c$$$         ampli=ampli*pi/dsqrt(nomm2)/gamH

         q23=mv12
         q24=2d0*p1q2
         q25=2d0*p1p2
         q34=2d0*q1q2
         q35=2d0*q1p2
         q45=mv22

         zampli=MWWlnln(Gf,mW,gamW,mZ,gamZ,q23,q24,q25,q34,q35,q45)
         if (ndecay.eq.2) then
CCC   M->ZZ->3*(nu nubar) + l lbar
CCC   M->ZZWW->nul nubarl l lbar
            zampli=1d0*zampli
     $      +3d0*MZZlnln(Gf,mW,gamW,mZ,gamZ,q23,q24,q25,q34,q35,q45)
     $      +1d0*MWWZZlnln(Gf,mW,gamW,mZ,gamZ,q23,q24,q25,q34,q35,q45)
         endif
         jac=1d0/(2048d0*mW2*gamW**2*pi**3)
         jac=jac*(mv12**2+(gamW**2-2d0*mv12)*mW2+mW2**2)
         jac=jac*(mv22**2+(gamW**2-2d0*mv22)*mW2+mW2**2)
         jac=jac/z*squdelm*(z1max-z1min)*(z2max-z2min)
         jac=jac*(zhmax-zhmin)/dsqrt(nomm2)/gamH

         ampli=jac*dreal(zampli)

         constraint=ampli*constraint
      endif


C ------------ CALL EXTERNAL CUT FUNCTION TO APPLY ADDITIONAL CUTS AND
C     FILL HISTOGRAMS
        
           ! do pass=1,11
           !     print*,pass," | ",part(pass,1),part(pass,2),part(pass,3),part(pass,4)
           ! enddo
                 constraint=constraint*1d6
      constraint=constraint*
     &     externalCuts(part,constraint*Tcoeff,lums)


C      write(*,*) phi11, dilepmass
C      write(*,*) '----------------'
C ============== NEW TO FILL HISTOGRAMS ====================
C      write(*,*) phi11
C     find right bin
C      HphillBin=phi11/pi*18+1
C      Hphill(HphillBin)=Hphill(HphillBin)+constraint*Tcoeff
C      Hphill(1)=Hphill(1)+constraint*Tcoeff
C      write(*,*) HphillBin

C      constraint=constraint
      
C      write(*,*) ' ***  ',topflag, Vflag, lepflag1, lepflag2
C      write(*,*) '      ',constraint

      return
      end
