      double precision function constraintgg(var,qqq,ndim,zdim,z,x1,x2,
     & s13,s23,s14,s24,s34,s1v,s2v,s3v,s4v,Tcoeff,lums)
C      implicit double precision(a-h,o-z)
      implicit none
      INTEGER ndim,zdim,prodim
      double precision Tcoeff
      double precision var(ndim)
      double precision qqq(zdim)
      double precision Gf

      COMMON/blockprodim/Gf, prodim

C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. gamma1
C        3. 
C        4. 
C        5. gamma2
C        6. 
C        7. 
C        8. part1  /  part1
C        9. part2  /  part2
C        10. jet1  /  jet1
C        11. jet2  /  jet2

      double precision part(11,4)
C      COMMON/particles/part
C --------------------------------------------------
      double precision externalCuts
      external externalCuts

      double precision zhmin,zhmax

      double precision z,x1,x2,s13,s23,s14,s24,s34,
     & s1v,s2v,s3v,s4v

      double precision zn, s34n, s1vn, s2vn, s3vn, s4vn

C      double precision rapu,rapd,pTu,pTd,m2,scm
C      INTEGER gnjet

      double precision pi
      parameter(pi = 3.1415926536d0)

      double precision aux, aux1, aux2
      
      double precision pt3, pt4, pT
      double precision En3, En4, En
      double precision pz3, pz4, pZ

      double precision Y, eta3, eta4
      double precision etar, ptr

      double precision ptbuf, topflag
      double precision photonflag 

CCC   parton angles ...
      double precision cosr, cos3, cos4, cos34
      double precision phi3, phi4, phi34, phir
      double precision totphi3, totphi4, totphir

CCC   Generating phase space
      double precision xlambda, B1, B2, Ome
      double precision FFF, Discr 
      double precision s2anorm, s2bnorm, s1anorm, s1bnorm
      double precision s2a, s2b, s1a, s1b

CCC   Photon momenta
      double precision Ena, Enb, pza, pzb
      double precision ptga, ptgb, etaa, etab
      double precision pta,ptb

CCC   Photon angles
      double precision cosa, cosb, phia, phib
      double precision totphia,totphib

      double precision djack

      double precision Rmax, R34
      double precision ptlead, ptfoll
      double precision Etmax, Risol
      double precision Rar, Rbr
      double precision R3a, R3b, R4a, R4b
      double precision xlambda4
      double precision Ethada, Ethadb
      double precision pt34
      double precision etag1, etag2, ptg1, ptg2
      double precision phira, phirb, phi3a, phi3b, phi4a, phi4b



      double precision pt_sym, pt_sym_min, pt_sym_max
      double precision eta_diff, eta_diff_min, eta_diff_max
      double precision weight
      integer i,j

CCC   variable buffers
      double precision varbuf
      integer counter, numJets

      double precision ptjet, ptjet2, etajet, etajet2, phi
      double precision phijet, cosphijet, totphijet
      double precision phijet2, cosphijet2, totphijet2
      double precision EnJet, EnJet2, pzJet, pzJet2

      double precision J1px, J1py, J2px, J2py


c$$$C==================  CUT CONTROL ================================      
c$$$      double precision Ymin,Ymax,pTmin,pTmax
c$$$      COMMON/cutcontrol/ Ymin,Ymax,pTmin,pTmax
c$$$C================================================================

C     ------------------------ PDF errors ------------------------
      integer NSMax
      parameter(NSMax=50)

      double precision lums(0:NSMax,0:2)


      include 'cutcontrol.f'
      include 'masses.f'
      include 'constants.f'


      double precision JetDefConeSizeNew
      


CCCC========================================================      
CCCC  Generate the phase-space variables for the decay 
CCCC  H -> gamma1 gamma2 (NO USER INPUT REQUIRED)

      constraintgg=1d0

C ------------------ set particle adat top zero (fool-proof)
      counter=1
      do while(counter.lt.12)
         part(counter,1)=0d0
         part(counter,2)=0d0
         part(counter,3)=0d0
         part(counter,4)=0d0
         counter=counter+1
      enddo


      xlambda4 = var(prodim+1)      
      B1=z-s1v
      B2=z-s2v
      Ome = dabs(B1*B2-z)
      FFF = dsqrt(z*Ome*xlambda4*dabs(1d0-xlambda4))
      Discr =-FFF*cos(pi*var(prodim+2))      
      s2anorm = xlambda4 
      s2bnorm = (1d0-xlambda4)
      s1anorm = xlambda4*Ome + z*(1d0-xlambda4)+2d0*Discr
      s1bnorm= (1d0-xlambda4)*Ome + z*xlambda4-2d0*Discr
C
C    Photon+beam (a,b)*(1,2) invariant mass combinations 
C     
      s2a=-s2anorm*B2
      s2b=-s2bnorm*B2
      s1a=-s1anorm/B2
      s1b=-s1bnorm/B2

CCC   =====================================================
CCC   Form observable quantities  (energies, pt, eta, etc)
CCC   (NO USER INPUT REQUIRED)
CCC   =====================================================      
            
CCC   The transverse momenta of all final-states
      
      pt3 = dsqrt(dabs(x1*x2*scm*s13*s23))
      pt4 = dsqrt(dabs(x1*x2*scm*s14*s24))
      pT  = dsqrt(dabs(x1*x2*scm*((s1v-z)*(s2v-z)-z)))
      
CCC   The energies of all final-states
      
      En3 = - 0.5d0*dsqrt(scm)*(x2*s13+x1*s23)
      En4 = - 0.5d0*dsqrt(scm)*(x2*s14+x1*s24)
      En  = - 0.5d0*dsqrt(scm)*(x2*(s1v-z)+x1*(s2v-z))
      
CCC   The z-momenta of all final-states
      
      pz3 = 0.5d0*dsqrt(scm)*(x2*s13-x1*s23) 
      pz4 = 0.5d0*dsqrt(scm)*(x2*s14-x1*s24) 
      pZ  = 0.5d0*dsqrt(scm)*((s1v-z)*x2-(s2v-z)*x1)
      
CCC   The rapidity of the Higgs is 
      
      Y = 0.5*dlog((En+pZ)/(En-pZ))
CCCC ===============  photon variables ===============      
C     photon energies
C     
      Ena = - 0.5d0*dsqrt(scm)*(x2*s1a+x1*s2a)
      Enb = - 0.5d0*dsqrt(scm)*(x2*s1b+x1*s2b)

C     photon z-momenta
C     
      pza = 0.5d0*dsqrt(scm)*(x2*s1a-x1*s2a)
      pzb = 0.5d0*dsqrt(scm)*(x2*s1b-x1*s2b)  
      
CC    photon transverse momenta
      
      ptga = dsqrt(dabs(x1*x2*scm*s1a*s2a))
      ptgb = dsqrt(dabs(x1*x2*scm*s1b*s2b))

C      write(6,*)'! ',ptga,ptgb

C      write(*,*)
C      write(*,*) 'Higgs:   E =',En
C      write(*,*) '        pZ =',pZ
C      write(*,*) '        pT =',pT
C      write(*,*) '         M =',dsqrt(En**2-pZ**2-pT**2)
C      write(*,*)


C     --------- PARTICLES FILL -----------
      part(1,1)=En
      part(1,4)=pZ
      part(8,1)=En3
      part(8,4)=pz3
      part(9,1)=En4
      part(9,4)=pz4
C     ------------------------------------      

C     ~~~~~~~~~~~~~~~~~~~~~  CUT SECTION  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     ***   CUT on higgs pT
      if((constraintgg.gt.0.5d0).and.(CutHiggsPt.gt.0.5d0)) then
         if((pT.lt.HiggsPtMin).or.(pT.gt.HiggsPtMax)) then
            constraintgg=0d0
            return
         endif
      endif

C     ***   CUT on Higgs rapidity
      if((constraintgg.gt.0.5d0).and.(CutHiggsEta.gt.0.5d0)) then
         if(dabs(Y).gt.HiggsEtaMax) then
            constraintgg=0d0
            return
         endif
      endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      
CCC  Use a pt-buffer to separate configurations with 
CCC   different parton multiplicities (0, 1, 2 extra partons)
CCC   NOT A USER INPUT: this is not a cutoff for an approximation;
CCC   it is only a flag to mark regions of the phase-space
CCC   with different properties!!!!
      
      ptbuf=0.01d0
      
CCC   This flag denotes the multiplicity in the final state
C     topflag:
C     0d0  -> Higgs + 0 hard partons
C     1d0  -> Higgs + 1 hard parton (3)
C     1d0  -> Higgs + 1 hard parton (4)
C     2d0  -> Higgs (pT>0) + 2 hard partons
C     3d0  -> Higgs (pT=0) + 2 hard (balancing pT) partons
C     
CCC   For each configuration you define all angles among 
CCC   all particles in the ``visible'' final-state
CCC   

      if(((pt3.lt.ptbuf).and.(pt4.lt.ptbuf)).or. 
     .     ((pT.lt.ptbuf).and.((pt3.lt.ptbuf).or.(pt4.lt.ptbuf)))) then
C     ----------------------------------------------------------------
C     topflag = 0d0
C     --> Higgs pT=0
C     --> gamma's back-to-back
C     --> gamma1 phi-reference candidate
C     ---------------------------------------------------------------- 
         
         topflag=0d0
         pT=0d0
         numJets=0
C     ***************  NO JET-VETO ********************************

C     ***************  NO TEV-VETO ********************************

      else if ((pt3.gt.ptbuf).and.(pt4.lt.ptbuf)) then 
C     ----------------------------------------------------------------
C     topflag = 1d0
C     --> Higgs-parton3 back-to-back
C     --> Higgs is phi-reference
C     ----------------------------------------------------------------          
         topflag=1d0 
         ptr=pt3
         etar=0.5d0*dlog((En3+pz3)/(En3-pz3))
         phir=pi
         totphir=pi
C     --------- PARTICLES FILL -----------
         part(1,2)=pT
         part(1,3)=0d0
         part(8,2)=-ptr
         part(8,3)=0d0
         part(9,2)=0d0
         part(9,3)=0d0
C     ------------------------------------

C     --------------------  JET DEFINITION -----------------------------
         if((pt3.gt.JetDefPtMin).and.(dabs(eta3).lt.JetDefEtaMax)) then
            ptjet=pt3
            EnJet=En3
            pzJet=pz3
            etajet=0.5d0*dlog((En3+pz3)/(En3-pz3))
            phijet=pi
            cosphijet=-1d0
            totphijet=pi
            numJets=1
         else
            numJets=0
         endif
C     -------------------------------------------------------------------
         
C     ~~~~~~~~~~~~~~~~~~~~~  JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
            if(numJets.gt.0) then
               if((ptjet.gt.JetVetoPtMax).and.
     .              (dabs(etajet).lt.JetVetoEtaMax)) then
                  constraintgg=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
            if(numJets.gt.maxNumJets) then
               constraintgg=0d0
               return
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         
         
C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
            if(numJets.eq.1) then
               if(ptjet.gt.TevJetOnePtMax) then
                  constraintgg=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


      else if ((pt4.gt.ptbuf).and.(pt3.lt.ptbuf)) then
C     ----------------------------------------------------------------
C     topflag = 1d0
C     --> Higgs-parton4 back-to-back
C     --> Higgs is phi-reference
C     ----------------------------------------------------------------  
         topflag=1d0
         
         ptr=pt4
         etar=0.5d0*dlog((En4+pz4)/(En4-pz4))
         phir=pi
         totphir=pi
C     --------- PARTICLES FILL -----------
         part(1,2)=pT
         part(1,3)=0d0
         part(9,2)=-ptr
         part(9,3)=0d0
         part(8,2)=0d0
         part(8,3)=0d0
C     ------------------------------------
C     --------------------  JET DEFINITION -----------------------------
         if((pt4.gt.JetDefPtMin).and.(dabs(eta4).lt.JetDefEtaMax)) then
            ptjet=pt4
            EnJet=En4
            pzJet=pz4            
            etajet=eta4
            phijet=pi
            cosphijet=-1d0
            totphijet=pi
            numJets=1
         else
            numJets=0
         endif
C     -------------------------------------------------------------------
         
C     ~~~~~~~~~~~~~~~~~~~~~~ JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
            if(numJets.gt.0) then
               if((ptjet.gt.JetVetoPtMax).and. 
     .              (dabs(etajet).lt.JetVetoEtaMax)) then
                  constraintgg=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
            if(numJets.gt.maxNumJets) then
               constraintgg=0d0
               return
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
            if(numJets.eq.1) then
               if(ptjet.gt.TevJetOnePtMax) then
                  constraintgg=0d0
                  return
               endif
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      else if ((pt3.gt.ptbuf).and.(pt4.gt.ptbuf)) then
         
         if (pT.gt.(0.1d0*ptbuf)) then 
C     ----------------------------------------------------------------
C     topflag = 2d0
C     --> both gluons and Higgs are hard
C     --> Higgs is phi-reference
C     ----------------------------------------------------------------    
            
            topflag=2d0
            
            eta3 = 0.5d0*dlog((En3+pz3)/(En3-pz3))
            eta4 = 0.5d0*dlog((En4+pz4)/(En4-pz4))
            cos3 = (En3*En-pz3*pZ-0.5d0*(s3v-z)*x1*x2*scm)/pt3/pT
            cos4 = (En4*En-pz4*pZ-0.5d0*(s4v-z)*x1*x2*scm)/pt4/pT
            cos34 = (En3*En4-pz3*pz4-0.5d0*s34*x1*x2*scm)/pt3/pt4
            
            if (cos3.lt.(-1d0)) then 
               cos3=-1d0
            else if (cos3.gt.(1d0)) then 
               cos3=1d0
            endif
            if (cos4.lt.(-1d0)) then 
               cos4=-1d0
            else if (cos4.gt.(1d0)) then 
               cos4=1d0
            endif
            if (cos34.lt.(-1d0)) then 
               cos34=-1d0
            else if (cos34.gt.(1d0)) then 
               cos34=1d0
            endif
            phi3=dacos(cos3)
            phi4=dacos(cos4)
            phi34=dacos(cos34)
            if (var(prodim+3).gt.0.5d0) then
               totphi3=phi3
               totphi4=2d0*pi-phi4
            else
               totphi3=2d0*pi-phi3
               totphi4=phi4
            endif
               
C     --------- PARTICLES FILL -----------
            part(1,2)=pT
            part(1,3)=0d0
            part(8,2)=pt3*dcos(totphi3)
            part(8,3)=pt3*dsin(totphi3)
            part(9,2)=pt4*dcos(totphi4)
            part(9,3)=pt4*dsin(totphi4)
C     ------------------------------------

C     ---------------  JET DEFINITION ------------------------------------
            R34 = dsqrt(phi34**2d0+(eta3-eta4)**2d0)            
            
C            write(*,*) '  R34 = ',R34

            if(UseSISCone.gt.0.5d0) then
               if(pt3.lt.pt4) then 
                  JetDefConeSizeNew=(1.0+pt3/pt4)*JetDefConeSize
               else
                  JetDefConeSizeNew=(1.0+pt4/pt3)*JetDefConeSize
               endif
            else
               JetDefConeSizeNew=JetDefConeSize
            endif
 
C            write(*,*) 'Cone Size =',JetDefConeSizeNew
           
            if(R34.lt.JetDefConeSizeNew) then
               ptjet=dsqrt(pt3**2+pt4**2+2d0*pt3*pt4*cos34)
C               write(*,*) '  ptjet = ',ptjet
               etajet=0.5d0*dlog((En3+En4+pz3+pz4)/(En3+En4-pz3-pz4))
               EnJet=En3+En4
               pzJet=pz3+pz4


C     -- compute totphi jet combined ------- using the var. Jipj temporary

               J1px=pt3*dcos(totphi3)
               J2px=pt4*dcos(totphi4)
               J1px=J1px+J2px
               
C               write(*,*) ' ************** '

C               write(*,*) pt3, pt4, totphi3, totphi4

C               write(*,*) J1px, J2px

               J1py=pt3*dsin(totphi3)
               J2py=pt4*dsin(totphi4)
               J1py=J1py+J2py

C               write(*,*) J1py, J2py
               
               J1px=J1px/ptjet
               if(J1px.lt.-1d0) J1px=-1d0
               if(J1px.gt.1d0) J1px=1d0

               totphijet=dacos(J1px)
               if(J1py.lt.0d0) totphijet=2d0*pi-totphijet

               if((ptjet.gt.JetDefPtMin).and.
     .              (dabs(etajet).lt.JetDefEtaMax)) then
                  numJets=1
               else
                  numJets=0
               endif
            else
               numJets=0
               if((pt3.gt.JetDefPtMin).and.
     .              (dabs(eta3).lt.JetDefEtaMax)) then
                  ptjet=pt3
                  EnJet=En3
                  pzJet=pz3
                  etajet=eta3
                  numJets=1
                  totphijet=totphi3
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     ptjet2=pt4
                     EnJet2=En4
                     pzJet2=pz4
                     etajet2=eta4
                     totphijet2=totphi4
                     numJets=2
                  endif
               else
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     EnJet=En4
                     pzJet=pz4
                     ptjet=pt4
                     etajet=eta4
                     totphijet=totphi4
                     numJets=1
                  endif
               endif
            endif

C            write(*,*) ' test = ',ptjet

C     --------------------------------------------------------------------
            
C     ~~~~~~~~~~~~~~~~~~~~~  JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraintgg.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
               if(numJets.gt.0) then
                  if((ptjet.gt.JetVetoPtMax).and.
     .                 (dabs(etajet).lt.JetVetoEtaMax)) then
                     constraintgg=0d0
                     return
                  endif
                  if(numJets.eq.2) then
                     if((ptjet2.gt.JetVetoPtMax).and.
     .                    (dabs(etajet2).lt.JetVetoEtaMax)) then
                        constraintgg=0d0
                        return
                     endif
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         if((constraintgg.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
            if(numJets.gt.maxNumJets) then
               constraintgg=0d0
               return
            endif
         endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraintgg.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
               if(numJets.eq.1) then
                  if(ptjet.gt.TevJetOnePtMax) then
                     constraintgg=0d0
                     return
                  endif
               else if(numJets.eq.2) then
                  if(((ptjet.gt.TevJetTwoPtMax).or.
     .                 (ptjet2.gt.TevJetTwoPtMax))) then
                     constraintgg=0d0
                     return
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

         else
C     ----------------------------------------------------------------
C     topflag = 3d0
C     --> both gluons, no Higgs pT
C     --> gluons back-to-back
C     --> gluon 3 is phi-reference
C     ---------------------------------------------------------------- 
            topflag=3d0
            eta3 = 0.5d0*dlog((En3+pz3)/(En3-pz3))
            eta4 = 0.5d0*dlog((En4+pz4)/(En4-pz4))
            phi34=pi
            totphi3=0d0
            totphi4=phi34 
C     --------- PARTICLES FILL -----------
            part(1,2)=0d0
            part(1,3)=0d0
            part(8,2)=pt3
            part(8,3)=0d0
            part(9,2)=-pt4
            part(9,3)=0d0
C     ------------------------------------
C     ---------------  JET DEFINITION (probably silly, but foolproof) ---
            R34 = dsqrt(phi34**2d0+(eta3-eta4)**2d0)            
            
            if(UseSISCone.gt.0.5d0) then
               if(pt3.lt.pt4) then 
                  JetDefConeSizeNew=(1.0+pt3/pt4)*JetDefConeSize
               else
                  JetDefConeSizeNew=(1.0+pt4/pt3)*JetDefConeSize
               endif
            else
               JetDefConeSizeNew=JetDefConeSize
            endif
            
            if(R34.lt.JetDefConeSizeNew) then
               ptjet=dsqrt(pt3**2+pt4**2+2d0*pt3*pt4*cos34)
               etajet=0.5d0*dlog((En3+En4+pz3+pz4)/(En3+En4-pz3-pz4))


C     -- compute totphi jet combined ------- using the var. Jipj temporary

               J1px=pt3*dcos(totphi3)
               J2px=pt4*dcos(totphi4)
               J1px=J1px+J2px
               
C               write(*,*) ' ************** '

C               write(*,*) pt3, pt4, totphi3, totphi4

C               write(*,*) J1px, J2px

               J1py=pt3*dsin(totphi3)
               J2py=pt4*dsin(totphi4)
               J1py=J1py+J2py

C               write(*,*) J1py, J2py
               
               J1px=J1px/ptjet
               if(J1px.lt.-1d0) J1px=-1d0
               if(J1px.gt.1d0) J1px=1d0

               totphijet=dacos(J1px)
               if(J1py.lt.0d0) totphijet=2d0*pi-totphijet

               if((ptjet.gt.JetDefPtMin).and.
     .              (dabs(etajet).lt.JetDefEtaMax)) then
                  numJets=1
               else
                  numJets=0
               endif
            else
               numJets=0
               if((pt3.gt.JetDefPtMin).and.
     .              (dabs(eta3).lt.JetDefEtaMax)) then
                  ptjet=pt3
                  etajet=eta3
                  totphijet=totphi3
                  numJets=1
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     ptjet2=pt4
                     etajet2=eta4
                     totphijet2=totphi4
                     numJets=2
                  endif
               else
                  if((pt4.gt.JetDefPtMin).and.
     .                 (dabs(eta4).lt.JetDefEtaMax)) then
                     ptjet=pt4
                     etajet=eta4
                     totphijet=totphi4
                     numJets=1
                  endif
               endif
            endif
C     --------------------------------------------------------------------
            
C     ~~~~~~~~~~~~~~~~~~~~~  JET-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraintgg.gt.0.0d0).and.(CutJetVeto.gt.0.5d0)) then
               if(numJets.gt.0) then
                  if((ptjet.gt.JetVetoPtMax).and.
     .                 (dabs(etajet).lt.JetVetoEtaMax)) then
                     constraintgg=0d0
                     return
                  endif
                  if(numJets.eq.2) then
                     if((ptjet2.gt.JetVetoPtMax).and.
     .                    (dabs(etajet2).lt.JetVetoEtaMax)) then
                        constraintgg=0d0
                        return
                     endif
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

C     ~~~~~~~~~~~~~~~~~~~~~  NUM-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraintgg.gt.0.0d0).and.(CutNumVeto.gt.0.5d0)) then
               if(numJets.gt.maxNumJets) then
                  constraintgg=0d0
                  return
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
C     ~~~~~~~~~~~~~~~~~~~~~  TEV-VETO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            if((constraintgg.gt.0.0d0).and.(CutTevVeto.gt.0.5d0)) then
               if(numJets.eq.1) then
                  if(ptjet.gt.TevJetOnePtMax) then
                     constraintgg=0d0
                     return
                  endif
               else if(numJets.eq.2) then
                  if(((ptjet.gt.TevJetTwoPtMax).or.
     .                 (ptjet2.gt.TevJetTwoPtMax))) then
                     constraintgg=0d0
                     return
                  endif
               endif
            endif
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            

         endif
      end if

C     --------- PARTICLES FILL -----------
      if(numJets.eq.1) then
         part(10,1)=EnJet
         part(10,2)=ptjet*dcos(totphijet)
         part(10,3)=ptjet*dsin(totphijet)
         part(10,4)=pzJet
      endif

      if(numJets.eq.2) then
         if(ptjet.gt.ptjet2) then
            part(10,1)=EnJet
            part(10,2)=ptjet*dcos(totphijet)
            part(10,3)=ptjet*dsin(totphijet)
            part(10,4)=pzJet
            part(11,1)=EnJet2
            part(11,2)=ptjet2*dcos(totphijet2)
            part(11,3)=ptjet2*dsin(totphijet2)
            part(11,4)=pzJet2
         else
            part(11,1)=EnJet
            part(11,2)=ptjet*dcos(totphijet)
            part(11,3)=ptjet*dsin(totphijet)
            part(11,4)=pzJet
            part(10,1)=EnJet2
            part(10,2)=ptjet2*dcos(totphijet2)
            part(10,3)=ptjet2*dsin(totphijet2)
            part(10,4)=pzJet2
         endif
      endif
C     ------------------------------------

C     ------------------------------------------------------------------------
C     if there is no decay --> return
      if(ndecay.eq.0) then
         constraintgg=constraintgg*
     &        externalCuts(part,constraintgg*Tcoeff,lums)
         return
      endif
C     ------------------------------------------------------------------------
      
C     We divide the photon decay configurations into 
C     two classes: 
C     two hard photons (photonflag = 2) with pT=0
C     two hard photons (photonflag = 1) with pT>0
C     at least one low-pt photon (photonflag=0)
      
      if ((ptga.lt.ptbuf).or.(ptgb.lt.ptbuf)) then 
         photonflag=0d0
CCC   -> no need for describing kinematics
C         write(6,*)'photonflag=0'

         etaa = 0.5d0*dlog((Ena+pza)/(Ena-pza))
         etab = 0.5d0*dlog((Enb+pzb)/(Enb-pzb))

         if (ptga.ge.ptbuf) then
            cosa = (En*Ena-pZ*pza-m2/2d0)/pT/ptga
         else
            cosa=1d0
         endif
         if (ptgb.ge.ptbuf) then
            cosb = (En*Enb-pZ*pzb-m2/2d0)/pT/ptgb
         else
            cosb=-1d0
         endif
         if (cosa.lt.(-1d0)) then 
            cosa=-1d0
         else if (cosa.gt.(1d0)) then 
            cosa=1d0
         endif            
         if (cosb.lt.(-1d0)) then 
            cosb=-1d0
         else if (cosb.gt.(1d0)) then 
            cosb=1d0
         endif

         phia = dacos(cosa)
         phib = dacos(cosb)
         totphia=phia
         totphib=2d0*pi-phib

      else 
         if (pT.gt.ptbuf) then 
            photonflag=1d0
            
            etaa = 0.5d0*dlog((Ena+pza)/(Ena-pza))
            etab = 0.5d0*dlog((Enb+pzb)/(Enb-pzb))
            
            cosa = (En*Ena-pZ*pza-m2/2d0)/pT/ptga
            cosb = (En*Enb-pZ*pzb-m2/2d0)/pT/ptgb
            if (cosa.lt.(-1d0)) then 
               cosa=-1d0
            else if (cosa.gt.(1d0)) then 
               cosa=1d0
            endif            
            if (cosb.lt.(-1d0)) then 
               cosb=-1d0
            else if (cosb.gt.(1d0)) then 
               cosb=1d0
            endif
            
            phia = dacos(cosa)
            phib = dacos(cosb)
            totphia=phia
            totphib=2d0*pi-phib

            
         else 
C     C    balancing pt's for the photons
            photonflag=2d0
            etaa = 0.5d0*dlog((Ena+pza)/(Ena-pza))
            etab = 0.5d0*dlog((Enb+pzb)/(Enb-pzb))
            phia=pi*var(prodim+3)
            phib=phia+pi
c$$$            if (var(prodim+3).lt.0.5d0) then
c$$$               phib=phia+pi
c$$$            else
c$$$               phib=phia-pi
c$$$            endif
            if (topflag.eq.0d0) then
C               totphia=0d0
C               totphib=pi
               totphia=phia
               totphib=phib
            elseif (topflag.eq.3d0) then
               totphia=totphi3-phia
               totphib=totphi3-phib
            endif

         endif         
      endif

C     --------- PARTICLES FILL -----------
      part(2,1)=Ena
      part(2,4)=pza
      part(5,1)=Enb
      part(5,4)=pzb
C     ------------------------------------

c$$$      if (var(prodim+3).gt.0.5d0) then
c$$$         totphia=2d0*pi-totphia
c$$$         totphib=2d0*pi-totphib
c$$$      endif

      
C========================================================
C   Generate azimuthal angles between photons and gluons: 
C   It requires photonflag>0 and topflag>0 
C
      if (photonflag.gt.0d0) then 
         

         if (topflag.eq.1d0) then 
            phira = pi-totphia 
            phirb = pi-totphib
         endif
         
         if (topflag.gt.1d0) then 
c$$$            if (var(prodim+3).gt.(0.5d0)) then               
c$$$               phi3a=dsqrt((phi3-totphia)**2)
c$$$               phi3b=dsqrt((2d0*pi-phi3-totphib)**2)
c$$$               phi4a=dsqrt((2d0*pi-phi4-totphia)**2)
c$$$               phi4b=dsqrt((phi4-totphib)**2)
c$$$            else 
c$$$               phi3a=dsqrt((2d0*pi-phi3-totphia)**2)
c$$$               phi3b=dsqrt((phi3-totphib)**2)
c$$$               phi4a=dsqrt((phi4-totphia)**2)
c$$$               phi4b=dsqrt((2d0*pi-phi4-totphib)**2)               
c$$$            endif
               phi3a=dsqrt((totphi3-totphia)**2)
               phi3b=dsqrt((totphi3-totphib)**2)
               phi4a=dsqrt((totphi4-totphia)**2)
               phi4b=dsqrt((totphi4-totphib)**2)
         endif

      endif

      if (photonflag.ge.0d0) then
C     --------- PARTICLES FILL -----------
         part(2,2)=ptga*dcos(totphia)
         part(2,3)=ptga*dsin(totphia)
         part(5,2)=ptgb*dcos(totphib)
         part(5,3)=ptgb*dsin(totphib)
C     ------------------------------------
      endif

c$$$      write(6,*)topflag,photonflag
c$$$      write(6,*)ptga,ptgb
c$$$      write(6,*)totphia,dcos(totphia),dsin(totphia)
c$$$      write(6,*)totphib,dcos(totphib),dsin(totphib)
c$$$      write(6,*)'pa= ',part(2,1),part(2,2),part(2,3),part(2,4)
c$$$      write(6,*)'pb= ',part(5,1),part(5,2),part(5,3),part(5,4)

CCC     CUTS ON THE PHOTONS ===========================

      
      if ((constraintgg.gt.0.5d0).and.(CutPhotBasic.gt.0.5d0)) then
         if (ptga.gt.ptgb) then 
            ptlead = ptga
            ptfoll = ptgb
         else 
            ptlead = ptgb
            ptfoll = ptga
         endif

         if ((ptlead.lt.ptg1m).or.(ptfoll.lt.ptg2m)) then 
            constraintgg = 0d0
            return
         endif


         if (constraintgg.gt.0.5d0) then 
            if ((dabs(etaa).gt.etagM).or.(dabs(etab).gt.etagM)) then 
               constraintgg = 0d0
               return
            endif
         endif

      endif
      
CC    Simple cone isolation cuts; they are applied on top 
CC    of the basic photon cuts. Require hadronic activity with 
CC    transverse energy less than Etmax in a cone of size Risol.

      if ((constraintgg.gt.0.5d0).and.(CutPhotIsol.gt.0.5d0)) then
         Risol=PhotIsolationCone
         Etmax=PhotETmax

         pt34=pt3+pt4
         if (pt34.lt.Etmax) then 
            constraintgg = 1d0 
         else 
            if (topflag.eq.0d0) then 
               constraintgg = 1d0               
            elseif (topflag.eq.1d0) then 
               if (ptr.lt.Etmax) then 
                  constraintgg = 1d0 
               else
                  
                  Rar = dsqrt((phira)**2 +(etaa-etar)**2)
                  Rbr = dsqrt((phirb)**2 +(etab-etar)**2)
                  
                  if ((Rar.lt.Risol).or.(Rbr.lt.Risol)) then                   
                     constraintgg = 0d0
                     return
                  endif
                  
               endif
            elseif (topflag.eq.2d0) then
               
               
               R3a=dsqrt(phi3a**2+(eta3-etaa)**2)
               R3b=dsqrt(phi3b**2+(eta3-etab)**2)
               R4a=dsqrt(phi4a**2+(eta4-etaa)**2)
               R4b=dsqrt(phi4b**2+(eta4-etab)**2)
               
               
               if ((R3a.lt.Risol).and.(R4a.lt.Risol)) then 
                  Ethada = pt3+pt4
               elseif  ((R3a.lt.Risol).and.(R4a.gt.Risol)) then 
                  Ethada = pt3 
               elseif  ((R4a.lt.Risol).and.(R3a.gt.Risol)) then 
                  Ethada = pt4
               else 
                  Ethada =0d0
               endif
               
               
               if ((R3b.lt.Risol).and.(R4b.lt.Risol)) then 
                  Ethadb = pt3+pt4
               elseif  ((R3b.lt.Risol).and.(R4b.gt.Risol)) then 
                  Ethadb = pt3 
               elseif  ((R4b.lt.Risol).and.(R3b.gt.Risol)) then 
                  Ethadb = pt4
               else 
                  Ethadb =0d0
               endif
               
               if ((Ethada.lt.Etmax).and.(Ethadb.lt.Etmax)) then 
                  constraintgg = 1d0
               else
                  constraintgg = 0d0
                  return
               endif
               
               
            elseif (topflag.eq.3d0) then 
               if (pt3.lt.Etmax) then 
                  constraintgg = 1d0
               else 
                  
                  
               
                  R3a=dsqrt(phi3a**2+(eta3-etaa)**2)
                  R3b=dsqrt(phi3b**2+(eta3-etab)**2)
                  R4a=dsqrt(phi4a**2+(eta4-etaa)**2)
                  R4b=dsqrt(phi4b**2+(eta4-etab)**2)
              
                  if ((R3a.lt.Risol).and.(R4a.lt.Risol)) then 
                     Ethada = pt3+pt4
                  elseif  ((R3a.lt.Risol).and.(R4a.gt.Risol)) then 
                     Ethada = pt3 
                  elseif  ((R4a.lt.Risol).and.(R3a.gt.Risol)) then 
                     Ethada = pt4
                  else 
                     Ethada =0d0
                  endif
                              
                  if ((R3b.lt.Risol).and.(R4b.lt.Risol)) then 
                     Ethadb = pt3+pt4
                  elseif  ((R3b.lt.Risol).and.(R4b.gt.Risol)) then 
                     Ethadb = pt3 
                  elseif  ((R4b.lt.Risol).and.(R3b.gt.Risol)) then 
                     Ethadb = pt4
                  else 
                     Ethadb =0d0
                  endif
                  
                  if ((Ethada.lt.Etmax).and.(Ethadb.lt.Etmax)) then 
                     constraintgg = 1d0
                  else
                     constraintgg = 0d0
                     return
                  endif               
               endif
            endif
         endif
      endif
      

CCC  Cuts on pt of the softer photon
CCC  

      if ((constraintgg.gt.(0.1d0)).and.(ptsoftcut.gt.0.5d0)) then 
         
         if(ptga<ptgb) then
            pt_sym = ptga
         else   
            pt_sym = ptgb      
         endif
         
         if (pt_sym.lt.ptsoftmin) then 
            constraintgg=0d0
            return
         endif
         constraintgg=constraintgg
         
      endif
      

CCC  Cuts on the average pt of the photons (hadron-hadron frame)
CCC  

      if ((constraintgg.gt.(0.1d0)).and.(ptmcut.gt.0.5d0)) then 

CCC-------- insert values -------------
         pt_sym_min = ptmmin
         pt_sym_max = ptmmax
CCC   ------------------------------------
         
         pt_sym = 0.5d0*(ptga+ptgb)         
         
         if ((pt_sym.gt.pt_sym_max).or.(pt_sym.lt.pt_sym_min)) then 
            constraintgg=0d0
            return
         endif
         constraintgg=constraintgg
         
      endif
      
      
CCC   Cuts on the pseudo rapidity of higher energetic photons
CCC   
      if ((constraintgg.gt.(0.1d0)).and.
     $     (constraintgg.lt.CutPhotEtaHigh)) then 
       
C     C------ insert values --------
         eta_diff_min = EtaDiff_min 
         eta_diff_max = EtaDiff_max
C     C------------------------------         

         if(ptga>ptgb) then
            eta_diff = abs(etaa)
         else
            eta_diff = abs(etab)
         endif         
         if ((eta_diff.gt.eta_diff_max)
     $        .or.(eta_diff.lt.eta_diff_min)) then 
            constraintgg=0d0
            return
         endif
         constraintgg=constraintgg
      endif
      
CCC  Cuts on the ystar (rapidity difference) of the photons
CCC   
      if ((constraintgg.gt.(0.1d0)).and.(ystcut.gt.0.5d0)) then
         
C     C------ insert values --------
         eta_diff_min = ystmin 
         eta_diff_max = ystmax
C     C------------------------------
         
         eta_diff = 0.5d0*dabs(etaa-etab)         
         if ((eta_diff.gt.eta_diff_max)
     $        .or.(eta_diff.lt.eta_diff_min)) then 
            constraintgg=0d0
            return
         endif
         constraintgg=constraintgg
      endif

      if(higgswidth.gt.0) then
         zhmin=datan(-nomm2/gamH/dsqrt(nomm2))
         zhmax=datan((scm-nomm2)/gamH/dsqrt(nomm2))
         constraintgg=constraintgg*(zhmax-zhmin)/pi
      endif

      constraintgg=constraintgg*brarat

C ------------ CALL EXTERNAL CUT FUNCTION TO APPLY ADDITIONAL CUTS AND
C     FILL HISTOGRAMS
      constraintgg=constraintgg*1d6
      constraintgg=constraintgg*
     &     externalCuts(part,constraintgg*Tcoeff,lums)

      return
      END	
