      double precision function externalCuts(part, Tcoeff,lums)
      implicit none

C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. gamma1
C        3. 
C        4.       
C        5. gamma2
C        6. 
C        7. 
C        8. part1
C        9. part2
C        10. hard jet
C        11. soft jet


C --------------------------------------------------
      double precision part(11,4)
      double precision Tcoeff

      include 'histos.f'
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'declar.f'

      double precision lums(0:NSMax,0:2)
      
      integer whichBin
      
      double precision xvarbins(21)
      data xvarbins/-2d0,-1.4d0,-0.9d0,-0.5d0,-0.2d0,-0.08d0,-0.06d0,
     $     -0.04d0,-0.02d0,-0.01d0,0.001d0,0.01d0,0.02d0,0.04d0,
     $     0.06d0,0.08d0,0.2d0,0.5d0,0.9d0,1.4d0,2d0/

      double precision pthiggs
      double precision p3sq,p4sq,mm,xvar

      double precision UserCuts
      external UserCuts

      externalCuts=1d0

CCC   Now call user defined cuts
      externalCuts=UserCuts(part, Tcoeff,lums)


CCC   Fill Histogram for extra adaptation

      if ((ifastinclusive.eq.0).and.(AdaptToFirstOnly.eq.0)
     $     .and.(bFillHisto)) then
         pthiggs=dsqrt(part(1,2)**2+part(1,3)**2)
         mm=dsqrt(part(1,1)**2-part(1,2)**2-part(1,3)**2-part(1,4)**2)
         xvar=part(8,2)*part(9,2)+part(8,3)*part(9,3)
     $        +part(8,4)*part(9,4)
         p3sq=dsqrt(part(8,2)**2+part(8,3)**2+part(8,4)**2)
         p4sq=dsqrt(part(9,2)**2+part(9,3)**2+part(9,4)**2)
         
         if (p3sq*p4sq.gt.0d0) then
            xvar=xvar/p3sq/p4sq
         else
            xvar=1d0
         endif
         xvar=xvar*pthiggs/mm

         whichBin=0
         do while ((whichBin.lt.ncomptoadapt+1).and.
     $        (xvar.gt.xvarbins(whichBin+1)))
            whichBin=whichBin+1
         enddo
         if ((whichBin.le.ncomptoadapt).and.
     $        (whichBin.gt.0)) then
            if (lums(0,porder).ne.0d0) then
               histAdapt(whichBin)=histAdapt(whichBin)
     $              +Tcoeff*externalCuts
            endif
         endif
      endif
      

      return
      end
