// ------------------------------------------------------------
// This is the main C wrapper for FeHiP
// reads in command line arguments
// calling sequence: ./fehip -i inputfile -o outputfile -t datdir
// inputfile: input file containing parameters for the computation
// outputfile: results will be printed there (appending LO,NLO,NNLO depending on order)
// datdir: path to dat directory containing grids for PDF sets (it's ok to use . or ..)


#include <iostream>
#include <string.h>
#include <stdlib.h>

extern"C"
{
  extern void initf_(char*, int*, char*, int*, char*, int*, char*, int*);
  extern void moref_(char*, int*, char*, int*, char*, int*, char*, int*);
  extern void integrator_(char*, int*, char*, int*, char*, int*);
  extern void ending_(char*, int*, char*, int*, char*, int*);
}

int main(int argc, char** argv)
{
  
  char* input;	
  char* output;	
  char* ttmpdir;
  char* pdfdir;
  int len1,len2,len3,len4;


    
    for(int k=1; k<argc; ++k)
        {
        if(((argv[k])[0])=='-')
            {
            if(!strcmp(argv[k],"-o"))
                {
                k++;
                output=argv[k];
                }
            else if(!strcmp(argv[k],"-i"))
                {
                k++;
                input=argv[k];
                    }
            else if(!strcmp(argv[k],"-t"))
                {
              k++;
              ttmpdir=argv[k];
                }
            else if(!strcmp(argv[k],"-p"))
                {
              k++;
              pdfdir=argv[k];
                }
            else
                {
              std::cout<<"Unknown option"<<std::endl;
              exit(1);
                }
            }
        else
            {
                std::cout<<"Unknown option"<<std::endl;
                exit(-1);
            }
        }
  (len1)=int(strlen(input));
  (len2)=int(strlen(output));
  (len3)=int(strlen(ttmpdir));
  (len4)=int(strlen(pdfdir));

  std::cout<<"********* fehip.cc: "<< len4 << "  " <<pdfdir<<std::endl;

  initf_(input,&len1,output,&len2,ttmpdir,&len3,pdfdir,&len4);
  moref_(input,&len1,output,&len2,ttmpdir,&len3,pdfdir,&len4);
  integrator_(input,&len1,output,&len2,ttmpdir,&len3);
  ending_(input,&len1,output,&len2,ttmpdir,&len3);
  return 1;
}


