CCC====================================================================
CCC   Fully Exclusive Higgs Production (FeHiPro v1.0.0) @NNLO
CCC   Authors: C. Anastasiou, R. Boughezal, S. Bucherer, F. Petriello, F. Stoeckli
CCC
CCC   based on FEHiP by
CCC   C. Anastasiou, K. Melnikov and F. Petriello
CCC
CCC====================================================================



      subroutine initf(infile,len1, outfile,len2, dir, len3, pdfdir, len4)
      implicit none
      character*128 infile,outfile
      character*1000 dir, pdfdir,pdfdir_proper
      integer len1,len2,len3,len4

      include 'declar.f'
      include 'numcomp.f'
      include 'histos.f'
      include 'pdfcontrol.f'
      include 'cutcontrol.f'
      include 'masses.f'
      include 'constants.f'
        
      double precision SSC
      external SSC

      double complex scanal,scfactor
      double precision Delta,Dnum,Dden,Dratio

      integer imod,aorder
      double precision ytrel,ybrel

      double precision WidthH,bragaga
      double precision asZ

      double precision as,conv,ftn,tn,cnorm
      double precision Etot, Mhiggs, MW, GW, MZ, GZ

      double precision tmpmax
      common/tmp/tmpmax
      
      tmpmax=0d0

CCC   C strings are null terminated, Fortran strings are not
CCC   We have to tell Fortran how long the string is meant to be
CCC   and pad ther rest with blanks
CCC   otherwise we get problems when concatenating
      call Fix_C_Str(infile,len1,inputfile,128)
      call Fix_C_Str(outfile,len2,outputfile,128)
      call Fix_C_Str(dir,len3,ttmpdir,1000)
      call Fix_C_Str(pdfdir,len4,pdfdir_proper,1000)


      C0_user=0d0
      C1_user=0d0
      C2_user=0d0

CCC ====   INPUT PARAMETERS =================
      open(unit=14,file=inputfile,status='old')
      read(14,*) 
      read(14,*) dummystring, NNLOcont
      read(14,*) dummystring, NNLOsect
      read(14,*) 
      read(14,*) dummystring, Mhiggs
      read(14,*) dummystring, gamH
      read(14,*) dummystring, MW
      read(14,*) dummystring, GW
      read(14,*) dummystring, MZ
      read(14,*) dummystring, GZ      
      read(14,*) dummystring, mt
      read(14,*) dummystring, mb
      read(14,*) dummystring, imbscheme
      read(14,*) dummystring, Gf
      read(14,*) 
      read(14,*) dummystring, ncollider
      read(14,*) dummystring, Etot
      read(14,*)
      read(14,*) dummystring, muf
      read(14,*) dummystring, mur
      read(14,*)
      read(14,*) dummystring, ytrel
      read(14,*) dummystring, ybrel
      read(14,*) dummystring, C0_user
      read(14,*) dummystring, C1_user
      read(14,*) dummystring, C2_user
      read(14,*)
      read(14,*) dummystring, ifastinclusive
      read(14,*) dummystring
      read(14,*) dummystring
      read(14,*) dummystring, ndecay
      read(14,*) dummystring, porder
      read(14,*) dummystring, imassive
      read(14,*)
      read(14,*) dummystring, iewk
      read(14,*) dummystring, zerowidth
      read(14,*) dummystring, higgswidth
      read(14,*) 
      read(14,*) 
      read(14,*) dummystring, imethod
      read(14,*) dummystring, epsrel
      read(14,*) dummystring, epsabs
      read(14,*) dummystring, ntherm
      read(14,*) dummystring, nref
      read(14,*) dummystring, nstart
      read(14,*) dummystring, nincrease
      read(14,*) dummystring, deadtime
      read(14,*) dummystring, AdaptToFirstOnly
      read(14,*) 
      read(14,*) 
      read(14,*) dummystring, consflag
      read(14,*)
      read(14,*) dummystring
      read(14,*) dummystring, whichpdf
      read(14,*) dummystring
      read(14,*) dummystring, whichas
      read(14,*) dummystring, fPDFerror
      read(14,*)
      read(14,*) dummystring, JetDefConeSize
      read(14,*) dummystring, JetDefPtMin
      read(14,*) dummystring, JetDefEtaMax
      read(14,*) dummystring, UseSISCone
      read(14,*)
      read(14,*)
      read(14,*) dummystring, TriggerCut
      read(14,*) dummystring, TriggerPt
      read(14,*) dummystring, TriggerEta
      read(14,*) dummystring, CutHardLeptPtMin
      read(14,*) dummystring, HardLeptPtMin
      read(14,*) dummystring, CutHardLeptPtMax
      read(14,*) dummystring, HardLeptPtMax
      read(14,*) dummystring, CutSoftLeptPtMin
      read(14,*) dummystring, SoftLeptPtMin
      read(14,*) dummystring, CutSoftLeptPtMax
      read(14,*) dummystring, SoftLeptPtMax
      read(14,*) dummystring, CutHardLeptEta
      read(14,*) dummystring, HardLeptEtaMax
      read(14,*) dummystring, CutSoftLeptEta
      read(14,*) dummystring, SoftLeptEtaMax
      read(14,*) dummystring, CutIsolation
      read(14,*) dummystring, IsolationCone
      read(14,*) dummystring, Isolation
      read(14,*) dummystring, CutJetVeto
      read(14,*) dummystring, JetConeSize
      read(14,*) dummystring, JetVetoPtMax
      read(14,*) dummystring, JetVetoEtaMax
      read(14,*) dummystring, CutNumVeto
      read(14,*) dummystring, maxNumJets
      read(14,*) dummystring, CutTevVeto
      read(14,*) dummystring, TevJetOnePtMax
      read(14,*) dummystring, TevJetTwoPtMax
      read(14,*) dummystring, CutPhiLL
      read(14,*) dummystring, PhiLLMin
      read(14,*) dummystring, PhiLLMax
      read(14,*) dummystring, CutMissPt
      read(14,*) dummystring, MissPtMin
      read(14,*) dummystring, MissPtMax
      read(14,*) dummystring, CutInvMass
      read(14,*) dummystring, InvMassMin
      read(14,*) dummystring, InvMassMax
      read(14,*) dummystring, CutSumPt
      read(14,*) dummystring, SumPtMin
      read(14,*) dummystring, SumPtMax
      read(14,*) dummystring, CutSpecMet
      read(14,*) dummystring, SpecMetMin
      read(14,*)
      read(14,*) dummystring, CutMassV1
      read(14,*) dummystring, MinMassV1
      read(14,*) dummystring, MaxMassV1
      read(14,*) dummystring, CutMassV2
      read(14,*) dummystring, MinMassV2
      read(14,*) dummystring, MaxMassV2
      read(14,*) dummystring, CutVB1Pt
      read(14,*) dummystring, VB1PtMin
      read(14,*) dummystring, VB1PtMax
      read(14,*) dummystring, CutVB2Pt
      read(14,*) dummystring, VB2PtMin
      read(14,*) dummystring, VB2PtMax
      read(14,*) dummystring, CutVB1Eta
      read(14,*) dummystring, VB1EtaMin
      read(14,*) dummystring, VB1EtaMax
      read(14,*) dummystring, CutVB2Eta
      read(14,*) dummystring, VB2EtaMin
      read(14,*) dummystring, VB2EtaMax
      read(14,*) dummystring, CutHiggsPt
      read(14,*) dummystring, HiggsPtMin
      read(14,*) dummystring, HiggsPtMax
      read(14,*) dummystring, CutHiggsEta
      read(14,*) dummystring, HiggsEtaMin
      read(14,*) dummystring, HiggsEtaMax
      read(14,*)
      read(14,*) dummystring, CutPhotBasic
      read(14,*) dummystring, ptg1m
      read(14,*) dummystring, ptg2m
      read(14,*) dummystring, etagM
      read(14,*) dummystring, CutPhotIsol
      read(14,*) dummystring, PhotIsolationCone
      read(14,*) dummystring, PhotETmax
      read(14,*) dummystring, ptmcut
      read(14,*) dummystring, ptmmin
      read(14,*) dummystring, ptmmax
      read(14,*) dummystring, ystcut
      read(14,*) dummystring, ystmin
      read(14,*) dummystring, ystmax
      read(14,*) dummystring, ptsoftcut
      read(14,*) dummystring, ptsoftmin
      read(14,*) dummystring, CutPhotEtaHigh
      read(14,*) dummystring, EtaDiff_min
      read(14,*) dummystring, EtaDiff_max
      read(14,*) dummystring, brarat
      read(14,*)
      read(14,*) dummystring, cut_on_pt_of_all_leptons
      read(14,*) dummystring, all_leptons_minimum_pt
      read(14,*) dummystring, cut_on_rapidity_of_all_leptons
      read(14,*) dummystring, all_leptons_maximum_y


      close(14)

      !  write(6,*)'Mhiggs=',Mhiggs
      ppi = 3.14159265358979d0

      if (ifastinclusive.eq.1) then
         ndecay=0
         write(6,*)
         write(6,*)'************************************'
         write(6,*)'** Fast inclusive computation     **'
         write(6,*)'** No decay                       **'
         write(6,*)'** Cuts ignored                   **'
         write(6,*)'************************************'
         write(6,*)
      else
         if ((CutPhotIsol.gt.0.5d0).and.(CutPhotBasic.lt.0.5d0)) then
            write(6,*)'Photon basic cut must be turned on for use with '
            write(6,*)' isolation cut!!          !'
            write(6,*)'Aborting...'
            stop
         endif
      endif

CCC=====================================================
CCC   Initialize PDFs (fPDFerror=0: no determination of PDF errors,
CCC   fPDFerror=1: determination of PDF errors)
CCC   and initialize alpha_s

      write(6,*)'Inititalizing PDFs...'
      call InitPDFs(pdfdir_proper,mur,MZ)


CCC=====================================================
CCC   Set alpha_s 
CCC   and set minorder and maxorder
CCC   (when running in NNLO mode we compute LO,NLO,NNLO result 
CCC   in one run for each sector if appropriate )
      if (porder.eq.0) then
         as=asLO
         minorder=0
         maxorder=0
      elseif (porder.eq.1) then
         as=asNLO
         minorder=1
         maxorder=1
      elseif (porder.eq.2) then
         if (ifastinclusive.eq.1) then
            minorder=0
         else
            if (NNLOcont.lt.1.5d0) then
               if (NNLOsect.lt.1.5d0) then
                  minorder=0
               elseif (NNLOsect.lt.2.5d0) then
                  minorder=1
               elseif ((NNLOsect.gt.3.5d0)
     $                 .and.(NNLOsect.lt.4.5d0)) then
                  minorder=0
               elseif ((NNLOsect.gt.4.5d0)
     $                 .and.(NNLOsect.lt.6.5d0)) then
                  minorder=1
               else
                  minorder=2
               endif
            else
               minorder=2
            endif
         endif
         as=asNNLO
         maxorder=2
      endif


CCC=====================================================
CCC   prodim=  number of integration needed for production without decay

      if(porder.eq.0) prodim=2
      if(porder.eq.1) prodim=4
      if(porder.eq.2) then
         if (ifastinclusive.eq.1) then
            prodim=4
         elseif(NNLOcont.lt.0.5d0) then
            prodim=6
         elseif(NNLOcont.lt.1.5d0) then
            prodim=4
         elseif(NNLOcont.lt.2.5d0) then
            prodim=6
         elseif(NNLOcont.lt.3.5d0) then
            prodim=6
         elseif(NNLOcont.lt.5.5d0) then
            prodim=6
         elseif(NNLOcont.lt.8.5d0) then
            prodim=3
         elseif(NNLOcont.lt.9.5d0) then
            prodim=4
         elseif(NNLOcont.lt.10.5d0) then
            prodim=4
         elseif(NNLOcont.lt.12.5d0) then
            prodim=3
         elseif(NNLOcont.lt.13.5d0) then
            prodim=4
         else 
            prodim=4
         endif
         
      endif

CCC   now adding number of dimensions for decay phase space
      if (ndecay.eq.0) then 
         ndim=prodim        
      elseif ((ndecay.ge.1).and.(ndecay.le.4)) then 
         ndim=prodim+11
      elseif (ndecay.eq.5) then 
C         ndim=prodim+4
         ndim=prodim+3
      endif

      if(higgswidth.gt.0.and.ndecay.gt.0) ndim=ndim+1

C------ internal notation transfered from line 379 because we need m2 in histogram initialization
C        m2 = Mhiggs**2
        nominal_mass_of_higgs = Mhiggs
C ====== including histogram information
      ncomp=1

      write(6,*)'Initializing Histograms...'
      if (ifastinclusive.eq.1) then
         do aorder=minorder,maxorder
            TOTBINS(aorder)=0
         enddo
      else
         call initHist()
      endif
CCC   Compute total number of components needed for histogramming and PDF sets
      if ((AdaptToFirstOnly.eq.0).and.(ifastinclusive.eq.0)) then
         ncomp=ncomp+ncomptoadapt
      endif
      do aorder=minorder,maxorder
         ncomp=ncomp+TOTBINS(aorder)
         if (aorder.eq.0) then
            ncomp=ncomp+NPDFerrorLO+1
         elseif (aorder.eq.1) then
            ncomp=ncomp+NPDFerrorNLO+1
         elseif (aorder.eq.2) then
            ncomp=ncomp+NPDFerrorNNLO+1
         endif
      enddo

      write(6,*)'ncomp= ',ncomp

CCC   check that number of components is allowed (750 in current version)
      if (ncomp.gt.interdim) then
         write(6,*)'Number of components booked (',ncomp,') too large.'
         write(6,*)'Maximum is ',interdim,'.'
         write(6,*)'Book less histogram bins or eliminate PDF error '
         write(6,*)'estimate.'
         write(6,*)'Current set up:'
         do aorder=minorder,maxorder
         write(6,*)'TOTBINS(',aorder,')=',TOTBINS(aorder)
         if (aorder.eq.0) then
           write(6,*)'NPDFerrorLO=',NPDFerrorLO+1
         elseif (aorder.eq.1) then
            write(6,*)'NPDFerrorNLO=',NPDFerrorNLO+1
         elseif (aorder.eq.2) then
            write(6,*)'NPDFerrorNNLO=',NPDFerrorNNLO+1
         endif
        enddo
         stop
      endif

CCC   Internal notations===========================
      nomm2 = Mhiggs**2
      m2 = nomm2
      scm = Etot**2
      mW2 = MW**2
      gamW = GW
      mZ2 = MZ**2
      gamZ = GZ
      ptau = m2/scm
      pfscale = muf
      gnjet = ncollider
      Gamma = 1.0d0
      Gammagg = 1.0d0



CCC   ==============================================
CCCC  Limits of phase-space: rapidity and pT range
      rapmax = 0.5d0*dlog(scm/m2)
      rapd = -rapmax
      rapu = rapmax
      pTd = -20.0d0
      pTu = 1000000.0d0


CCCC  ==============================================
CCC   Define the overall normalization
CCC   Normalizes to the Born cross-section with full 
CCC   top-mass dependence 

      conv = 0.3893792922d0*(10.0d0)**9
      tn = 4*mt**2/m2

C------ start new module ------------

      if (tn.gt.1d0) then
         scanal =  dcmplx(dasin(1D0/dsqrt(tn)), 0d0)
      else

         Delta = 1d0- tn
         Delta = dsqrt(Delta)

         Dnum = 1d0 +  Delta
         Dden = 1d0 -  Delta

         Dratio = Dnum/Dden

         scanal = dcmplx(dlog(Dratio) ,-ppi)
         scanal = scanal*dcmplx(0d0,0.5d0)
      endif

      scfactor = dcmplx(1D0,0d0)+dcmplx(1-tn, 0d0)*scanal**2
      scfactor = tn*scfactor
CCC   without normalizing to LO with exact mt dependence: scfactor=2/3
C      scfactor=2d0/3d0

C------ end new module ------------

      cnorm = conv*Gf*ppi**2/128.0d0/dsqrt(2.0d0)/ppi
     & *cdabs(scfactor)**2


      norm = as**2*cnorm

CCCC  ============================================== SB
CCC   Initialize parameters for massive computation

      write(6,*)'Initializing HPro...'
      imod=0
      call HProInit(imod,as*ppi,ytrel,ybrel)


CCCC  ============================================== SB
CCC   Computes electroweak corrections

      write(6,*)'Computing EWK corrections...'
      call EWKCorr(iewk,MW,GW,MZ,GZ,mt,Mhiggs,muf,mur)


CCC   Compute Higgs width and Branching ratio for h->diphoton
CCC   using HDECAY.
CCC   Attention: If extension to MSSM is scheduled,
CCC   HDECAY_INIT must be modified for setting MSSM parameters!!!
CCC   maybe use susylha standard
CCC   comment: updated to HDECAY version 3.4

      write(6,*)'Calling Hdecay...'
      if ((gamH.eq.0d0).or.(brarat.eq.0d0)) then
         call HDECAY_INIT(Mhiggs,asZnnlo,MW,GW,MZ,GZ,mt,mb,Gf,
     $        WidthH,bragaga)
         if (gamH.eq.0d0) then
            gamH=WidthH
         endif
         if (brarat.eq.0d0) then
            brarat=bragaga
         endif
      endif    

      call flush()
        
      return
      END

CCCC============================================================

      subroutine moref(infile,len1, outfile,len2, dir, len3, pdfdir, len4)
      implicit none
      character*128 infile,outfile
      character*1000 dir, pdfdir,pdfdir_proper
      integer len1,len2,len3,len4

      include 'declar.f'
      include 'pdfcontrol.f'
      include 'constants.f'

      character*60 pdfset
      integer aorder,is,m,Np

      external fitpdf
      
         
CCCC============================================================
CCCC   Routines for a fast interpolation of the parton densities


      call Fix_C_Str(infile,len1,inputfile,128)
      call Fix_C_Str(outfile,len2,outputfile,128)
      call Fix_C_Str(dir,len3,ttmpdir,1000)
      call Fix_C_Str(pdfdir,len4,pdfdir_proper,1000)

      write(6,*)'Fitting PDF sets... '

      do aorder = minorder,maxorder

        
         if (aorder.eq.0) then
            pdfset=pdfsetLO
            NPDFerror=NPDFerrorLO
         elseif (aorder.eq.1) then
            pdfset=pdfsetNLO
            NPDFerror=NPDFerrorNLO
         else
            pdfset=pdfsetNNLO
            NPDFerror=NPDFerrorNNLO
         endif

         do is=0,NPDFerror
            Np = 1000
            call fitpdf(pdfdir_proper,pdfset,is,Np,aorder)

         enddo

      enddo
      
        
            
      return

      END





CCC===================================================
CCC   this is the integrator
      subroutine integrator(infile,len1, outfile,len2, dir, len3)
      implicit none
      character*128 infile,outfile
      character*1000 dir
      integer len1,len2,len3

      include 'declar.f'
      include 'numcomp.f'
      include 'constants.f'

      external zufall, zufalli, zufallrs, zufallsv
      external vegasrout,hggtotal


      integer flags,thermsteps,maxeval
      integer nregions

      integer ncadapt
        
C      include 'histos.f'
         
        
       
            
      call Fix_C_Str(infile,len1,inputfile,128)
      call Fix_C_Str(outfile,len2,outputfile,128)
      call Fix_C_Str(dir,len3,ttmpdir,1000)

      ncadapt=ncomptoadapt+1


      if (imethod.lt.10) then

CCC   pvegas
CCC   File for vegas saves
CCC   If the program is interupted, the user can restart 
CCC   from the last Vegas iteration: just rerun "fehip"
CCC   The data for the last iteration is stored in: 

         pstatefile = "pvegas_last_iter"

CCC   Vegas Integration 
CCC   Takes  minutes (LO,NLO), hours (NNLO inclusive cross-sections)
CCC   or days (NNLO with many cuts/large event rejection)
CCC  
         if (ifastinclusive.eq.1) then
            call pavegas(ndim,ncomp,hggtotal,
     &           epsrel/100d0,epsabs,deadtime,
     &           ntherm,nref,nstart,nincrease,neval,fail,
     &           integral,error,prob)

         else
            call pavegas(ndim,ncomp,vegasrout,
     &           epsrel/100d0,epsabs,deadtime,
     &           ntherm,nref,nstart,nincrease,neval,fail,
     &           integral,error,prob)

         endif

      elseif (imethod.lt.20) then 
CCC   Cuba: 11=VEGAS,12=SUAVE,13=DIVONNE,14=CUHRE 

         imethod=imethod-10

C         thermsteps=(ntherm)*nstart
C         maxeval=2147483647
C         maxeval=1000000000
         maxeval=500000000
C         maxeval=109200000
C         maxeval=200000000
         statefile = "vegas_last_iter"

         if (ifastinclusive.eq.1) then
            call Cuba(imethod,AdaptToFirstOnly,ndim,ncomp,
     $           hggtotal,
     $           epsrel/100d0,epsabs,
     $           ntherm,maxeval,nstart,nincrease,ncadapt,
     $           integral,error,prob)

         else
            call Cuba(imethod,AdaptToFirstOnly,ndim,ncomp,
     $           vegasrout,
     $           epsrel/100d0,epsabs,
     $           ntherm,maxeval,nstart,nincrease,ncadapt,
     $           integral,error,prob)
         endif

      else

         write(6,*)'Unknown integrator: imethod= ',imethod
         write(6,*)'Abort...'
         stop

      endif
      return
      end

CCC===================================================
CCC   Writes info on the output file [[N]N]LO.outfile
CCC   
      subroutine ending(infile,len1, outfile,len2, dir, len3)
      implicit none
      character*128 infile,outfile
      character*1000 dir
      integer len1,len2,len3

      include 'declar.f'
      include 'numcomp.f'
      include 'histos.f'
      include 'cutcontrol.f'
      include 'pdfcontrol.f'
      include 'masses.f'
      include 'constants.f'


      double precision runvar
      double precision runwhy
      double precision binSize
      
      double precision sum,sumerr

      integer counter1, counter2, counter3
      integer icomp

      integer aorder,iset

      character*60 pdfset
      character*133 fout
      character*5 prefix

      double precision alphas
      double precision histerr(NUMBINSTOT),histprob(NUMBINSTOT)
      double precision sig,dsig,chi2

      double precision conv



      call Fix_C_Str(infile,len1,inputfile,128)
      call Fix_C_Str(outfile,len2,outputfile,128)
      call Fix_C_Str(dir,len3,ttmpdir,1000)

      if (ndecay.gt.0) then
         conv=1d0/1d6
      else
         conv=1d0
      endif


      icomp=1
      if (AdaptToFirstOnly.eq.0) then
c$$$         do counter2=1,ncomptoadapt
c$$$            write(6,*)'icomp= ',icomp,integral(icomp+1)
c$$$            icomp=icomp+1
c$$$         enddo
         icomp=icomp+ncomptoadapt
      endif

      do aorder=minorder,maxorder

         if (aorder.eq.0) then
            prefix='LO.'
            NPDFerror=NPDFerrorLO
            alphas=asLO
            pdfset=pdfsetLO
         elseif (aorder.eq.1) then
            prefix='NLO.'
            NPDFerror=NPDFerrorNLO
            alphas=asNLO
            pdfset=pdfsetNLO
         elseif (aorder.eq.2) then
            prefix='NNLO.'
            NPDFerror=NPDFerrorNNLO
            alphas=asNNLO
            pdfset=pdfsetNNLO
         endif
       
         do counter2=0,NPDFerror
            xsecPDFerror(counter2,aorder)=conv*integral(icomp+1)
            if (counter2.eq.0) then
               if (aorder.ne.porder) then
                  sig=xsecPDFerror(counter2,aorder)
                  dsig=conv*error(icomp+1)
                  chi2=prob(icomp+1)                  
               else
                  sig=conv*integral(1)
                  dsig=conv*error(1)
                  chi2=prob(1)
               endif
            endif
            icomp=icomp+1

         enddo
         
         do counter2=1,TOTBINS(aorder)
            HIST(counter2,aorder)=conv*integral(icomp+1)
            histerr(counter2)=conv*error(icomp+1)
            histprob(counter2)=prob(icomp+1)
            icomp=icomp+1
         end do

CCC   Add Prefix for output file depending on order of results
         fout=prefix(1:len_trim(prefix))//outputfile

         call unlink(fout)

         open(21,FILE=fout,STATUS='NEW')
         write(21,*) '-----------------  RESULT  -----------------'   
         if (ncollider.eq.0) then 
            write(21,*) '           proton-proton collider'
         else if (ncollider.eq.1) then
            write(21,*) '         proton-antiproton collider'
         endif
         write(21,103) 'CMS collision Energy (GeV)  = ', dsqrt(scm)
         !write(21,103) 'Higgs boson mass     (GeV)  = ', dsqrt(m2)
         write(21,103) 'Higgs boson mass     (GeV)  = ', nominal_mass_of_higgs
         write(21,103) 'Higgs width          (GeV)  = ', gamH
         write(21,103) 'Z mass               (GeV)  = ', dsqrt(mZ2)
         write(21,103) 'Z width              (GeV)  = ', gamZ
         write(21,103) 'W mass               (GeV)  = ', dsqrt(mW2)
         write(21,103) 'W width              (GeV)  = ', gamW
         write(21,103) 'Top-quark mass       (GeV)  = ', mt
         write(21,103) 'Bottom-quark mass    (GeV)  = ', mb
         write(21,*) '--------------------------------------------'
         write(21,103) 'Factorization scale  (GeV)  = ',muf
         write(21,103) 'Renormalization scale(GeV)  = ',mur
         write(21,*) 'Fermi constant              = ', Gf
         write(21,*) '--------------------------------------------'
         if (ndecay.eq.0) then 
            write(21,*) '                No decay'
         else if (ndecay.eq.1) then 
            write(21,*) '         H --> W W --> e- nu e+ nu'
         else if (ndecay.eq.2) then 
            write(21,*) '         H --> W W / Z Z --> e- nu e+ nu'
         else if (ndecay.eq.3) then 
            write(21,*) '        H --> Z Z --> e- e+ e- e+'
         else if (ndecay.eq.4) then 
            write(21,*) '        H --> Z Z --> e- e+ mu- mu+'
         else if (ndecay.eq.5) then 
            write(21,*) '        H --> gamma gamma'
         endif
         if(zerowidth.gt.0d0) then
            write(21,*) 'narrow width approximation for Vector bosons'
         else
            write(21,*) '            W/Z width included'
         endif      
         write(21,*) '--------------------------------------------'
         if (aorder.eq.0) then 
            write(21,*) '             LO Cross-Section'
         else if (aorder.eq.1) then 
            write(21,*) '            NLO Cross-Section'
         else if (aorder.eq.2) then 
            write(21,*) '            NNLO Cross-Section'
         endif
         write(21,*)''
         if (iewk.eq.0) then
            write(21,*) 'No electroweak effects computed'
         else if (iewk.eq.1) then
            write(21,*) 'Virtual electroweak/QCD effects computed'
         else if (iewk.eq.1) then
            write(21,*)'Virt. and real electroweak/QCD effects computed'
         endif
         write(21,*)
         !write(21,*)'User defined Wilson coefficients: '
         !write(21,*)'                            C0 = ',C0_user
         !write(21,*)'                            C1 = ',C1_user
         !write(21,*)'                            C2 = ',C2_user
         !write(21,*)
         write(21,*)''
         write(21,*) 'PDF set:                      ',pdfset
         write(21,104) 'Strong coupling             = ',alphas*ppi
         write(21,*) '--------------------------------------------'
         write(21,104) 'Sigma (fb)                  = ',sig
         write(21,104) 'Error (fb)                  = ',dsig
         write(21,104) 'chi^2 Probability           = ',chi2
         write(21,*) '--------------------------------------------'
         write(21,*)
         write(21,*)




         write(21,*) '------ HISTOGRAMS -------'
         write(21,*)

         counter1=1
         counter3=1
         
         do while(counter1.le.NUMHIST)
            counter2=1
            binSize=(HIGHEDGE(counter1)-LOWEDGE(counter1))
     &           /NUMBINS(counter1)
            write(21,*)
            write(21,102) HISTNAME(counter1)
            write(21,*)
            do while(counter2.le.NUMBINS(counter1))
C               write(21,101) LOWEDGE(counter1)+(counter2-1)*binSize,
C     &              HIST(counter3,aorder),0d0
               write(21,100) LOWEDGE(counter1)+(counter2-1)*binSize+
     &              binSize/2d0,HIST(counter3,aorder),
     $              histerr(counter3),histprob(counter3)
C               write(21,101) LOWEDGE(counter1)+(counter2)*binSize,
C     &              HIST(counter3,aorder),0d0
               counter3=counter3+1
               counter2=counter2+1
            enddo
            counter1=counter1+1
         enddo


CCC   -----------------------------------------------------------------
CCC   Finalize PDF error estimate
CCC   PDF error is not computed since this can only be done after combining sectors
         if (fPDFerror.eq.1) then
            write(21,*)
            write(21,*)'******************************************'
            write(21,*)'*** PDF error analysis '
            do iset=0,NPDFerror
               write(21,*)'* ',iset,xsecPDFerror(iset,aorder)
            enddo
            write(21,*)'******************************************'
         endif




         close(21)

      enddo

 100  format(F7.3, G17.8, G17.8, F10.2)
 101  format(F7.3, G17.8, G17.8)
 102  format('  ----   ',A8,'   ----')
 103  format(A30,F17.2)
 104  format(A30,G17.6)
      return
      END


CCC===================================================
CCC   the integrand
      subroutine vegasrout(nd,var,nc,ff)
      implicit none
      INTEGER nd,nc,zdim
      parameter (zdim=3)
      double precision var(nd),ff(nc)
      double precision qqq(zdim)
      double precision risa(nc)
      double precision zhmin,zhmax,zone

      double precision pb2fb
      parameter(pb2fb=1000d0)

      integer aorder,counter1,counter2

      external LOe0,NLOe0,NNLOe0,zufall

      double precision Btilde
      external Btilde
      integer iflag/1/
      save iflag
 
      include 'histos.f' 
      include 'masses.f' 
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'declar.f'
      include 'hprocontrol.f'
     
        
CCC   ncomp is stored in common block /needed/ in declar.f
CCC   here we check that nc passed by vegas is greater or equal ncomp
CCC   if not, we are in the thermalization stage and no filling of histograms
CCC   and computing of additional PDF sets is performed
CCC     :: The above story doesn't seem to work for WW,ZZ decays at NLO. Then the thermalization 
CCC         state has also nc=ncomp and bFillHisto is true
      if (nc.lt.ncomp) then 
         bFillHisto=.False.
      else
         bFillHisto=.True.
      endif
              if (bFillHisto) then
CCC   resetting histos
         call clearHist()
      endif
       
CCC   resetting PDF cross sections
      do aorder=minorder,maxorder
         if (aorder.eq.0) NPDFerror=NPDFerrorLO
         if (aorder.eq.1) NPDFerror=NPDFerrorNLO
         if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
         do counter2=0,NPDFerror
            xsecPDFerror(counter2,aorder)=0d0
         enddo
      enddo

CCC   Find the Higgs mass distributed BW
CCC   only if decay is on ...
      if(ndecay.gt.0.and.higgswidth.gt.0) then
         zhmin=datan(-nomm2/gamH/dsqrt(nomm2))
         zhmax=datan((scm-nomm2)/gamH/dsqrt(nomm2))
         zone=zhmin+var(nd)*(zhmax-zhmin)
         m2 = dsqrt(nomm2)*gamH*dtan(zone)+nomm2
C---    below the Hpro parameter mh is re-defined
C---    We want to change the mass of the higgs 
C---    that Hpro is using. This is necessary in the case the calculation
C---    is done with the higgs width on, i.e. when the higgs mass changes from
C---    point to point. 
        call HProSetNewHigssMass(dsqrt(m2))
      endif
CCC-----------branching for bbar->higgs
C      if (bbar.eq.1)  then
C            if (porder.eq.0) then 
C                call bbar_LO(nd,zdim,var,qqq,nc,risa)
C            elseif (porder.eq.1) then 
C                call bbar_NLO(nd,zdim,var,qqq,nc,risa)
C            elseif (porder.eq.2) then 
C                call bbar_NNLO(nd,zdim,var,qqq,nc,risa)
C            endif
C            ff(1)=pb2fb*risa(1)
C      else
CCC   branching dependent on order we compute
            if (porder.eq.0) then 
                call LOe0(nd,zdim,var,qqq,nc,risa)
            elseif (porder.eq.1) then 
                call NLOe0(nd,zdim,var,qqq,nc,risa)
            elseif (porder.eq.2) then 
                call NNLOe0(nd,zdim,var,qqq,nc,risa)
            endif
            ff(1)=pb2fb*risa(1)
C      endif  


CCC   Filling of additional components
      if (bFillHisto) then
         counter1=1
         !Case when we adapt to ALL below (AdaptToFirstOnly=false) 
         if (AdaptToFirstOnly.eq.0) then
            do counter2=1,ncomptoadapt
               ff(counter1+1)=pb2fb*histAdapt(counter2)
               counter1=counter1+1
            enddo
         
         endif

         do aorder=minorder,maxorder
CCC   PDF error
            if (aorder.eq.0) NPDFerror=NPDFerrorLO
            if (aorder.eq.1) NPDFerror=NPDFerrorNLO
            if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
            do counter2=0,NPDFerror
               ff(counter1+1)=pb2fb*xsecPDFerror(counter2,aorder)
               counter1=counter1+1            
            enddo
CCC   Histograms
            do counter2=1,TOTBINS(aorder)
               ff(counter1+1)=pb2fb*HIST(counter2,aorder)
               counter1=counter1+1
               
            enddo
         enddo
      endif


      RETURN
      END

CCC===================================================
CCC   the integrand for fast inclusive computation
      subroutine hggtotal(nd,var,nc,ff)
      implicit none
      integer nd,nc
      double precision var(nd),ff(nc)

      integer nncomp
      
      double precision pb2fb
      parameter(pb2fb=1000d0)

      include 'declar.f'
      include 'histos.f'
      include 'constants.f'
      include 'pdfcontrol.f'
      include 'hprocontrol.f'

      double precision qcd1(0:NSMax,0:2),qcd2(0:NSMax,0:2)
      double precision qcd3(0:NSMax,0:2)
      double precision weak1(0:NSMax),weak2(0:NSMax),weak3(0:NSMax)
      double precision sig(0:NSMax,0:2)
      integer j,aorder,counter1
      double precision as
      double precision risa(3*(NSMax+1))
      double precision tmp
      double precision Btilde
      external Btilde

      integer iflag/1/
      save iflag
      

C      write(6,*)'---------------------------------'
c$$$      write(6,*)'in hggtotal now'
C      write(6,*)var

      
      Rewk(0)=1d0
      Rewk(1)=1d0
      Rewk(2)=1d0

      if (nc.lt.ncomp) then 
         bFillHisto=.False.
      else
         bFillHisto=.True.
      endif

      do j=1,nd
         if ((var(j).lt.0d0).or.(var(j).gt.1d0)) then
            write(6,*)'Strange MC variable= '
            write(6,*)var
            write(6,*)'Discard.'
            return
         endif
      enddo


      do aorder=minorder,maxorder
         do j=0,NSMax
            qcd1(j,aorder)=0d0
            qcd2(j,aorder)=0d0
            qcd3(j,aorder)=0d0
            sig(j,aorder)=0d0
         enddo
      enddo

CCC   =====================================================
CCC   Compute massive corrections
      if ((imass.eq.1)) then

         
         ltop=1d0
         ltopbot=1d0
         lbot=1d0
         linftyLO=-1d0
         linftyNLO=-1d0


         
CCC   resetting PDF cross sections
         do aorder=minorder,maxorder
            if (aorder.eq.0) NPDFerror=NPDFerrorLO
            if (aorder.eq.1) NPDFerror=NPDFerrorNLO
            if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
            do j=0,NPDFerror
               xsecPDFerror(j,aorder)=0d0
            enddo
         enddo
         
         if (maxorder.gt.0) then
            if (maxorder.eq.1) then
               Ras(0)=(asLO/asNLO)**3
               Ras(1)=1d0
               Ras(2)=1d0
            elseif (maxorder.eq.2) then
               Ras(0)=(asLO/asNNLO)**3
               Ras(1)=(asNLO/asNNLO)**3
               Ras(2)=1d0
            endif

CCC   NLO: (top+bottom)^2-(infty)^2
C            write(6,*)'NLO'
            iorder=1
            channels(1)=.false.
            channels(2)=.true.
            channels(3)=.true.
            channels(4)=.true.
            channels(5)=.true.
            channels(6)=.true.
            channels(7)=.true.
            fbrems=.true.
            tmp = Btilde(ndim,var,1d0,iflag)
            iflag=0
            do aorder=minorder,maxorder
               if (aorder.eq.0) NPDFerror=NPDFerrorLO
               if (aorder.eq.1) NPDFerror=NPDFerrorNLO
               if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
               do j=0,NPDFerror
                  if (aorder.ge.1) then
                     sig(j,aorder)=sig(j,aorder)
     $                    +pb2fb*xsecPDFerror(j,aorder)
                  endif
               enddo
            enddo
         endif

CCC   resetting PDF cross sections
         do aorder=minorder,maxorder
            if (aorder.eq.0) NPDFerror=NPDFerrorLO
            if (aorder.eq.1) NPDFerror=NPDFerrorNLO
            if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
            do j=0,NPDFerror
               xsecPDFerror(j,aorder)=0d0
            enddo
         enddo

CCC   LO: (top+bottom)^2 -(top)^2
C         write(6,*)'LO'
         if (maxorder.eq.0) then
            Ras(0)=1d0
            Ras(1)=1d0
            Ras(2)=1d0
         elseif (maxorder.eq.1) then
            Ras(0)=(asLO/asNLO)**2
            Ras(1)=1d0
            Ras(2)=1d0
         elseif (maxorder.eq.2) then
            Ras(0)=(asLO/asNNLO)**2
            Ras(1)=(asNLO/asNNLO)**2
            Ras(2)=1d0
         endif
         iorder=0
         channels(1)=.true.
         channels(2)=.false.
         channels(3)=.false.
         channels(4)=.false.
         channels(5)=.false.
         channels(6)=.false.
         channels(7)=.false.
         fbrems=.false.
         tmp = Btilde(ndim,var,1d0,iflag)
         do aorder=minorder,maxorder
            if (aorder.eq.0) NPDFerror=NPDFerrorLO
            if (aorder.eq.1) NPDFerror=NPDFerrorNLO
            if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
            do j=0,NPDFerror
               sig(j,aorder)=sig(j,aorder)
     $              +pb2fb*xsecPDFerror(j,aorder)
            enddo
         enddo
         iflag=0

      endif

CCC   =====================================================

      if (maxorder.eq.0) then
         Ras(0)=1d0
         Ras(1)=1d0
         Ras(2)=1d0
      elseif (maxorder.eq.1) then
         Ras(0)=(asLO/asNLO)**2
         Ras(1)=1d0
         Ras(2)=1d0
      elseif (maxorder.eq.2) then
         Ras(0)=(asLO/asNNLO)**2
         Ras(1)=(asNLO/asNNLO)**2
         Ras(2)=1d0
      endif      

C      write(6,*)'hggtot'
      do aorder=maxorder,minorder,-1
          counter1=0
         if (aorder.eq.0) then
            NPDFerror=NPDFerrorLO
            nncomp=NPDFerror+1
            as=asLO
         elseif (aorder.eq.1) then
            NPDFerror=NPDFerrorNLO
            nncomp=2*(NPDFerror+1)
            as=asNLO
         elseif (aorder.eq.2) then
            NPDFerror=NPDFerrorNNLO
            nncomp=3*(NPDFerror+1)
            as=asNNLO
         endif
         if (.not.bFillHisto) then
            NPDFerror=0
            nncomp=1
         endif

 
         if (aorder.eq.0) then
            call hggtot_INTE0(nd,var,nncomp,risa)
         elseif (aorder.eq.1) then
            call hggtot_INTE1(nd,var,nncomp,risa)
         elseif (aorder.eq.2) then
            call hggtot_INTE2(nd,var,nncomp,risa)
         endif
C         write(6,*)'risa(1)= ',risa(1)
 
         if (aorder.ge.2) then
            do j=0,NPDFerror
               counter1=counter1+1
               if (counter1.le.nncomp) then
                  qcd3(j,aorder)=Ras(aorder)*pb2fb*norm*risa(counter1)
               endif
            enddo
         endif
         if (aorder.ge.1) then
            do j=0,NPDFerror
               counter1=counter1+1
               if (counter1.le.nncomp) then
                  qcd2(j,aorder)=Ras(aorder)*pb2fb*norm*risa(counter1)
               endif
            enddo
         endif
         if (aorder.ge.0) then
            do j=0,NPDFerror
               counter1=counter1+1
               if (counter1.le.nncomp) then
                  qcd1(j,aorder)=Ras(aorder)*pb2fb*norm*risa(counter1)
               endif
            enddo
         endif
         

         do j=0,NPDFerror
            weak1(j)=2d0*lambda_ewk*qcd1(j,aorder)
            sig(j,aorder)=sig(j,aorder)+qcd1(j,aorder)
     $           +weak1(j)+C0_user*(2d0+C0_user)*qcd1(j,aorder)
            if (aorder.ge.1) then
               qcd2(j,aorder)=qcd2(j,aorder)-qcd1(j,aorder)
               weak2(j)=2d0*lambda_ewk*(qcd2(j,aorder)
     $              +as*qcd1(j,aorder)*(C1w_ewk-C1q_ewk))
               sig(j,aorder)=sig(j,aorder)+qcd2(j,aorder)
     $              +weak2(j)
     $              +(C0_user*qcd2(j,aorder)
     $              +as*2d0*C1_user*(1d0+C0_user)*qcd1(j,aorder))
            endif
            if (aorder.ge.2) then 
               qcd3(j,aorder)=qcd3(j,aorder)-qcd2(j,aorder)
     $              -qcd1(j,aorder)
               weak3(j)=2d0*lambda_ewk*(qcd3(j,aorder)
     $              +as*qcd2(j,aorder)*(C1w_ewk-C1q_ewk))
     $              +2d0*lambda_ewk*(as)**2*qcd1(j,aorder)
     $              *(C2w_ewk-C2q_ewk+C1q_ewk*(C1q_ewk-C1w_ewk))
               sig(j,aorder)=sig(j,aorder)+qcd3(j,aorder)
     $              +weak3(j)
     $              +(C0_user*qcd3(j,aorder)
     $              +as*C1_user*qcd2(j,aorder)
     $              +as**2*(2d0*C2_user*(1d0+C0_user)
     $              +C1_user**2-C0_user*C1q_ewk**2 )*qcd1(j,aorder))
            endif
         enddo
      enddo 

      ff(1)=sig(0,maxorder)

C      write(6,*)'ff(1)= ',ff(1)

      if (bFillHisto) then 
         counter1=1
         do aorder=minorder,maxorder
            if (aorder.eq.0) NPDFerror=NPDFerrorLO
            if (aorder.eq.1) NPDFerror=NPDFerrorNLO
            if (aorder.eq.2) NPDFerror=NPDFerrorNNLO
            do j=0,NPDFerror
               counter1=counter1+1
               if (counter1.gt.nc) then
                  write(6,*)'counter1>nc: ',counter1,nc,j,aorder
                  stop
               endif
               ff(counter1)=sig(j,aorder)
            enddo
         enddo
      endif

      return
      end


CCC===================================================
CCC   auxiliary function for dealing with C-Strings
      SUBROUTINE Fix_C_Str (text, length, newtext, newlength)
      CHARACTER*(*) text
      INTEGER length,newlength
      character*(*) newtext

      INTEGER i


      i = 1
      DO WHILE ((i .LE. length))
         newtext(i:i)=text(i:i)
         i = i + 1
      END DO

C  Pad with blanks to the end of the string
      DO WHILE ((i .gt. length).and.(i.le.newlength))
        newtext(i:i) = ' '
        i=i+1
      END DO

      END
