#!/usr/bin/env python 

#########################################################################################
#								user input
#
#
#								physics input
#
results_dir = 'JET_VETO'				# top directory with results from different runs
project = 'WW'				# directory with results of current run
type = 'exclusive'					# inclusive (fast, no decay) or exclusive
m_higgs	= ['150']					# mass value or scan set
#m_higgs = range(100,625,25)
factorization_scale = ['0.5']		# factorization scale value or scan range
vary_a_s = 'no'					# vary the a_s within the pdf sets ? (yes or no)
perturbative_order='NLO'			# LO, NLO, NNLO
collider = 'Tevatron'					# LHC, Tevatron
sqrtS = '1960'			# in GeV
electroweak_corrections = 'virtual-real'		# 'off', 'only-virtual', 'virtual-real'
decay = 'WW'						#'none' , gamma gamma, WW, ZZ, WW-ZZ , ZZ->l1 l1 l2 l2
massive_corrections = 'top-bottom'		#none, top-only, top-bottom
pdfset= '4.0'						#-- 4.0= MSTW 2008; 3.0= MRST 2006; 2.0= MRST 2004; 1.0= MRST 2001
calculate_pdf_error = 'no'			# yes or no
#
ifcluster = 'no'						# are you running on a cluster ? (yes or no)
walltime = '480'                      # time limit in minutes for the job (in case you run on a cluster with time limited queues)
submitts='4'                    #-- For cluster: Number of submissions of the same job. 
#
accRel='0.4'             # in percentage, i.e. 0.8 means 0.8%
accAbs = '0.0'           # requires knowledge of the cross section (per sector in the exclusive mode case)
ncalls = '50000'       # points per iteration in thermalization stage
nincr= '0'                  # increase in points from iteration to iteration in thermalization stage
ntherm = '10' 
WilsonFile = 'xxxxx'               # file for redefinition of Wilson coefficients
higgs_width_flag = 'no'     # finite higgs width effects, 'yes' or 'no'


#
#
#								end of user input
#				
#								(begining of the "I really know what I am doing" section)
#
#########################################################################################

#-----------------------------------------------------------------------------------------------------

import os,sys,time,copy
module_dir = os.getcwd()
sys.path.insert(0,module_dir)
import ClassesFehip 

jobdefs = {}
myfixed = {}

#-- Do the QCD calculation
possible_flags = ['perturbative_order','type','massive_corrections','electroweak_corrections',
'muFrel','higgs_width_flag','collider','sqrtS','decay','pdfset','calculate_pdf_error',
'vary_a_s','accRel','accAbs','ntherm','ncalls','nincr','WilsonFile']

job_flags=['results_dir','project','ifcluster','walltime','submitts']
for xname in dir():
    if (xname in possible_flags):
        myfixed[xname]=eval(xname)
for xname in dir():
    if (xname in job_flags):
        jobdefs[xname]=eval(xname)

fehipjob=ClassesFehip.FeHiProProject(m_higgs,factorization_scale,myfixed,jobdefs)

