#!/usr/bin/env python 

#########################################################################################
#								user input
#
#
#								physics input
#
results_dir = 'results'                 # top directory with results from different scripts
project = 'INC'                         # directory with results of current script
type = 'inclusive'                      # inclusive (fast, no decay) or exclusive
m_higgs	= ['140']                       # mass value or scan set
#m_higgs = range(100,625,25)            # mass scan: eg. from 100 to 600 with a step of 25
factorization_scale = ['0.25','0.5','1.0']# factorization scale value or scan range in units of m_H (i.e. the ratio mu_F/m_H)
vary_a_s = 'yes'                         # vary the a_s within the pdf sets ? (yes or no) 
                                        # if set to 'yes' three runs will be performed for every value of m_higgs and factorization_scale
perturbative_order='NLO'               # LO, NLO, NNLO
collider = 'Tevatron'                        # LHC, Tevatron
sqrtS = '1960'                          # in GeV
electroweak_corrections = 'virtual-real'# 'off', 'only-virtual', 'virtual-real'
massive_corrections = 'top-bottom'		#none, top-only, top-bottom

pdfset= '4.0'                           #-- 4.0= MSTW 2008; 3.0= MRST 2006; 2.0= MRST 2004; 1.0= MRST 2001
                                        # should be '4.0' if PDF error is requested
calculate_pdf_error = 'yes'             # yes or no (only for MSTW2008)
#
ifcluster = 'no'						# are you running on a cluster ? (yes or no)
walltime = '480'                        # time limit in minutes for the job (in case you run on a cluster with time limited queues)
submitts='1'                            #-- For cluster: Number of chained submissions of the same job. 
#
accRel='0.5'                           # relative accuracy for VEGAS: in percentage, i.e. 0.8 means 0.8%
accAbs = '0.0'                          # requires knowledge of the cross section
ncalls = '10000'                        # points per iteration in thermalization stage (i.e. the stage where cuba/vegas determines the grid)
nincr= '0'                              # increase in points from iteration to iteration in thermalization stage
ntherm = '10'                           # number of thermalization iterations
higgs_width_flag = 'no'                 # finite higgs width effects, 'yes' or 'no'

gridpath= '~/work/mstw_pdfs'
TevatronSpecialScan= 'true'
ConfidenceLevel = '68%'
real_run = 'yes'
#
#
#								end of user input
#				
#								(begining of the "I really know what I am doing" section)
#
#########################################################################################

#-----------------------------------------------------------------------------------------------------

import os,sys,time,copy
module_dir = os.getcwd()
sys.path.insert(0,module_dir)
import ClassesFehip 

jobdefs = {}
myfixed = {}

decay = 'none'                          #'none' , gamma gamma, WW, ZZ, WW-ZZ , ZZ->l1 l1 l2 l2
                                        # should be 'none' for inclusive cross sections
WilsonFile = 'xxxxx'                    # file for redefinition of Wilson coefficients 
#-- Do the QCD calculation
possible_flags = ['perturbative_order','type','massive_corrections','electroweak_corrections',
'muFrel','higgs_width_flag','collider','sqrtS','decay','pdfset','calculate_pdf_error',
'vary_a_s','accRel','accAbs','ntherm','ncalls','nincr','WilsonFile','TevatronSpecialScan','ConfidenceLevel','real_run'
#'PtHiggsCut','PtHiggsMin','PtHiggsMax','EtaHiggsCut','EtaHiggsMin','EtaHiggsMax',
#'UseSISCone','JetConeSize','JetDefPtMin','JetDefEtaMax','JetVeto','JetPtMax','JetEtaMax',
#'NumVeto','JetNmax','TeVVeto','TeVJetPtMax1','TeVJetPtMax2','EtaV2Cut','EtaV2Min','EtaV2Max'
]


job_flags=['results_dir','project','ifcluster','walltime','submitts','gridpath']
for xname in dir():
    if (xname in possible_flags):
        myfixed[xname]=eval(xname)
for xname in dir():
    if (xname in job_flags):
        jobdefs[xname]=eval(xname)

#myfixed['real_run']='no'  # the directory structure and the input files are produced but the jobs are not submitted
fehipjob=ClassesFehip.FeHiProProject(m_higgs,factorization_scale,myfixed,jobdefs)

