#!/usr/bin/env python 

#########################################################################################
#								user input
#
#
#								physics input
#
results_dir = 'results'				# top directory with results from different runs
current_run_dir = 'testing'				# directory with results of current run
m_higgs	= ['600']					# mass value or scan set
factorization_scale = ['0.5']		# factorization scale value or scan range
delta_a_s = 'no'					# vary the a_s within the pdf sets ? (yes or no)
collider = 'LHC'					# LHC, Tevatron
collider_energy = '7000'			# in GeV
decay = 'gamma gamma'				#'none' , gamma gamma, WW, ZZ, WW-ZZ , ZZ->l1 l1 l2 l2
massive_corrections = 'top-bottom'		#none, top-only, top-bottom
pdf_set= '4.0'						#-- 4.0= MSTW 2008; 3.0= MRST 2006; 2.0= MRST 2004; 1.0= MRST 2001
calculate_pdf_error = 'no'			# yes or no
cluster = 'no'						# are you running on a cluster ? (yes or no)
walltime = '480'                      # time limit in minutes for the job (in case you run on a cluster with time limited queues)
relative_accuracy='0.4'             # in percentage, i.e. 0.8 means 0.8%
absolute_accuracy = '0.0'           # requires knowledge of the cross section (per sector in the exclusive mode case)
points_per_iteration = '10000'       # points per iteration in thermalization stage
n_increase= '0'                  # increase in points from iteration to iteration in thermalization stage
number_of_thermalization_iterations = '10' 
wilson_file = 'xxxxx'               # file for redefinition of Wilson coefficients
include_higgs_width_effects = 'no'     # finite higgs width effects, 'yes' or 'no'



import os,sys,time,copy
module_dir = os.getcwd()
sys.path.insert(0,module_dir)
import ClassesFehip 

jobdefs = {}
myfixed = {}

#-----------------------------------------------------------------------------------------------------
#:packing user input
 
myfixed['muFrel']= factorization_scale[0] 
myfixed['higgs_width_flag']= include_higgs_width_effects
#myfixed['muRrel']= renormalization_scale	
myfixed['collider']= collider 
myfixed['sqrtS']= collider_energy
myfixed['decay']= decay 
myfixed['pdfset']= pdf_set		
myfixed['calculate_pdf_error']= calculate_pdf_error		
myfixed['vary_a_s'] = delta_a_s
jobdefs['results_dir'] = results_dir
jobdefs['project']=current_run_dir
#: vegas variables
myfixed['accRel']= relative_accuracy                    
myfixed['accAbs']= absolute_accuracy                           
myfixed['ntherm']= number_of_thermalization_iterations	
myfixed['ncalls']= points_per_iteration                 
myfixed['nincr']= n_increase                            
#:cluster settings
jobdefs['ifcluster']=cluster
jobdefs['walltime']=walltime 
jobdefs['submitts']='1'  
#wilson file
myfixed['WilsonFile']=wilson_file
#-----------------------------------------------------------------------------------------------------
#-- Do the QCD calculation
for type in ['exclusive']:
    for perturbative_order in ['LO','NLO']:
        for massive_corrections in ['none','top-bottom']:
            for electroweak_corrections in ['off', 'only-virtual','virtual-real']:
                myfixed['perturbative_order']= perturbative_order
                myfixed['type'] = type
                myfixed['massive_corrections']= massive_corrections 
                myfixed['electroweak_corrections']= electroweak_corrections
                fehipjob=ClassesFehip.FeHiProProject(m_higgs,factorization_scale,myfixed,jobdefs)


    
    

