
      double precision function Fjet(var,qqq,ndim,zdim,z,uxa,s13,s23,
     &     s14,s24,s34,s1v,s2v,s3v,s4v,lum,Tcoeff)
      implicit none
      double precision Tcoeff
      INTEGER mode
      INTEGER ndim,zdim
      double precision var(ndim),qqq(zdim)
      double precision z,ux,s13,s23,s14,s24,s34,s1v,s2v,s3v,
     &     s4v,uxa,uxold,x1cons,x2cons
      double precision x1,x2,q,uxmin,uxmax,uxjac,lum   
      double precision uval1,dval1,usea1,dsea1,str1,chm1,btm1,glu1,
     &     uval2,dval2,usea2,dsea2,str2,chm2,btm2,glu2 
      double precision fpflag,uv1,us1,dv1,ds1,uv2,us2,dv2,ds2
      double precision tup,tgluk
      external tup,tgluk

      include 'constants.f'
      include 'masses.f'
      include 'pdfcontrol.f'

      integer aorder,j

      double precision lumqiqj,lumqiqi,lumuiubi,lumdidbi
      double precision lumgg,lumug,lumdg
      dimension lumqiqj(0:NSMax,0:2),lumqiqi(0:NSMax,0:2)
      dimension lumuiubi(0:NSMax,0:2),lumdidbi(0:NSMax,0:2)
      dimension lumgg(0:NSMax,0:2),lumug(0:NSMax,0:2),lumdg(0:NSMax,0:2)

      double precision lums(0:NSMax,0:2)
      
      double precision constraint,constraintgg
      external constraint,constraintgg

      integer i,jj,k

C      write(6,*)'Fjet: '

      mode = 1
      ptau = m2/scm
      q = dsqrt(m2)

CCC   Cut on the z value

      Fjet = 0.0d0
      if (z.gt.ptau) then

CCC   Note that in the qg case, I call this procedure with the argument
CCC   1/ux.  This really means flip ux, not var(6), as I do in the
CCC   argument.  Fix that here.  Note that uxa=var(6)<1; if it's
CCC   greater, that means I called it with 1/ux

CCC   Note that I'm generating the variable x1

         uxmax = 1.0d0
         uxmin = ptau/z
         uxjac = uxmax-uxmin

CCC   print*, uxjac-1d0

         fpflag = -999.0d0
         if (uxa.le.(1.0d0)) then
            ux = uxjac*uxa+uxmin            
            uxold = ux
            x1 = ux
            x2 = ptau/x1/z
            x1cons = x1
            x2cons = x2
         else
            fpflag = 999.0d0
            ux = uxjac/uxa+uxmin
            uxold = ux
            ux = 1.0d0/ux
            x1 = uxold
            x2 = ptau/x1/z
            x1cons = x2
            x2cons = x1
         endif

CCC   compute the luminosities
         call Luminosity(x1,x2,fpflag,lumqiqj,lumqiqi,
     $     lumuiubi,lumdidbi,lumgg,lumug,lumdg)


CCC   There is an x1*x2 absorbed by the MRST function call

         Fjet = 1.0d0/z/x1*uxjac

C         write(6,*)'lumgg: '
C         do k=0,2
C            do jj=0,NSMax
C               write(6,*)jj,k,lumgg(jj,k)
C            enddo
C         enddo
C         write(6,*)'Fjet2= ',Fjet

CCC   All channels of the form qiqj,qbariqbarj,qiqbarj
         if (lum.eq.(1.0d0)) then
            Fjet = Fjet*lumqiqj(0,porder)
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif 
               do j=0,NPDFerror
                  lums(j,aorder)=lumqiqj(j,aorder)
               enddo
            enddo
CCC   All channels of the form qiqi, qbariqbari
         elseif (lum.eq.(2.0d0)) then
            Fjet = Fjet*lumqiqi(0,porder)
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               do j=0,NPDFerror
                  lums(j,aorder)=lumqiqi(j,aorder)
               enddo
            enddo
CCC   All channels of the form qiqbari
         elseif (lum.eq.(3.0d0)) then
            Fjet = Fjet*(lumuiubi(0,porder)+lumdidbi(0,porder))
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               do j=0,NPDFerror
                  lums(j,aorder)=lumuiubi(j,aorder)+lumdidbi(j,aorder)
               enddo
            enddo
CCC   The gg channel
         elseif (lum.eq.(4.0d0)) then
            Fjet = Fjet*lumgg(0,porder)
C            write(6,*)'Fjet3= ',Fjet
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               do j=0,NPDFerror
                  lums(j,aorder)=lumgg(j,aorder)
               enddo
            enddo
CCC   The qg channel, with the quark getting x2
         elseif (lum.eq.(5.0d0)) then        
            Fjet = Fjet*(lumug(0,porder)+lumdg(0,porder))
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif  
               do j=0,NPDFerror
                  lums(j,aorder)=lumug(j,aorder)+lumdg(j,aorder)
               enddo
            enddo
         endif

C         write(6,*)Fjet



CCC   Now call the constraint function
         
         if(ndecay.lt.5) then
            Fjet = Fjet*constraint(var,qqq,ndim,zdim,z,x1cons,
     &           x2cons,s13,
     &           s23,s14,s24,s34,s1v,s2v,s3v,s4v,Tcoeff*Fjet,lums)
         else
            Fjet = Fjet*constraintgg(var,qqq,ndim,zdim,z,x1cons,
     &           x2cons,s13,
     &           s23,s14,s24,s34,s1v,s2v,s3v,s4v,Tcoeff*Fjet,lums)
         endif
         
      endif

C      write(6,*)'Fjet final: ',Fjet
      
      RETURN
      END

      
