
      double precision function Fjetc(var,qqq,ndim,zdim,l1,l2,l3,z,
     & s13,s23,s1v,s2v,yp,lum,Tcoeff)
      implicit none
      double precision Tcoeff
      INTEGER mode
      INTEGER ndim,zdim
      double precision var(ndim),qqq(zdim)
      double precision z,ux,s13,s23,s14,s24,s34,s1v,s2v,s3v,
     &     s4v,uxa,uxold,l1,l2,l3,yp,rapcons,raptest,x1cons,x2cons
      double precision x1,x2,q,uxmin,uxmax,uxjac,lum   
      double precision uval1,dval1,usea1,dsea1,str1,chm1,btm1,glu1,
     &     uval2,dval2,usea2,dsea2,str2,chm2,btm2,glu2
      double precision fpflag,uv1,us1,dv1,ds1,uv2,us2,dv2,ds2
      double precision jacrap,rapmin,rap,x1m,x2m
      double precision tup,tgluk
      external tup,tgluk

      include 'constants.f'
      include 'masses.f'
      include 'pdfcontrol.f'

      integer aorder,j
      
      double precision lumqiqj,lumqiqi,lumuiubi,lumdidbi
      double precision lumgg,lumug,lumdg
      dimension lumqiqj(0:NSMax,0:2),lumqiqi(0:NSMax,0:2)
      dimension lumuiubi(0:NSMax,0:2),lumdidbi(0:NSMax,0:2)
      dimension lumgg(0:NSMax,0:2),lumug(0:NSMax,0:2),lumdg(0:NSMax,0:2)
      
      double precision lums(0:NSMax,0:2)

      double precision constraint,constraintgg
      external constraint,constraintgg



      s14 = 0.0d0
      s24 = 0.0d0
      s34 = 0.0d0
      s4v = 1.0d0+s13+s23
      s3v = 1.0d0

      mode = 1
      ptau = m2/scm
      q = dsqrt(m2)
      jacrap = dlog(1.0d0/ptau)
      rapmin = -0.5d0*dlog(1.0d0/ptau)

CCC   If yp is < 0, then I have the gq channel, and I
CCC   need to take rap -> -rap

      fpflag = -999.0d0
      if (yp.gt.(0.0d0)) then     
         rap = jacrap*yp+rapmin
         rapcons = rap
      else
         fpflag = 999.0d0
         rap = jacrap*(-yp)+rapmin
         rapcons = -rap         
      endif

      x1m = dsqrt(ptau)*dexp(rap)
      x2m = dsqrt(ptau)*dexp(-rap)

CCC   Cut on the l1,l2 value
      
      Fjetc = 0.0d0
      if ((l1.gt.x1m).and.(l2.gt.x2m)) then
         
         x1 = x1m/l1
         x2 = x2m/l2

         if (yp.gt.(0.0d0)) then     
            x1cons = x1m/dsqrt(z*(1.0d0+s1v)/(z-s1v))
            x2cons = x2m/dsqrt(z*(1.0d0+s2v)/(z-s2v))
         else
            x1cons = x2m/dsqrt(z*(1.0d0+s1v)/(z-s1v))
            x2cons = x1m/dsqrt(z*(1.0d0+s2v)/(z-s2v))
         endif

CCC   compute the luminosities
         call Luminosity(x1,x2,fpflag,lumqiqj,lumqiqi,
     $     lumuiubi,lumdidbi,lumgg,lumug,lumdg)

         Fjetc = jacrap

CCC   All channels of the form qiqj,qbariqbarj,qiqbarj
         if (lum.eq.(1.0d0)) then
            Fjetc = Fjetc*lumqiqj(0,porder)
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               
               do j=0,NPDFerror
                  lums(j,aorder)=lumqiqj(j,aorder)
               enddo
            enddo
CCC   All channels of the form qiqi, qbariqbari
         elseif (lum.eq.(2.0d0)) then
            Fjetc = Fjetc*lumqiqi(0,porder)
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               do j=0,NPDFerror
                  lums(j,aorder)=lumqiqi(j,aorder)
               enddo
            enddo
CCC   All channels of the form qiqbari
         elseif (lum.eq.(3.0d0)) then
            Fjetc = Fjetc*(lumuiubi(0,porder)+lumdidbi(0,porder))
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               do j=0,NPDFerror
                  lums(j,aorder)=lumuiubi(j,aorder)+lumdidbi(j,aorder)
               enddo
            enddo
CCC   The gg channel
         elseif (lum.eq.(4.0d0)) then
            Fjetc = Fjetc*lumgg(0,porder)
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif 
               do j=0,NPDFerror
                  lums(j,aorder)=lumgg(j,aorder)
               enddo
            enddo
CCC   The qg channel, with the quark getting x2
         elseif (lum.eq.(5.0d0)) then        
            Fjetc = Fjetc*(lumug(0,porder)+lumdg(0,porder))
            do aorder=minorder,maxorder
               NPDFerror=0
               if (aorder.eq.0) then
                  if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
               else
                  if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
               endif
               do j=0,NPDFerror
                  lums(j,aorder)=lumug(j,porder)+lumdg(j,porder)
               enddo
            enddo
         endif



CCC   Now call the constraint function
         if(ndecay.lt.5) then
            Fjetc = Fjetc*constraint(var,qqq,ndim,zdim,z,x1cons,
     &           x2cons,s13,
     &           s23,s14,s24,s34,s1v,s2v,s3v,s4v,Tcoeff*Fjetc,lums)
         else
            Fjetc = Fjetc*constraintgg(var,qqq,ndim,zdim,z,x1cons,
     &           x2cons,s13,
     &           s23,s14,s24,s34,s1v,s2v,s3v,s4v,Tcoeff*Fjetc,lums)
         endif
      endif

C      write(6,*)'Fjetc= ',Fjetc*Tcoeff

      
      RETURN
      END
      
