      subroutine Luminosity(x1,x2,fpflag,lumqiqj,lumqiqi,
     $     lumuiubi,lumdidbi,lumgg,lumug,lumdg)
      implicit none
      include 'pdfcontrol.f'
      include 'histos.f'
      double precision x1,x2,fpflag
      double precision lqiqj,lqiqi,luiubi,ldidbi,lgg,lug,ldg
      double precision lumqiqj,lumqiqi,lumuiubi,lumdidbi
      double precision lumgg,lumug,lumdg
      dimension lumqiqj(0:NSMax,0:2),lumqiqi(0:NSMax,0:2)
      dimension lumuiubi(0:NSMax,0:2),lumdidbi(0:NSMax,0:2)
      dimension lumgg(0:NSMax,0:2),lumug(0:NSMax,0:2),lumdg(0:NSMax,0:2)

      integer aorder,iset

      if (bFillHisto) then
         do aorder=minorder,maxorder
            
            if (aorder.eq.0) then
               NPDFerror=NPDFerrorLO
            elseif (aorder.eq.1) then
               NPDFerror=NPDFerrorNLO
            else
               NPDFerror=NPDFerrorNNLO
            endif

            do iset=0,NPDFerror
               
               call lumif(aorder,iset,x1,x2,fpflag,
     &              lqiqj,lqiqi,luiubi,ldidbi,
     $              lgg,lug,ldg)

               lumqiqj(iset,aorder)=lqiqj
               lumqiqi(iset,aorder)=lqiqi
               lumuiubi(iset,aorder)=luiubi
               lumdidbi(iset,aorder)=ldidbi
               lumgg(iset,aorder)=lgg
               lumug(iset,aorder)=lug
               lumdg(iset,aorder)=ldg
            enddo
         enddo
      else
         aorder=maxorder
         iset=0
         call lumif(aorder,iset,x1,x2,fpflag,
     &        lqiqj,lqiqi,luiubi,ldidbi,
     $        lgg,lug,ldg)

         lumqiqj(iset,aorder)=lqiqj
         lumqiqi(iset,aorder)=lqiqi
         lumuiubi(iset,aorder)=luiubi
         lumdidbi(iset,aorder)=ldidbi
         lumgg(iset,aorder)=lgg
         lumug(iset,aorder)=lug
         lumdg(iset,aorder)=ldg
      endif

      return
      end
      

      subroutine lumif(aorder,iset,x1,x2,fpflag,
     $     lumqiqj,lumqiqi,lumuiubi,lumdidbi,
     $     lumgg,lumug,lumdg)
      implicit none
      include 'pdfcontrol.f'
      include 'histos.f'
      integer aorder,iset
      double precision x1,x2,fpflag
      double precision lumqiqj,lumqiqi,lumuiubi,lumdidbi
      double precision lumgg,lumug,lumdg
      
      double precision retpdfg,retpdfuv,retpdfdv,retpdfus,retpdfds,
     &     retpdfstr,retpdfchm,retpdfbtm,retpdfsbar,retpdfcbar,
     $     retpdfbbar
      external retpdfg,retpdfuv,retpdfdv,retpdfus,retpdfds,
     &     retpdfstr,retpdfchm,retpdfbtm,retpdfsbar,retpdfcbar,
     $     retpdfbbar

      double precision uval1,dval1,usea1,dsea1,str1,sba1,chm1,cba1,
     $     btm1,bba1,glu1,
     &     uval2,dval2,usea2,dsea2,str2,sba2,chm2,cba2,
     $     btm2,bba2,glu2
      double precision uv1,us1,dv1,ds1,uv2,us2,dv2,ds2
      double precision st1,sb1,ch1,cb1,bo1,bb1
      double precision st2,sb2,ch2,cb2,bo2,bb2

      integer ncollider
      COMMON/coltype/ ncollider

C      write(6,*)'lumif: ',aorder,iset,x1,x2,fpflag

      if ((x1.gt.1d0).or.(x2.gt.1d0)) then 
         lumqiqj=0d0
         lumqiqi=0d0
         lumuiubi=0d0
         lumdidbi=0d0
         lumgg=0d0
         lumug=0d0
         lumdg=0d0
         return
      endif
      uval1 = retpdfuv(x1,iset,aorder)
      uval2 = retpdfuv(x2,iset,aorder)
      dval1 = retpdfdv(x1,iset,aorder)
      dval2 = retpdfdv(x2,iset,aorder)
      usea1 = retpdfus(x1,iset,aorder)
      usea2 = retpdfus(x2,iset,aorder)
      dsea1 = retpdfds(x1,iset,aorder)
      dsea2 = retpdfds(x2,iset,aorder)
      glu1 = retpdfg(x1,iset,aorder)
C     write(6,*)'glu1= ',glu1
      glu2 = retpdfg(x2,iset,aorder)
C     write(6,*)'glu2= ',glu2
      str1 = retpdfstr(x1,iset,aorder)
      str2 = retpdfstr(x2,iset,aorder)
      chm1 = retpdfchm(x1,iset,aorder)
      chm2 = retpdfchm(x2,iset,aorder)
      btm1 = retpdfbtm(x1,iset,aorder)
      btm2 = retpdfbtm(x2,iset,aorder) 
      sba1 = retpdfsbar(x1,iset,aorder)
      sba2 = retpdfsbar(x2,iset,aorder)
      cba1 = retpdfcbar(x1,iset,aorder)
      cba2 = retpdfcbar(x2,iset,aorder)
      bba1 = retpdfbbar(x1,iset,aorder)
      bba2 = retpdfbbar(x2,iset,aorder) 


C     write(6,*)'Luminosity: ',aorder,iset,x1,x2,glu1,glu2

CCC   Define the up/down distributions for pp and ppbar colliders

      if (ncollider.eq.0) then

         dv1 = dval1+dsea1
         dv2 = dval2+dsea2
         ds1 = dsea1
         ds2 = dsea2
         uv1 = uval1+usea1
         uv2 = uval2+usea2
         us1 = usea1
         us2 = usea2

         st1 = str1
         sb1 = sba1
         ch1 = chm1
         cb1 = cba1
         bo1 = btm1
         bb1 = bba1
         st2 = str2
         sb2 = sba2
         ch2 = chm2
         cb2 = cba2
         bo2 = btm2
         bb2 = bba2
         

      elseif (ncollider.eq.1) then      

         if (fpflag.lt.(0.0d0)) then
            dv1 = dval1+dsea1
            dv2 = dsea2
            ds1 = dsea1
            ds2 = dval2+dsea2
            uv1 = uval1+usea1
            uv2 = usea2
            us1 = usea1
            us2 = uval2+usea2
            
            st1 = str1
            sb1 = sba1
            ch1 = chm1
            cb1 = cba1
            bo1 = btm1
            bb1 = bba1
            st2 = sba2
            sb2 = str2
            ch2 = cba2
            cb2 = chm2
            bo2 = bba2
            bb2 = btm2

         else
            dv1 = dsea1
            dv2 = dval2+dsea2
            ds1 = dval1+dsea1
            ds2 = dsea2
            uv1 = usea1
            uv2 = uval2+usea2
            us1 = uval1+usea1
            us2 = usea2

            st1 = sba1
            sb1 = str1
            ch1 = cba1
            cb1 = chm1
            bo1 = bba1
            bb1 = btm1
            st2 = str2
            sb2 = sba2
            ch2 = chm2
            cb2 = cba2
            bo2 = btm2
            bb2 = bba2

         endif 
      endif
      
      lumqiqj=((uv1+us1)*(dv2+ds2+st2+ch2
     &     +bo2+sb2+cb2+bb2)
     &     +(dv1+ds1)*(uv2+us2+st2+sb2+ch2+cb2+bo2+bb2)
     &     +(st1+sb1)*(uv2+us2+dv2+ds2+ch2+cb2+bo2+bb2)
     &     +(ch1+cb1)*(uv2+us2+dv2+ds2+st2+sb2+bo2+bb2)
     &     +(bo1+bb1)*(uv2+us2+dv2+ds2+st2+sb2+2*ch2+cb2))
      lumqiqi=(uv1*uv2+us1*us2+dv1*dv2+ds1*ds2
     &     +st1*st2+sb1*sb2+ch1*ch2+cb1*cb2+bo1*bo2+bb1*bb2)

      
      lumuiubi=(uv1*us2+uv2*us1+ch1*cb2+ch2*cb1)

      lumdidbi=(dv1*ds2+dv2*ds1+st1*sb2+st2*sb1
     $     +bo1*bb2+bo2*bb1)

      lumgg=glu1*glu2


      lumug=glu1*(uv2+us2+ch2+cb2)

      lumdg=glu1*(dv2+ds2+st2+sb2+bo2+bb2)


      
      if (fpflag.eq.(0.0d0)) then
         lumug=lumug
     &        +glu2*(uv1+us1+ch1+cb1)
         lumdg=lumdg
     &        +glu2*(dv1+ds1+st1+sb1+bo1+bb1)

      endif
  


      return
      end
