      double complex function MZZeemm(GF,mW,GammaW,mZ,GammaZ,s23,s24,
     $     s25,s34,s35,s45)
      implicit none
      double precision GF,mW,GammaW,mZ,GammaZ,s23,s24,
     $     s25,s34,s35,s45

      double complex CV1
      double complex CA1
      double complex CV2
      double complex CA2
      double complex LambdaZ
      double complex gweak
      double complex cosW,sinW
      double complex v
      double complex tt1
      double complex tt2
      double complex tt3
      double complex tt4
      double complex tt5
      double complex tt6
      double complex tt7
      double complex tt8
      double complex tt9
      double complex tt10
      double complex tt11
      double complex tt12
      double complex tt13
      double complex tt14
 
      double complex numerator,denominator
      double complex ImagOne,One
      double precision Pi
      parameter(Pi=3.14159265358979d0)


      One = dcmplx(1d0,0d0)
      ImagOne = dcmplx(0d0,1d0)
      cosW=mW/mZ
      sinW=zsqrt(1d0-cosW**2)
      v=One/zsqrt(zsqrt(2d0*One)*GF*One)
      LambdaZ = 1d0/v
      gweak = zsqrt(zsqrt(16*mW**4*GF**2/Pi**3*One))
      CA1 = dcmplx(-1d0,0d0)
      CA2 = dcmplx(-1d0,0d0)
      CV1 = -1d0-4d0*(-1d0)*sinW**2
      CV2 = -1d0-4d0*(-1d0)*sinW**2
      MZZeemm = dcmplx(0d0,0d0)

      numerator=1d0
      tt1 = 8
      numerator=numerator*tt1
      tt2 = mZ ** 4
      numerator=numerator*tt2
      tt3 = gweak ** 4
      numerator=numerator*tt3
      tt4 = cosW ** 4
      numerator=numerator*tt4
      tt5 = mZ ** 4 - 2 * mZ ** 2 * s45 + mZ ** 2 * GammaZ ** 2 + s45 **
     # 2
      numerator=numerator*tt5
      tt6 = mZ ** 4 - 2 * mZ ** 2 * s23 + mZ ** 2 * GammaZ ** 2 + s23 **
     # 2
      numerator=numerator*tt6
      tt7 = s25 * s34 * CA2 ** 2 * CA1 ** 2 + s25 * s34 * CA2 ** 2 * CV1
     # ** 2 - 4 * CV1 * CV2 * CA2 * CA1 * s25 * s34 + s25 * s34 * CA1 **
     # 2 * CV2 ** 2 + s24 * s35 * CV1 ** 2 * CV2 ** 2 + s24 * s35 * CA2 
     #** 2 * CV1 ** 2 + 4 * s24 * s35 * CV1 * CV2 * CA2 * CA1 + s24 * s3
     #5 * CA1 ** 2 * CV2 ** 2 + s24 * s35 * CA2 ** 2 * CA1 ** 2 + s25 * 
     #s34 * CV1 ** 2 * CV2 ** 2
      numerator=numerator*tt7
      tt8 = LambdaZ ** 2
      numerator=numerator*tt8
      tt9 = One
      numerator=numerator*tt9

      denominator=1d0
      tt10 = 64
      denominator=denominator*tt10
      tt11 = cosW ** 8
      denominator=denominator*tt11
      tt12 = (mZ ** 4 - 2 * mZ ** 2 * s45 + mZ ** 2 * GammaZ ** 2 + s45 
     #** 2) ** 2
      denominator=denominator*tt12
      tt13 = (mZ ** 4 - 2 * mZ ** 2 * s23 + mZ ** 2 * GammaZ ** 2 + s23 
     #** 2) ** 2
      denominator=denominator*tt13
      tt14 = One
      denominator=denominator*tt14

      MZZeemm = MZZeemm + numerator/denominator

      return
      end
 
c$$$      One = dcmplx(1d0,0d0)
c$$$      ImagOne = dcmplx(0d0,1d0)
c$$$      cosW=mW/mZ*One
c$$$      sinW=zsqrt(1d0-cosW**2)
c$$$      v=One/zsqrt(zsqrt(2d0*One)*GF*One)
c$$$      LambdaZ = 1d0/v
c$$$      gweak = zsqrt(zsqrt(16*mW**4*GF**2/Pi**3*One))
c$$$      CA1 = dcmplx(1d0,0d0)
c$$$      CA2 = dcmplx(-1d0,0d0)
c$$$      CV1 = dcmplx(1d0,0d0)
c$$$      CV2 = -1d0-4d0*(-1d0)*sinW**2
c$$$      MZZeemm = dcmplx(0d0,0d0)
c$$$
c$$$      numerator=1d0
c$$$      tt1 = 8
c$$$      numerator=numerator*tt1
c$$$      tt2 = mZ ** 4
c$$$      numerator=numerator*tt2
c$$$      tt3 = gweak ** 4
c$$$      numerator=numerator*tt3
c$$$      tt4 = cosW ** 4
c$$$      numerator=numerator*tt4
c$$$      tt5 = mZ ** 4 - 2 * mZ ** 2 * s45 + mZ ** 2 * GammaZ ** 2 + s45 **
c$$$     # 2
c$$$      numerator=numerator*tt5
c$$$      tt6 = mZ ** 4 - 2 * mZ ** 2 * s23 + mZ ** 2 * GammaZ ** 2 + s23 **
c$$$     # 2
c$$$      numerator=numerator*tt6
c$$$      tt7 = -2 * s25 * s34 * CA2 ** 2 * CV2 ** 2 + s25 * s34 * CV2 ** 4 
c$$$     #+ s25 * s34 * CA2 ** 4 + s24 * s35 * CV2 ** 4 + 6 * s24 * s35 * CA
c$$$     #2 ** 2 * CV2 ** 2 + s24 * s35 * CA2 ** 4
c$$$      numerator=numerator*tt7
c$$$      tt8 = LambdaZ ** 2
c$$$      numerator=numerator*tt8
c$$$      tt9 = One
c$$$      numerator=numerator*tt9
c$$$
c$$$      denominator=1d0
c$$$      tt10 = 64
c$$$      denominator=denominator*tt10
c$$$      tt11 = cosW ** 8
c$$$      denominator=denominator*tt11
c$$$      tt12 = (mZ ** 4 - 2 * mZ ** 2 * s45 + mZ ** 2 * GammaZ ** 2 + s45 
c$$$     #** 2) ** 2
c$$$      denominator=denominator*tt12
c$$$      tt13 = (mZ ** 4 - 2 * mZ ** 2 * s23 + mZ ** 2 * GammaZ ** 2 + s23 
c$$$     #** 2) ** 2
c$$$      denominator=denominator*tt13
c$$$      tt14 = One
c$$$      denominator=denominator*tt14
c$$$
c$$$      MZZeemm = MZZeemm + numerator/denominator
c$$$
c$$$      return
c$$$      end
