CCCCCC
      subroutine fitpdf(dir,pdfname,iset,Np,aorder)
      implicit double precision (a-h,o-z)
      character*128 dir
      character*60 pdfname
      integer iset
      INTEGER aorder

c$$$  real*8 tau,fscale,pi
c$$$  COMMON /fordyi/ tau,fscale,pi
c$$$  dimension cc(5)

      include 'pdfcontrol.f'

      dimension xx(NP) 
      dimension yglu(Np), yupv(Np), ydnv(Np)
      dimension yusea(Np), ydsea(Np), ystr(Np)
      dimension ysbar(Np),ycbar(Np),ybbar(Np)
      dimension ychm(Np), ybot(Np)
      dimension xsel(3), ysel(3)
      
      character*60 pdfset
      common/pdfset/ pdfset

      character*128 tmpdir
      common/tempdir/tmpdir

      double precision tiny
      parameter (tiny=1d-7)

      double precision gamH
      integer zerowidth,ndecay
      COMMON/nparams/ gamH,zerowidth,ndecay

      double precision nomm2
      integer higgswidth
      COMMON/params2/ nomm2,higgswidth

      tmpdir=dir
      pdfset=pdfname

      if(higgswidth.lt.1.or.ndecay.lt.1) then
         minfit=ptau
      else
         minfit=ptau/10000d0
      endif

      do i=1,Np
	 xx(i) = minfit + (1d0-minfit)*i*(i-1d0)/Np/(Np-1d0)
	 xi1=min(xx(i),1d0-tiny)

	 q=pfscale
	 mode=1

         call mypdf(iset,xi1,q,upv,dnv,usea,dsea,str,sbar,chm,
     $        cbar,bot,bbar,glu,whichas)


CCC   ====================================================================

         yupv(i) = upv
         ydnv(i) = dnv
         yusea(i) = usea
         ydsea(i) = dsea
         ystr(i) = str
         ysbar(i) = sbar
         ychm(i) = chm
         ycbar(i) = cbar
         ybot(i) = bot
         ybbar(i) = bbar
         yglu(i) = glu

      enddo	

      hh = Np*(Np-1)/(1-minfit)

      hhg = hh
      hhuv = hh
      hhdv = hh
      hhus = hh
      hhds = hh
      hhstr = hh
      hhchm = hh
      hhbtm = hh
      hhsba = hh
      hhcba = hh
      hhbba = hh

      
      do i=1,Np 
         if (i.eq.1) then
            i1=i
            i2=i+1
            i3=i+3
         elseif (i.eq.Np) then 
            i1=i-2
            i2=i-1
            i3=i
         else
            i1=i-1
            i2=i
            i3=i+1
         endif 
         
         xa1 = xx(i1)
         xa2 = xx(i2)
         xa3 = xx(i3)
         
         
         ya1 =yglu(i1)
         ya2 =yglu(i2)
         ya3 =yglu(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
      
         xxg(i,iset,aorder) = xx(i)
         AAG(i,iset,aorder) = a
         BBG(i,iset,aorder) = b
         CCG(i,iset,aorder) = c
         
         ya1 =yupv(i1)
         ya2 =yupv(i2)
         ya3 =yupv(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)

         xxuv(i,iset,aorder) = xx(i)
         AAUV(i,iset,aorder) = a
         BBUV(i,iset,aorder) = b
         CCUV(i,iset,aorder) = c


         ya1 =ydnv(i1)
         ya2 =ydnv(i2)
         ya3 =ydnv(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)

         xxdv(i,iset,aorder) = xx(i)
         AADV(i,iset,aorder) = a
         BBDV(i,iset,aorder) = b
         CCDV(i,iset,aorder) = c
  
         
         ya1 =yusea(i1)
         ya2 =yusea(i2)
         ya3 =yusea(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)

         xxus(i,iset,aorder) = xx(i)
         AAUS(i,iset,aorder) = a
         BBUS(i,iset,aorder) = b
         CCUS(i,iset,aorder) = c

          
         ya1 =ydsea(i1)
         ya2 =ydsea(i2)
         ya3 =ydsea(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxds(i,iset,aorder) = xx(i)
         AADS(i,iset,aorder) = a
         BBDS(i,iset,aorder) = b
         CCDS(i,iset,aorder) = c


         
         ya1 =ystr(i1)
         ya2 =ystr(i2)
         ya3 =ystr(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxstr(i,iset,aorder) = xx(i)
         AASTR(i,iset,aorder) = a
         BBSTR(i,iset,aorder) = b
         CCSTR(i,iset,aorder) = c

         
         
         ya1 =ychm(i1)
         ya2 =ychm(i2)
         ya3 =ychm(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxchm(i,iset,aorder) = xx(i)
         AACHM(i,iset,aorder) = a
         BBCHM(i,iset,aorder) = b
         CCCHM(i,iset,aorder) = c

         
         ya1 =ybot(i1)
         ya2 =ybot(i2)
         ya3 =ybot(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxbtm(i,iset,aorder) = xx(i)
         AABTM(i,iset,aorder) = a
         BBBTM(i,iset,aorder) = b
         CCBTM(i,iset,aorder) = c


         ya1 =ysbar(i1)
         ya2 =ysbar(i2)
         ya3 =ysbar(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxsba(i,iset,aorder) = xx(i)
         AASBA(i,iset,aorder) = a
         BBSBA(i,iset,aorder) = b
         CCSBA(i,iset,aorder) = c

         ya1 =ycbar(i1)
         ya2 =ycbar(i2)
         ya3 =ycbar(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxcba(i,iset,aorder) = xx(i)
         AACBA(i,iset,aorder) = a
         BBCBA(i,iset,aorder) = b
         CCCBA(i,iset,aorder) = c
         
         ya1 =ybbar(i1)
         ya2 =ybbar(i2)
         ya3 =ybbar(i3)
         
         call givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
         
         xxbba(i,iset,aorder) = xx(i)
         AABBA(i,iset,aorder) = a
         BBBBA(i,iset,aorder) = b
         CCBBA(i,iset,aorder) = c

      enddo

 

CCCCCC
      end


      subroutine givecoeff(xa1,xa2,xa3,ya1,ya2,ya3, a, b, c)
      implicit double precision (a-h,o-z)
      
      den=(xa1-xa2)*(xa2-xa3)*(xa3-xa1)
      a = -ya1*(xa2-xa3)/den
      a = a-ya2*(xa3-xa1)/den
      a = a-ya3*(xa1-xa2)/den
      
      b =  ya1*(xa2*xa2-xa3*xa3)/den
      b = b+ya2*(xa3*xa3-xa1*xa1)/den
      b = b+ya3*(xa1*xa1-xa2*xa2)/den
      
      c = -ya1*(xa2-xa3)*xa2*xa3/den
      c = c-ya2*(xa3-xa1)*xa1*xa3/den
      c = c-ya3*(xa1-xa2)*xa1*xa2/den
      return
      end 





c     gluon pdf

      double precision function retpdfg(x,iset,aorder)
      implicit real*8(a-h,o-z)   
      integer iset,aorder

      include 'pdfcontrol.f'

      hh=hhg

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =int(rr) 
      retpdfg = CCG(L,iset,aorder)+BBG(L,iset,aorder)*x
     $     +AAG(L,iset,aorder)*x**2

C      write(6,*)L,iset,aorder,CCG(L,iset,aorder),BBG(L,iset,aorder),
C     $     AAG(L,iset,aorder),retpdfg
      

      end


c     up-valence pdf

      double precision function retpdfuv(x,iset,aorder)
      implicit real*8(a-h,o-z)    
      integer iset,aorder

      include 'pdfcontrol.f'

      hh=hhuv

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfuv = CCUV(L,iset,aorder)+BBUV(L,iset,aorder)*x
     $     +AAUV(L,iset,aorder)*x**2

      end



c     down-valence pdf

      double precision function retpdfdv(x,iset,aorder)
      implicit real*8(a-h,o-z)    
      integer iset,aorder

      include 'pdfcontrol.f'

      hh=hhdv

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfdv = CCDV(L,iset,aorder)+BBDV(L,iset,aorder)*x
     $     +AADV(L,iset,aorder)*x**2

      end



c     up-sea pdf

      double precision function retpdfus(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhus

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfus = CCUS(L,iset,aorder)+BBUS(L,iset,aorder)*x
     $     +AAUS(L,iset,aorder)*x**2

      end



c     down-sea pdf

      double precision function retpdfds(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhds

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfds = CCDS(L,iset,aorder)+BBDS(L,iset,aorder)*x
     $     +AADS(L,iset,aorder)*x**2

      end


c     strange-sea pdf

      double precision function retpdfstr(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhstr

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfstr = CCSTR(L,iset,aorder)+BBSTR(L,iset,aorder)*x
     $     +AASTR(L,iset,aorder)*x**2

      end


c     charm-sea pdf

      double precision function retpdfchm(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'

      hh=hhchm

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfchm = CCCHM(L,iset,aorder)+BBCHM(L,iset,aorder)*x
     $     +AACHM(L,iset,aorder)*x**2

      end



c     bottom-sea pdf

      double precision function retpdfbtm(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhbtm

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfbtm = CCBTM(L,iset,aorder)+BBBTM(L,iset,aorder)*x
     $     +AABTM(L,iset,aorder)*x**2

      end

C     sbar pdf
      double precision function retpdfsbar(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhsba

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfsbar = CCSBA(L,iset,aorder)+BBSBA(L,iset,aorder)*x
     $     +AASBA(L,iset,aorder)*x**2

      end

C     cbar pdf
      double precision function retpdfcbar(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhcba

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfcbar = CCCBA(L,iset,aorder)+BBCBA(L,iset,aorder)*x
     $     +AACBA(L,iset,aorder)*x**2

      end

C     bbar pdf
      double precision function retpdfbbar(x,iset,aorder)
      implicit real*8(a-h,o-z)
      integer iset,aorder    

      include 'pdfcontrol.f'


      hh=hhbba

      lambda = (x-minfit)*hh

      if(lambda.lt.0d0) then
         write(*,*) 'WARNING: x out of fitting range'
         lambda=0d0
      endif

      rr = 0.5d0*(1.0d0+dsqrt(1+4d0*lambda))

      L =rr 
      retpdfbbar = CCBBA(L,iset,aorder)+BBBBA(L,iset,aorder)*x
     $     +AABBA(L,iset,aorder)*x**2

      end























