
      subroutine mypdf(isetval,xi1,q,upv,dnv,usea,dsea,str,sbar,chm,
     $     cbar,bot,bbar,glu,whichas)
      implicit none
      integer isetval
      double precision xi1,q,upv,dnv,usea,dsea,str,chm,bot,glu,sbar
      double precision cbar, bbar, phot
      integer mode
      INTEGER iset,ix,nx,iq,nq
      integer whichas  
      CHARACTER prefix*1024

      character*1000 tmpdir
      common/tempdir/tmpdir

      character*60 pdfset
      character*20 suffix
      common/pdfset/pdfset,suffix

      sbar=0d0
      cbar=0d0
      bbar=0d0
C      write(6,*)'mypdf: ',pdfset

      if (pdfset.eq.'MRSTLO') then
         mode =1       
         prefix = tmpdir(1:len_trim(tmpdir))//"/pdfdat/OldGrids/"
         call mrstlo(prefix,xi1,q,mode,upv,dnv,usea,dsea,str,
     $        chm,bot,glu)
         sbar=str
         cbar=chm
         bbar=bot
      elseif (pdfset.eq.'MRST2001') then
         mode =1      
         prefix = tmpdir(1:len_trim(tmpdir))//"/pdfdat/OldGrids/"
         call mrst2001(prefix,xi1,q,mode,upv,dnv,usea,dsea,str,
     $        chm,bot,glu)
         sbar=str
         cbar=chm
         bbar=bot
      elseif (pdfset.eq.'MRSTNNLO') then
         mode=1
         prefix = tmpdir(1:len_trim(tmpdir))//"/pdfdat/OldGrids/"
         call mrstnnlo(prefix,xi1,q,mode,upv,dnv,usea,dsea,str,
     $        chm,bot,glu)
         sbar=str
         cbar=chm
         bbar=bot
      elseif (pdfset.eq.'MRST2004NLO') then
         mode=1         
         prefix = tmpdir(1:len_trim(tmpdir))//"/pdfdat/OldGrids/"
         call mrst2004(prefix,xi1,q,mode,upv,dnv,usea,dsea,str,
     $        chm,bot,glu)
         sbar=str
         cbar=chm
         bbar=bot
      elseif (pdfset.eq.'MRST2004NNLO') then
         mode=2
         prefix = tmpdir(1:len_trim(tmpdir))//"/pdfdat/OldGrids/"
         call mrst2004(prefix,xi1,q,mode,upv,dnv,usea,dsea,str,
     $        chm,bot,glu)
         sbar=str
         cbar=chm
         bbar=bot
      elseif (pdfset.eq.'MRST2006NNLO') then 
         prefix=tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mrst2006nnlo" ! prefix for the grid files
C--   N.B. This fit has m_c = 1.43 GeV, m_b = 4.30 GeV,
C--   and Lambda_{QCD} = 0.2808 GeV => alpha_S(M_Z) = 0.1191.
C--   There are three different interfaces to access the PDFs.
C--   Consider only the central PDF set to start with.
         iset = isetval
C--   First the traditional MRST-like interface (but note the "sbar").

         call GetAllPDFs(prefix,iset,xi1,q,
     &        upv,dnv,usea,dsea,str,sbar,chm,bot,glu)
         cbar=chm
         bbar=bot

      elseif (pdfset.eq.'MSTW2008LO') then 
         prefix=tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mstw2008lo" ! prefix for the grid files
C         prefix = tmpdir//"/pdfdat/Grids/mstw2008lo" ! prefix for the grid files
      
         iset = isetval

         if (iset.gt.0) then 
            if ((whichas.eq.0).or.(whichas.eq.1).or.(whichas.eq.2)) then
                prefix = prefix(1:len_trim(prefix))//'.90cl'
            elseif ((whichas.eq.3).or.(whichas.eq.4).or.(whichas.eq.5)) then
                prefix = prefix(1:len_trim(prefix))//'.68cl'
            endif
         endif


         CALL GetAllPDFs08(prefix,iset,xi1,q,
     &        upv,dnv,usea,dsea,str,sbar,
     &        chm,cbar,bot,bbar,glu,phot)
         
C         write(6,*)iset,xi1,q,glu

      elseif (pdfset.eq.'MSTW2008NLO') then 
         prefix=tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mstw2008nlo" ! prefix for the grid files
         prefix = prefix(1:len_trim(prefix))//suffix(1:len_trim(suffix))
CC         prefix = tmpdir//"/pdfdat/Grids/mstw2008nlo" ! prefix for the grid files
         iset = isetval
         if (iset.gt.0) then 
            if ((whichas.eq.0).or.(whichas.eq.1).or.(whichas.eq.2)) then
                prefix = prefix(1:len_trim(prefix))//'.90cl'
            elseif ((whichas.eq.3).or.(whichas.eq.4).or.(whichas.eq.5)) then
                prefix = prefix(1:len_trim(prefix))//'.68cl'
            endif
         endif

         CALL GetAllPDFs08(prefix,iset,xi1,q,
     &        upv,dnv,usea,dsea,str,sbar,
     &        chm,cbar,bot,bbar,glu,phot)
         
      elseif (pdfset.eq.'MSTW2008NNLO') then 
         prefix=tmpdir(1:len_trim(tmpdir))//"/pdfdat/Grids/mstw2008nnlo" ! prefix for the grid files
         prefix = prefix(1:len_trim(prefix))//suffix(1:len_trim(suffix))
CC         prefix = tmpdir//"/pdfdat/Grids/mstw2008nnlo" ! prefix for the grid files
         iset = isetval
         if (iset.gt.0) then 
            if ((whichas.eq.0).or.(whichas.eq.1).or.(whichas.eq.2)) then
                prefix = prefix(1:len_trim(prefix))//'.90cl'
            elseif ((whichas.eq.3).or.(whichas.eq.4).or.(whichas.eq.5)) then
                prefix = prefix(1:len_trim(prefix))//'.68cl'
            endif
        endif

         CALL GetAllPDFs08(prefix,iset,xi1,q,
     &        upv,dnv,usea,dsea,str,sbar,
     &        chm,cbar,bot,bbar,glu,phot)
         


      endif

      END

