      double precision function UserCuts(part, Tcoeff,lums)
      implicit none

C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. W+
C        3. l+
C        4. nu      
C        5. W-
C        6. l-
C        7. nu_bar
C        8. part1
C        9. part2
C        10. hard jet
C        11. soft jet


C --------------------------------------------------
      double precision part(11,4)
      double precision Tcoeff

      include 'histos.f'
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'declar.f'


      double precision lums(0:NSMax,0:2)

      integer aorder,iset

      integer whichBin, startBin, counter
      double precision histval(NUMHIST)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   MODIFY THE FOLLOWING TO YOUR NEEDS                   CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      

C -------- HELPER VARIABLES -----------
      double precision pthiggs, yhiggs
      double precision ptLjet, yLjet
          

      UserCuts=1d0

      if (bFillHisto) then
C---- compute variables: PThiggs and Yhiggs
         
         pthiggs=dsqrt(part(1,2)**2+part(1,3)**2)
         yhiggs=0.5*dlog((part(1,1)+part(1,4))/(part(1,1)-part(1,4)))
         
         ptLjet=dsqrt(part(10,2)**2+part(10,3)**2)
         yLjet=0.5*dlog((part(10,1)+part(10,4))/(part(10,1)-part(10,4)))

         histval(1)=pthiggs
         histval(2)=dabs(yhiggs)
         
C         if(ptLjet.gt.5d0) then
C            histval(3)=dabs(yLjet)
C            histval(4)=dabs(yLjet)
C            histval(5)=dabs(yLjet-yhiggs)
C            histval(6)=dabs(yLjet-yhiggs)
C         else
C            histval(3)=-100d0
C            histval(4)=-100d0
C            histval(5)=-100d0
C            histval(6)=-100d0
C         endif
        
        
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   DO NOT TOUCH THE FOLLOWING                           CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C---- fill Histograms
         do aorder=minorder,maxorder
            startBin=1
            counter=1
            do while(counter.le.NUMHIST)
               if(histval(counter).ge.LOWEDGE(counter).and.
     &              histval(counter).lt.HIGHEDGE(counter)) then
                  whichBin=(histval(counter)-LOWEDGE(counter))/
     &                 (HIGHEDGE(counter)-LOWEDGE(counter))
     &                 *NUMBINS(counter)+startBin
                  if (lums(0,porder).ne.0d0) then
                     HIST(whichBin,aorder)=HIST(whichBin,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(0,aorder)/lums(0,porder)*UserCuts
                  endif
               endif      
               startBin=startBin+NUMBINS(counter)
               counter=counter+1
            enddo

CCC   fill arrays for PDF errors
            xsecPDFerror(0,aorder)=xsecPDFerror(0,aorder)
     $           +Rewk(aorder)*Ras(aorder)*Tcoeff
     $           *lums(0,aorder)/lums(0,porder)
            if (fPDFerror.eq.1) then
               if (aorder.eq.0) then
                  NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  NPDFerror=NPDFerrorNLO
               elseif (aorder.eq.2) then
                  NPDFerror=NPDFerrorNNLO
               endif
               do iset=1,NPDFerror
                  if (lums(0,porder).ne.0d0) then
                     xsecPDFerror(iset,aorder)=xsecPDFerror(iset,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff*
     $                    lums(iset,aorder)/lums(0,porder)*UserCuts
                  endif
               enddo
            endif

         enddo



      endif

      UserCuts=Rewk(maxorder)*UserCuts
      
      return
      end
