      double precision function UserCuts(part, Tcoeff,lums)
      implicit none

C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. W+
C        3. l+
C        4. nu      
C        5. W-
C        6. l-
C        7. nu_bar
C        8. part1
C        9. part2
C        10. hard jet
C        11. soft jet
      
C --------------------------------------------------
      double precision part(11,4)
      double precision Tcoeff

      include 'histos.f'
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'declar.f'

      double precision lums(0:NSMax,0:2)
      integer aorder,iset

      integer whichBin, startBin, counter
      double precision histval(NUMHIST), mvavars(5), mvaoutput

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   MODIFY THE FOLLOWING TO YOUR NEEDS                   CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC  

C -------- HELPER VARIABLES -----------
      double precision ptMu, ptAmu, invMass
      double precision phill, MET, pthard, ptsoft

      double precision pi
      parameter(pi=3.14159265358979d0)
      

      UserCuts=1d0

      if (bFillHisto) then
C---- compute variable: PHILL
         ptMu=dsqrt(part(3,2)**2+part(3,3)**2)
         ptAmu=dsqrt(part(6,2)**2+part(6,3)**2)
         invMass=(part(3,1)+part(6,1))**2
         invMass=invMass-(part(3,2)+part(6,2))**2
         invMass=invMass-(part(3,3)+part(6,3))**2
         invMass=invMass-(part(3,4)+part(6,4))**2
         invMass=dsqrt(invMass)

         phill=dacos(((part(3,2)+part(6,2))**2+(part(3,3)+part(6,3))**2-
     &        ptMu**2-ptAmu**2)
     &        /2d0/ptMu/ptAmu)

         phill=phill/pi*180d0

         MET=(part(4,2)+part(7,2))**2
         MET=MET+(part(4,3)+part(7,3))**2
         MET=dsqrt(MET)

         if(ptMu.gt.ptAmu) then
            pthard=ptMu
            ptsoft=ptAmu
         else
            pthard=ptAmu
            ptsoft=ptMu
         endif

         histval(1)=phill
         histval(2)=invMass
         histval(3)=MET
         histval(4)=pthard
         histval(5)=ptsoft

C---- fill mva array
c$$$         mvavars(1)=pthard
c$$$         mvavars(2)=ptsoft
c$$$         mvavars(3)=invMass
c$$$         mvavars(4)=MET
c$$$         mvavars(5)=phill/180d0*pi
c$$$
c$$$         call getval(mvaoutput,mvavars)
c$$$         
c$$$         histval(6)=mvaoutput
C     histval(6)=0d0

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   DO NOT TOUCH THE FOLLOWING                           CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C---- fill Histograms
         do aorder=minorder,maxorder
            startBin=1
            counter=1
            do while(counter.le.NUMHIST)         
               if(histval(counter).ge.LOWEDGE(counter).and.
     &              histval(counter).lt.HIGHEDGE(counter)) then
                  whichBin=(histval(counter)-LOWEDGE(counter))/
     &                 (HIGHEDGE(counter)-LOWEDGE(counter))
     &                 *NUMBINS(counter)+startBin
                  if (lums(0,porder).ne.0d0) then
                     HIST(whichBin,aorder)=HIST(whichBin,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(0,aorder)/lums(0,porder)*UserCuts
                  endif
               endif      
               startBin=startBin+NUMBINS(counter)
               counter=counter+1
            enddo
            
CCC   fill arrays for PDF errors
            xsecPDFerror(0,aorder)=xsecPDFerror(0,aorder)
     $           +Rewk(aorder)*Ras(aorder)*Tcoeff
     $           *lums(0,aorder)/lums(0,porder)
            if (fPDFerror.eq.1) then
               if (aorder.eq.0) then
                  NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  NPDFerror=NPDFerrorNLO
               elseif (aorder.eq.2) then
                  NPDFerror=NPDFerrorNNLO
               endif
               do iset=1,NPDFerror
                  if (lums(0,porder).ne.0d0) then
                     xsecPDFerror(iset,aorder)=xsecPDFerror(iset,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(iset,aorder)/lums(0,porder)*UserCuts
                  endif
               enddo
            endif

         enddo
      endif

      UserCuts=UserCuts*Rewk(maxorder)

      
      return
      end
