      double precision function UserCuts(part, Tcoeff,lums)
      implicit none

C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. Z1
C        3. l+
C        4. l-      
C        5. Z2
C        6. l+
C        7. l-
C        8. part1
C        9. part2
C        10. hard jet
C        11. soft jet
      
C --------------------------------------------------
      double precision part(11,4)
      double precision Tcoeff

      include 'histos.f'
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'declar.f'

      double precision lums(0:NSMax,0:2)
      integer aorder,iset

      integer whichBin, startBin, counter,pass,position,key(1:4),dummy
      double precision histval(NUMHIST)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   MODIFY THE FOLLOWING TO YOUR NEEDS                   CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 

C -------- HELPER VARIABLES -----------
      double precision pT1,pT2,pT3,pT4, MassT
      double precision pTl1,pTl2,pTl3,pTl4
      double precision pTl(1:4),eta(1:4)
      double precision pTmax1,pTmin1,pTmax2,pTmin2
      

      UserCuts=1d0
     

      if (bFillHisto) then
C---- compute variable: PHILL
         MassT=(part(3,1)+part(4,1)+part(6,1)+part(7,1))**2
         MassT=MassT-(part(3,4)+part(4,4)+part(6,4)+part(7,4))**2
         MassT=dsqrt(MassT)

         pTl1=dsqrt(part(3,2)**2+part(3,3)**2)
         pTl2=dsqrt(part(4,2)**2+part(4,3)**2)
         pTl3=dsqrt(part(6,2)**2+part(6,3)**2)
         pTl4=dsqrt(part(7,2)**2+part(7,3)**2)


         pTl(1)=pTl1
         pTl(2)=pTl2
         pTl(3)=pTl3
         pTl(4)=pTl4
         
         eta(1)=0.5*dlog((part(3,1)+part(3,4))/(part(3,1)-part(3,4)))
         eta(2)=0.5*dlog((part(4,1)+part(4,4))/(part(4,1)-part(4,4)))
         eta(3)=0.5*dlog((part(6,1)+part(6,4))/(part(6,1)-part(6,4)))
         eta(4)=0.5*dlog((part(7,1)+part(7,4))/(part(7,1)-part(7,4)))   
         
         
         key(1)=1
         key(2)=2
         key(3)=3
         key(4)=4
         
         !print*,"----"
         !print*,"pT unsorted: ",part(3,1)
         !print*,"pT unsorted: ",pTl(key(1)),pTl(key(2)),pTl(key(3)),pTl(key(4)) 
         
         do pass=1,3
                do position=1,3
                    if (pTl(key(position)) .lt. pTl(key(position+1))) then
                        dummy=key(position+1)
                        key(position+1)=key(position)
                        key(position)=dummy
                     !print*,"sorting: pass ",pass," position ",position,"\t::",pTl(key(1)),pTl(key(2)),pTl(key(3)),pTl(key(4))
                    endif
                enddo
         enddo
        
         
         
         pTmax1=max(pTl1,pTl2)
         pTmin1=min(pTl1,pTl2)
         pTmax2=max(pTl3,pTl4)
         pTmin2=min(pTl3,pTl4)
         
         if (pTmax2 .lt. pTmax1) then
            pT1 = pTmax1
            if (pTmax2 .lt. pTmin1) then
               pT2 = pTmin1
               
            else 
               pT2 = pTmax2
            endif
         else 
            pT1 = pTmax2
            if (pTmax1 .lt. pTmin2) then
               pT2 = pTmin2
            else 
               pT2 = pTmax1
            endif
         endif
         if (pTmin1 .lt. pTmin2) then
            pT4 = pTmin1
            if (pTmax1 .lt. pTmin2) then
               pT3 = pTmax1
            else 
               pT3 = pTmin2
            endif
         else 
            pT4 = pTmin2
            if (pTmax2 .lt. pTmin1) then
               pT3 = pTmax2
            else 
               pT3 = pTmin1
            endif
         endif
        
         !print*,"pT sorted: ",pTl(key(1)),pTl(key(2)),pTl(key(3)),pTl(key(4))    
         !print*,"keys:",key(1),key(2),key(3),key(4)  
         !print*,"pT sorted: ",pT1,pT2,pT3,pT4   
         if (pT1.ne.pTl(key(1)))  print*,"error in sorting", pT1,"!=",pTl(key(1))
         if (pT2.ne.pTl(key(2))) print*,"error in sorting", pT2,"!=",pTl(key(2))
         if (pT3.ne.pTl(key(3))) print*,"error in sorting", pT3,"!=",pTl(key(3))
         if (pT4.ne.pTl(key(4))) print*,"error in sorting", pT4,"!=",pTl(key(4))
         
C         histval(1)=MassT
         histval(1)=pT1
         histval(2)=pT2
         histval(3)=pT3
         histval(4)=pT4
         histval(5)=eta(key(1))
         histval(6)=eta(key(2))
         histval(7)=eta(key(3))
         histval(8)=eta(key(4))

        !print*,"UserCuts :: ",histval(1),histval(2),histval(3),histval(4),histval(5),histval(6),histval(7),histval(8)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   DO NOT TOUCH THE FOLLOWING                           CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C---- fill Histograms
         do aorder=minorder,maxorder
            startBin=1
            counter=1
            do while(counter.le.NUMHIST)         
               !print*,"UserCuts :: filling histogram ",counter
               if(histval(counter).ge.LOWEDGE(counter).and.
     &              histval(counter).lt.HIGHEDGE(counter)) then
                  whichBin=(histval(counter)-LOWEDGE(counter))/
     &                 (HIGHEDGE(counter)-LOWEDGE(counter))
     &                 *NUMBINS(counter)+startBin
                  if (lums(0,porder).ne.0d0) then
                     HIST(whichBin,aorder)=HIST(whichBin,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(0,aorder)/lums(0,porder)*UserCuts
                     !print*,"UserCuts :: adding with ",Rewk(aorder)*Ras(aorder)*Tcoeff*lums(0,aorder)/lums(0,porder)*UserCuts
                     !print*,"UserCuts :: HIST(",whichBin,aorder,")=",HIST(whichBin,aorder)
                  endif
               endif      
               startBin=startBin+NUMBINS(counter)
               counter=counter+1
            enddo
            
CCC   fill arrays for PDF errors
            xsecPDFerror(0,aorder)=xsecPDFerror(0,aorder)
     $           +Rewk(aorder)*Ras(aorder)*Tcoeff
     $           *lums(0,aorder)/lums(0,porder)
            if (fPDFerror.eq.1) then
               if (aorder.eq.0) then
                  NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  NPDFerror=NPDFerrorNLO
               elseif (aorder.eq.2) then
                  NPDFerror=NPDFerrorNNLO
               endif
               do iset=1,NPDFerror
                  if (lums(0,porder).ne.0d0) then
                     xsecPDFerror(iset,aorder)=xsecPDFerror(iset,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(iset,aorder)/lums(0,porder)*UserCuts
                  endif
               enddo
            endif

         enddo
      endif

      UserCuts=UserCuts*Rewk(maxorder)

      
      return
      end
