      double precision function UserCuts(part, Tcoeff,lums)
      implicit none

C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. gamma1
C        3. 
C        4.       
C        5. gamma2
C        6. 
C        7. 
C        8. part1
C        9. part2
C        10. hard jet
C        11. soft jet


C --------------------------------------------------
      double precision part(11,4)
      double precision Tcoeff

      include 'histos.f'
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'declar.f'

      double precision lums(0:NSMax,0:2)
      integer aorder,iset
      
      integer whichBin, startBin, counter
      double precision histval(NUMHIST)
      

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   MODIFY THE FOLLOWING TO YOUR NEEDS                   CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 

C -------- HELPER VARIABLES -----------
      double precision pta,ptb,etaa,etab
      double precision ptavg, ystar,ptlead
      double precision pthiggs,yhiggs
      

      UserCuts=1d0


      if (bFillHisto) then
         pthiggs=dsqrt(part(1,2)**2+part(1,3)**2)
         yhiggs=0.5*dlog((part(1,1)+part(1,4))/(part(1,1)-part(1,4)))

C---- compute variable: average pt of photons, rap difference, pt leading
         pta=dsqrt(part(2,2)**2+part(2,3)**2)
         ptb=dsqrt(part(5,2)**2+part(5,3)**2)
         ptavg=(pta+ptb)/2d0

         if (pta.gt.ptb) then
            ptlead=pta
         else
            ptlead=ptb
         endif


         etaa=0.5*dlog((part(2,1)+part(2,4))/(part(2,1)-part(2,4)))
         etab=0.5*dlog((part(5,1)+part(5,4))/(part(5,1)-part(5,4)))
         ystar=dabs(etaa-etab)/2d0

         histval(1)=ptavg
         histval(2)=ystar
         histval(3)=ptlead
         histval(4)=pthiggs
         histval(5)=dabs(yhiggs)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   DO NOT TOUCH THE FOLLOWING                           CCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C---- fill Histograms
         do aorder=minorder,maxorder
            
            startBin=1
            counter=1
            do while(counter.le.NUMHIST)
               if(histval(counter).ge.LOWEDGE(counter).and.
     &              histval(counter).lt.HIGHEDGE(counter)) then
                  whichBin=(histval(counter)-LOWEDGE(counter))/
     &                 (HIGHEDGE(counter)-LOWEDGE(counter))
     &                 *NUMBINS(counter)+startBin
                  if (lums(0,porder).ne.0d0) then
                     HIST(whichBin,aorder)=HIST(whichBin,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(0,aorder)/lums(0,porder)*UserCuts
                  endif
               endif      
               startBin=startBin+NUMBINS(counter)
               counter=counter+1
            enddo

CCC   fill arrays for PDF errors
            xsecPDFerror(0,aorder)=xsecPDFerror(0,aorder)
     $           +Rewk(aorder)*Ras(aorder)*Tcoeff
     $           *lums(0,aorder)/lums(0,porder)
            if (fPDFerror.eq.1) then
               if (aorder.eq.0) then
                  NPDFerror=NPDFerrorLO
               elseif (aorder.eq.1) then
                  NPDFerror=NPDFerrorNLO
               elseif (aorder.eq.2) then
                  NPDFerror=NPDFerrorNNLO
               endif
               do iset=1,NPDFerror
                  if (lums(0,porder).ne.0d0) then
                     xsecPDFerror(iset,aorder)=xsecPDFerror(iset,aorder)
     $                    +Rewk(aorder)*Ras(aorder)*Tcoeff
     $                    *lums(iset,aorder)/lums(0,porder)*UserCuts
                  endif
               enddo
            endif

         enddo

      endif

      UserCuts=Rewk(maxorder)*UserCuts

      
      return
      end
