CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   ewWilsonCoeffs
CCC
CCC   A simple program to compute Wilson coefficients for electroweak
CCC   corrections to gg->h
CCC
CCC   by Stefan Bucherer, 30th April 2009
CCC   based on HggTotalW
CCC
CCC   14th May 2009: LFCM routines by Radja Boughezal added 
CCC                  for replacing interpolation routines


      subroutine ewwilsoncoeffs(inputfile,len1,outputfile,len2,dir,len3)
      implicit none
      character*50 inputfile,outputfile
      character*128 dir
      integer len1,len2,len3

      double precision mhiggs, mtop, muR

      double precision fitted
      external fitted

      double precision LFCM
      external LFCM

      character*50 dummystring

C------------ Wilson coefficient definitions
      double precision  C1q, C2q, lambda, C0w,C1w, C2w, deltaEWK
      double precision C0,C1,C2,errC0,errC1,errC2

      double precision Lr,Lt

CCC   read in parameters
      open(unit=14,file=inputfile,status='old')
      read(14,*) dummystring, mhiggs
      read(14,*) dummystring, mtop
      read(14,*) dummystring, muR
      close(14)



CCC   compute coefficients
      Lr=dlog(mur**2/mhiggs**2)
      Lt=dlog(mhiggs**2/mtop**2)

      C1q=11d0/4d0
      C2q =2777d0/288d0+19d0/16d0*(Lr+Lt)
     #+5d0*(-67d0/96d0 +1d0/3d0*(Lr+Lt))


      deltaEWK=LFCM(mhiggs)
      lambda=deltaEWK/2d0

C      deltaEWK=fitted(mhiggs)/100d0 
C      lambda=deltaEWK/2d0

      C0w=lambda
      C1w=7d0/6d0*lambda

C---- this value is not known -> arbitrary
      C2w=10d0*lambda

      C0=C0w
      C1=C1w
      C2=C2w

      errC0=0d0
      errC1=0d0
      errC2=0d0


CCC   output results
      call unlink(outputfile)
      open(unit=21,file=outputfile,status='new')
      write(21,*)'mhiggs=  ',mhiggs
      write(21,*)'muR   =  ',mur
      write(21,*)'mtop  =  ',mtop
      write(21,*)
      write(21,*)'C0    = ',C0,' +/- ',errC0
      write(21,*)'C1    = ',C1,' +/- ',errC1
      write(21,*)'C2 max= ',C2,' +/- ',errC2
      write(21,*)'C2 min= ',-C2,' +/- ',errC2
      close(21)

      return
      end
