CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Mixed QCD/Electroweak corrections
CCC   arXiv:0811.3458 [hep-ph] 


      subroutine EWKCorr(fewk,mW,GammaW,mZ,GammaZ,
     $     mt,mh,muF,muR)
      implicit none
      integer fewk
      double precision mW,GammaW,mZ,GammaZ,mt,mh,muF,muR

      double precision Lr,Lt
      double precision deltaEWK
      double precision deltaRadja
      external deltaRadja
      include 'constants.f'

      Lr=dlog(muR**2/mh**2)
      Lt=dlog(mh**2/mt**2)
      
CCC   Heavy quark Wilson coefficients
CCC   We assume Nf=5. Scheme dependence?
      C1q_ewk=11d0/4d0
      C2q_ewk =2777d0/288d0+19d0/16d0*(Lr+Lt)
     $     +5d0*(-67d0/96d0 +1d0/3d0*(Lr+Lt))


      if (fewk.ge.1) then


         deltaEWK=deltaRadja(mW,GammaW,mZ,GammaZ,mt,mh)
         lambda_ewk=deltaEWK/2d0

C---  Wilson coefficient computed in arXiv:0811.3458 [hep-ph]  
C---  by Anastasiou et al
         C1w_ewk=7d0/60
C------  C2w is not computed but only estimated for the four-loop 
C------  mix QCD-EWK diagrams.  The  result is rather insensitive to 
C------   "reasonable" values (close to similar top-quark Wilson coeffs.) 
         C2w_ewk=-10d0
      else
         C1w_ewk=0d0
         C2w_ewk=0d0
         lambda_ewk=0d0      
      endif



c$$$      write(6,*)'lambda= ',lambda_ewk
c$$$      write(6,*)'C1q_ewk= ',C1q_ewk
c$$$      write(6,*)'C2q_ewk= ',C2q_ewk
c$$$      write(6,*)'C1w_ewk= ',C1w_ewk
c$$$      write(6,*)'C2w_ewk= ',C2w_ewk

      return
      end
