CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Btilde.f


CCC   =================================================================
CCC   Btilde is the integrand for the total cross section
CCC   Int Btilde dxrad = cross section
      double precision function Btilde(nd,var,weight,iflag)
      implicit none
      integer nd,iflag
      double precision var(nd),weight

      double precision xrad(nd),buf
C      parameter(buf=0.0001d0)
C       parameter(buf=0.00001d0)
      parameter(buf=10d-13)
      double precision res
      double precision jacb,jacc,jacr,jacd,rjacc,rjacr
      double precision resb,resc,resr

      double precision Bsoft

      double precision Borngg,Borngg2,Virtgg
      double precision Collggp1,Collggm1,Collggp2,Collggm2
      double precision Collqgp2,Collqgm2,Collgqp2,Collgqm2
      double precision Bremsgg,Bremsqg
      double precision Bremsgq,Bremsqq

      double precision zmin,zminp,zminm

      integer po,j,iset

      double precision bborn,bborn2,vvirt,ccollp1,ccollm1
      save bborn,bborn2,vvirt,ccollp1,ccollm1

      logical negflag,ifirst

      double precision Fcut
      external Fcut

      double precision normb,normc,normr

      include 'model.f'
      include 'event.f'
      include 'kinem.f'
      include 'xsection.f'
      include 'pdfcontrol.f'
      include 'hprocontrol.f'

      logical fdebug
      common/debug/fdebug


      fdebug=.false.

      Kgluino=0d0
      dKgluino=0d0

      idim=nd
      do j=1,nd
         xrad(j)=buf+(1d0-2d0*buf)*var(j)
         xxrad(j)=xrad(j)
      enddo

 
 
      Btilde=0d0
      ifirst=.false.
      irecalc=1
      irecalc2=1

      negflag=.true.
      

CCC   ---------------------------------------------------------------
CCC   Initializing
      Borngg=0d0
      Virtgg=0d0
      Collggp1=0d0
      Collggm1=0d0
      Bremsgg=0d0
      Bremsqg=0d0
      Bremsgq=0d0
      Bremsqq=0d0

      Collggp2=0d0
      Collgqp2=0d0
      Collqgp2=0d0
      Collggm2=0d0
      Collgqm2=0d0
      Collqgm2=0d0
      
      do j=1,nevts
         xx(j,1)=-1d0
         xx(j,2)=-1d0
      enddo


CCC   ---------------------------------------------------------------
CCC   Generate phase space (variables and jacobians)

      call GenPhaseSpace(nd,xrad,jacb,jacc,jacr,jacd,rjacc,rjacr)

      zmin=tauh
      zminp=tauh
      zminm=tauh
      
      
      
      z=zscaled
      zp=z
      zm=z
      
      
      xx(2,1)=dsqrt(tauh/z)*dexp(yrap)
      xx(2,2)=tauh/z/xx(2,1)
 

      xx(3,1)=xx(2,1)
      xx(3,2)=xx(2,2)
      
      xx(4,1)=xx(2,1)
      xx(4,2)=xx(2,2)
      
CCC   ---------------------------------------------------------------
CCC   Invariants

CCC   soft event
      s12(1)=xx(1,1)*xx(1,2)*S
      s13(1)=0d0
      s23(1)=0d0
      s1v(1)=0d0
      s2v(1)=0d0
      s3v(1)=mh2
      s4v(1)=mh2

CCC   real event
      s12(2)=xx(2,1)*xx(2,2)*S
      s13(2)=-s12(2)*(1d0-z)*(1d0-y)/2d0
      s23(2)=-s12(2)*(1d0-z)*(1d0+y)/2d0
      s1v(2)=-s12(2)/2d0*(1d0+y+z*(1d0-y))+mh2
      s2v(2)=-s12(2)/2d0*(1d0-y+z*(1d0+y))+mh2
      s3v(2)=s12(2)/2d0*(2d0-z*(z+1d0))+mh2
      s4v(2)=mh2


CCC   collinear + event
      s12(3)=xx(3,1)*xx(3,2)*S
      s13(3)=0d0
      s23(3)=-s12(3)*(1d0-zp)
      s1v(3)=-s12(3)+mh2
      s2v(3)=0d0
      s3v(3)=s12(3)/2d0*(2d0-zp*(zp+1d0))+mh2
      s4v(3)=mh2

CCC   collinear - event
      s12(4)=xx(4,1)*xx(4,2)*S
      s13(4)=-s12(4)*(1d0-zm)
      s23(4)=0d0
      s1v(4)=0d0
      s2v(4)=-s12(4)+mh2
      s3v(4)=s12(4)/2d0*(2d0-zm*(zm+1d0))+mh2
      s4v(4)=mh2



CCC   ---------------------------------------------------------------
CCC   compute different contributions

CCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Born & Virtual
CCCCCCCCCCCCCCCCCCCCCCCCCCC
      if (iflag.gt.0) then

         norm=1d0
         po=iorder
         call Psi(po,Borngg,Borngg2,Virtgg)
         norm=1d0

         bborn=Borngg
         bborn2=Borngg2
         vvirt=Virtgg
         
         ccollp1=as/(2d0*PI)*beta0*dlog(mh2/muF**2)*bborn2
         ccollm1=ccollp1

         norm=norm*gev2pb

C         write(6,*)Borngg,Virtgg

      endif
      
      if (.not.channels(1)) then
         Borngg=0d0
      else
         Borngg=bborn
      endif
      if (.not.channels(2)) then
         Virtgg=0d0
      else
         Virtgg=vvirt
      endif

      if (.not.channels(3)) then
         Collggp1=0d0
         Collggm1=0d0
      else
         Collggp1=ccollp1
         Collggm1=ccollm1
      endif

      normb=jacd*norm*jacb
      normc=jacd*norm*jacc
      normr=jacd*norm*jacr

      Bsoft=normb*(Borngg+Virtgg+Collggp1+Collggm1)
      Bsoft=Bsoft*Fcut(1,'gg  ',idim,xxrad,Bsoft)


CCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Collinear remnants
CCCCCCCCCCCCCCCCCCCCCCCCCCC
      if (channels(3)) then
         call GCollgg(normc,3,'gg  ',bborn2,zminp,zscaled,zp,rjacc,
     $        Collggp2)
         call GCollgg(normc,4,'gg  ',bborn2,zminm,zscaled,zm,rjacc,
     $        Collggm2)
      endif

      if (channels(5)) then
         call GCollqg(normc,3,'qg  ',bborn2,zminp,zscaled,zp,rjacc,
     $        Collqgp2)
         Collqgm2=0d0
        
         call GCollqg(normc,4,'gq  ',bborn2,zminm,zscaled,zm,rjacc,
     $        Collgqm2)
         Collgqp2=0d0
      endif


CCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Bremsstrahlung
CCCCCCCCCCCCCCCCCCCCCCCCCCC

CCC   Bremsstrahlung gg
      if (channels(4)) then
         call Rbremsgg(normr,y,zscaled,z,zp,zm,zmin,zminp,
     $        zminm,rjacr,s12(2),s13(2),s23(2),Bremsgg)
      endif


CCC   Bremsstrahlung qg & gq
      if (channels(6)) then
         call Rbremsqg(normr,y,zscaled,z,zp,zm,zmin,zminp,zminm,
     $        rjacr,s12(2),s13(2),s23(2),Bremsqg,Bremsgq)
      endif

CCC   Bremsstrahlung qq
      if (channels(7)) then
         call Rbremsqq(normr,z,s12(2),s13(2),s23(2),Bremsqq)
      endif
      

CCC   -----------------------------------------------------------------
CCC   collect everything         


      Btilde = (Bsoft + Collggp2 + Collggm2 + Collgqp2 + Collgqm2 
     $     + Collqgp2 + Collqgm2 + Bremsgg + Bremsgq + Bremsqg 
     $     + Bremsqq)

      xschannels(1)=xschannels(1) + (Bsoft + Collggp2 + Collggm2 
     $     + Bremsgg)*weight
      xschannels(2)=xschannels(2) + (Collgqp2 + Collgqm2 
     $     + Collqgp2 + Collqgm2 + Bremsgq + Bremsqg)*weight
      xschannels(3)=xschannels(3) + Bremsqq*weight

c$$$      if (dabs(Btilde).gt.dabs(tmpmax)) then
c$$$         tmpmax=Btilde
c$$$         write(6,*)'$$$$$$$$$$$$$$$$$$'
c$$$         write(6,*)Btilde
c$$$         write(6,*)xrad
c$$$         write(6,*)s12(2),s13(2),s23(2)
c$$$      endif

C      write(6,*)'Btilde= ',Btilde

c$$$      if (0d0*Btilde.eq.0d0) then
c$$$         continue
c$$$      else
c$$$      if (isnan(Btilde)) then
c$$$         write(6,*)
c$$$         write(6,*)'ATTENTION!'
c$$$         write(6,*)xrad,weight
c$$$         write(6,*)Btilde
c$$$         write(6,*)Bsoft,Borngg,normb
c$$$         write(6,*)xsevt
c$$$         write(6,*)'jac ',jacb,jacc,jacr
c$$$         write(6,*)'born ',Borngg,Virtgg,Collggp1,Collggm1
c$$$         write(6,*)'collgg2 ',Collggp2,Collggm2
c$$$         write(6,*)'collqg2 ',Collqgp2,Collqgm2
c$$$         write(6,*)'collgq2 ',Collgqm2,Collgqp2
c$$$         write(6,*)'bremsgg ',Bremsgg
c$$$         write(6,*)'bremsgq ',Bremsgq
c$$$         write(6,*)'bremsqg ',Bremsqg 
c$$$         write(6,*)'bremsqq ',Bremsqq
c$$$         write(6,*)'x1xx(2,2): '
c$$$         write(6,*)xx(1,1),xx(1,2),z,y
c$$$         write(6,*)xx(2,1),xx(2,2)
c$$$         write(6,*)xx(3,1),xx(3,2)
c$$$         write(6,*)xx(4,1),xx(4,2)
c$$$         write(6,*)'z: '
c$$$         write(6,*)zscaled,zmin,zminp,zminm
c$$$         write(6,*)z,zp,zm
c$$$         write(6,*)s12
c$$$         write(6,*)s13
c$$$         write(6,*)s23
c$$$         write(6,*)mh**2,mh2,mt**2,mt2,mb**2,mb2
c$$$         write(6,*)'Emergency!!!'
c$$$         stop
c$$$      endif

C      if (fdebug) then
C         write(6,*)
C         write(6,*)'ATTENTION!'
C         write(6,*)xrad,weight
C         write(6,*)Btilde
c$$$         write(6,*)Bsoft,Borngg,normb
c$$$         write(6,*)'born ',Borngg,Virtgg,Collggp1,Collggm1
c$$$         write(6,*)'collgg2 ',Collggp2,Collggm2
c$$$         write(6,*)'collqg2 ',Collqgp2,Collqgm2
c$$$         write(6,*)'collgq2 ',Collgqm2,Collgqp2
c$$$         write(6,*)'bremsgg ',Bremsgg
c$$$         write(6,*)'bremsgq ',Bremsgq
c$$$         write(6,*)'bremsqg ',Bremsqg 
c$$$         write(6,*)'bremsqq ',Bremsqq
c$$$         write(6,*)'x1xx(2,2): '
c$$$         write(6,*)xx(1,1),xx(1,2),z,y
c$$$         write(6,*)xx(2,1),xx(2,2)
c$$$         write(6,*)xx(3,1),xx(3,2)
c$$$         write(6,*)xx(4,1),xx(4,2)
c$$$         write(6,*)'z: '
c$$$         write(6,*)zscaled,zmin,zminp,zminm
c$$$         write(6,*)z,zp,zm
c$$$         write(6,*)s12
c$$$         write(6,*)s13
c$$$         write(6,*)s23
c$$$  
C      endif

C      stop
      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   End of File
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
