CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Fcut.f


      double precision function Fcut(ievt,cch,ndim,xrad,val)
      implicit none
      integer ievt,ndim
      character*4 cch
      double precision xrad(ndim),val

      include 'event.f'
      include 'pdfcontrol.f'
      include 'constants.f'
      include 'histos.f'

      double precision lumqiqj,lumqiqi,lumuiubi,lumdidbi
      double precision lumgg,lumug,lumdg
      dimension lumqiqj(0:NSMax,0:2),lumqiqi(0:NSMax,0:2)
      dimension lumuiubi(0:NSMax,0:2),lumdidbi(0:NSMax,0:2)
      dimension lumgg(0:NSMax,0:2),lumug(0:NSMax,0:2),lumdg(0:NSMax,0:2)

      double precision lum(0:NSMax,0:2)
      integer aorder,iset,Nset

      double precision zspartonic

      double precision constraint,constraintgg
      external constraint,constraintgg

      integer j,zdim
      parameter( zdim= 3)
      double precision var(ndim)
      double precision qqq(zdim)
CCC   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
CCC   Common blocks for constraint function
C -------- COMMON BLOCK PARTICLE DATA --------------
C     order:
C        1. Higgs
C        2. W+
C        3. l+
C        4. nu      
C        5. W-
C        6. l-
C        7. nu_bar
C        8. part1
C        9. part2
C        10. jet1
C        11. jet2

      double precision part(11,4)
      COMMON/particles/part
C --------------------------------------------------
      include 'masses.f'

      double precision x1,x2
      double precision ss13,ss23,ss14,ss24,ss34,ss1v,ss2v,ss3v,ss4v


      double precision tt1,tt2,tt3
      double precision fpflag
      double precision xxtmp

CCC   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C      write(6,*)
C      write(6,*)'Fcut: ',ievt

      Fcut=0d0

CCC   =====================================
CCC   translate into constraint variables


      x1=xx(ievt,1)
      x2=xx(ievt,2)

      zspartonic=m2/s12(ievt)
      ss13=s13(ievt)/s12(ievt)
      ss23=s23(ievt)/s12(ievt)
      ss14=0d0
      ss24=0d0
      ss34=0d0
      ss1v=s1v(ievt)/s12(ievt)
      ss2v=s2v(ievt)/s12(ievt)
      ss3v=s3v(ievt)/s12(ievt)
      ss4v=s4v(ievt)/s12(ievt)

      do j=1,ndim
         var(j)=xrad(j)
      enddo

CCC   dummy variables
      do j=1,zdim
         qqq(j)=1d0
      enddo

CCC   =====================================
CCC   Compute Luminosities

      fpflag=1d0
      if ((cch.eq.'qg  ').or.(cch.eq.'ug  ').or.(cch.eq.'dg  ')) then
         fpflag=1d0
         call Luminosity(x2,x1,fpflag,lumqiqj,lumqiqi,
     $     lumuiubi,lumdidbi,lumgg,lumug,lumdg)
      elseif ((cch.eq.'gq  ').or.(cch.eq.'gu  ')
     $        .or.(cch.eq.'gd  ')) then
         fpflag=-1d0
         call Luminosity(x1,x2,fpflag,lumqiqj,lumqiqi,
     $     lumuiubi,lumdidbi,lumgg,lumug,lumdg)
      else
         call Luminosity(x1,x2,fpflag,lumqiqj,lumqiqi,
     $     lumuiubi,lumdidbi,lumgg,lumug,lumdg)
      endif

      
      

      do aorder=minorder,maxorder
         do iset=0,NSMax
            lum(iset,aorder)=0d0
         enddo
         NPDFerror=0
         if (aorder.eq.0) then
            if (fPDFerrorLO.eq.1) NPDFerror=NPDFerrorLO
         elseif (aorder.eq.1) then
            if (fPDFerrorNLO.eq.1) NPDFerror=NPDFerrorNLO
         else
            if (fPDFerrorNNLO.eq.1) NPDFerror=NPDFerrorNNLO
         endif
         do iset=0,NPDFerror
            if (cch.eq.'gg  ') then
               lum(iset,aorder)=lumgg(iset,aorder)/x1/x2
            elseif (cch.eq.'gq  ') then
               lum(iset,aorder)=(lumug(iset,aorder)
     $              +lumdg(iset,aorder))/x1/x2
            elseif (cch.eq.'gu  ') then
               lum(iset,aorder)=lumug(iset,aorder)/x1/x2
            elseif (cch.eq.'gd  ') then
               lum(iset,aorder)=lumdg(iset,aorder)/x1/x2
            elseif (cch.eq.'qg  ') then
               lum(iset,aorder)=(lumug(iset,aorder)
     $              +lumdg(iset,aorder))/x1/x2
            elseif (cch.eq.'ug  ') then
               lum(iset,aorder)=lumug(iset,aorder)/x1/x2
            elseif (cch.eq.'dg  ') then
               lum(iset,aorder)=lumdg(iset,aorder)/x1/x2
            elseif (cch.eq.'qqb ') then
               lum(iset,aorder)=(lumuiubi(iset,aorder)
     $              +lumdidbi(iset,aorder))/x1/x2
            elseif (cch.eq.'uub ') then
               lum(iset,aorder)=lumuiubi(iset,aorder)/x1/x2
            elseif (cch.eq.'ddb ') then
               lum(iset,aorder)=lumdidbi(iset,aorder)/x1/x2
            endif
         enddo
      enddo

C      write(6,*)'Fcut: '
C      write(6,*)ievt,cch,x1,x2
C      write(6,*)ss13,ss23

      if (ifastinclusive.eq.0) then
CCC   =====================================
CCC   Call constraint function
        !print*,"Fcut :: ndecay= ",ndecay
         if (ndecay.lt.5) then
            tt1=lum(0,porder)
            tt2=tt1*val
            tt3=constraint(var,qqq,ndim,zdim,zspartonic,x1,x2,
     $           ss13,ss23,ss14,ss24,ss34,ss1v,ss2v,ss3v,ss4v,tt2,lum)
            Fcut=tt1*tt3
         else
            tt1=lum(0,porder)
            tt2=tt1*val
            tt3=constraintgg(var,qqq,ndim,zdim,zspartonic,x1,x2,
     $           ss13,ss23,ss14,ss24,ss34,ss1v,ss2v,ss3v,ss4v,tt2,lum)
            Fcut=tt1*tt3
         endif
      else
         Fcut=lum(0,porder)
         do aorder=minorder,maxorder
            do iset=0,NPDFerror
               xsecPDFerror(iset,aorder)=xsecPDFerror(iset,aorder)
     $              +Ras(aorder)*val*lum(iset,aorder)
            enddo
         enddo
         
      endif



C      write(6,*)Fcut,lum(0,porder)

      return
      end

