CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   GenPhaseSpace.f

      subroutine GenPhaseSpace(nd,xrad,jacb,jacc,jacr,jacd,rjacc,rjacr)
      implicit none
      integer nd
      double precision xrad(nd),jacb,jacc,jacr,jacd,rjacc,rjacr

      double precision yy,zz,xx1,xx2,yrap0
      double precision uu

      double precision tiny
      parameter(tiny=0d0)

      include 'event.f'
      include 'kinem.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      jacb=1d0
      jacc=1d0
      jacr=1d0
      jacd=1d0
      rjacc=1d0
      rjacr=1d0


      jacb=2d0*PI/S*jacb

      if (iorder.eq.0) then
CCC   LO, no decay
            
         yrap=dlog(tauh)/2d0*(-1d0+2d0*xrad(1))
C         phi=2d0*PI*xrad(2)
         phi=0d0
         jacb=-jacb*dlog(tauh)
         yrapdif=0d0
         phig=0d0
         y=0d0
         zscaled=0d0

         xx(1,1)=dsqrt(tauh)*dexp(yrap)
         xx(1,2)=tauh/xx(1,1)

      elseif (iorder.eq.1) then
CCC   NLO, no decay

         phi=0d0
         yrapdif=0d0
         phig=0d0

         
         zz=tiny+(1d0-2d0*tiny)*xrad(2)
         zscaled=tauh+(1d0-tauh)*zz
         jacc=jacb*(1d0-tauh)*(1d0-2d0*tiny)

         yrap=0.5d0*dlog(tauh/zscaled)*(1d0-2d0*xrad(1))
         jacc=-jacc*dlog(tauh/zscaled)

         yrap0=0.5d0*dlog(tauh)*(1d0-2d0*xrad(1))
         jacb=-jacb*dlog(tauh)

         y=(-1d0+tiny)+2d0*(1d0-tiny)*xrad(3)
         jacr=jacc*2d0*2d0*PI*(1d0-tiny)

         rjacc=dlog(tauh)/dlog(tauh/zscaled)
         rjacr=rjacc
         
         xx(2,1)=dsqrt(tauh/zscaled)*dexp(yrap)
         xx(2,2)=tauh/zscaled/xx(2,1)

         xx(1,1)=dsqrt(tauh)*dexp(yrap0)
         xx(1,2)=tauh/xx(1,1)



      endif


      return
      end


