CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Model.f
CCC   File for calculating couplings and parameters 
CCC   in different models


      subroutine InitSM
      implicit none

      integer i,j
      double precision Lambda

      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      double precision cw,sw,gz,gw

      htype=0


      mW2=mW**2
      mZ2=mZ**2
      mh2=mh**2
      mt2=mt**2
      mb2=mb**2
      ms12=ms1**2
      ms22=ms2**2
      msb12=msb1**2
      msb22=msb2**2

      sw2=1d0-mW2/mZ2

      sw=dsqrt(sw2)
      cw=dsqrt(1d0-sw2)
      gz=dsqrt(8*mW2*GF/dsqrt(2.0d0))/cw
      gw=dsqrt(8*mW2*GF/dsqrt(2.0d0))

      Lambda=dsqrt(dsqrt(2d0)*GF)
C      Lambda=1d0

      ytth=ytrel*Lambda
      ybbh=ybrel*Lambda

      gvzu = gz*(0.25d0-2D0/3D0*sw**2)
      gvzd = gz*(-0.25d0+1D0/3D0*sw**2)
      gazu = gz*(-0.25d0)
      gazd = gz*(0.25d0)
	
      ghww = gw*mW
      ghzz = gz*mZ
      gvw = gw/2d0/dsqrt(2d0)
      gaw = -gw/2d0/dsqrt(2d0)
      

      do i=1,2
         do j=1,2
            yssh(i,j)=0d0
            ysbsbh(i,j)=0d0
         enddo
         relt(i)=0d0
         relb(i)=0d0
      enddo

      

C      write(6,*)'SM couplings initialized to: '
C      write(6,*)ytth,ybbh,yssh(1,1),yssh(2,2),ysbsbh(1,1),ysbsbh(2,2)

      return
      end


      subroutine InitMSSM
      implicit none

      integer i,j
      double precision Lambda

      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      ytth=0d0
      ybbh=0d0
      do i=1,2
         do j=1,2
            yssh(i,j)=0d0
            ysbsbh(i,j)=0d0
         enddo
      enddo

      Lambda=dsqrt(dsqrt(2d0)*GF)
C      Lambda=1d0

      mW2=mW**2
      mZ2=mZ**2
      mh2=mh**2
      mt2=mt**2
      mb2=mb**2
      ms12=ms1**2
      ms22=ms2**2
      msb12=msb1**2
      msb22=msb2**2

      sw2=1d0-mW2/mZ2

      if (htype.eq.1) alpha=alpha-PI/2d0


      if (ytrel.ne.0d0) then
         call h0_couplings('TOP',mt,ms1,ms2,ths,alpha,beta,mZ,
     $        sw2,mu,ytth,yssh)
      endif

      if (ybrel.ne.0d0) then
         call h0_couplings('BOT',mb,msb1,msb2,thsb,alpha,beta,mZ,
     $        sw2,mu,ybbh,ysbsbh)
      endif

      ytth=Lambda*ytth
      ybbh=Lambda*ybbh
      do i=1,2
         do j=1,2
            yssh(i,j)=Lambda*yssh(i,j)
            ysbsbh(i,j)=Lambda*ysbsbh(i,j)
         enddo
      enddo

      

      relt(1)=mt2/ms12
      relt(2)=mt2/ms22
      relb(1)=mb2/msb12
      relb(2)=mb2/msb22

      

      write(6,*)'MSSM couplings initialized to: '
      write(6,*)ytth,ybbh,yssh(1,1),yssh(2,2),ysbsbh(1,1),ysbsbh(2,2)

      return
      end
