CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Psi.f


      subroutine Psi(porder,born2,born22,virtual2)
CCC   calculates the 2 -> 1 differential cross section
CCC   po=0: Leading Order
CCC   po=1: Next to leading Order
      implicit none
      double precision born2,born22,virtual2
      integer porder

      integer po,icontr
      double precision avgfac,flux
      double precision squaredme,soft2,scheme2,gluino2
      double precision pf
      double precision SMEggh
      external SMEggh

      double precision temp

      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      squaredme=0d0
      born2=0d0
      virtual2=0d0
      soft2=0d0
      scheme2=0d0
      gluino2=0d0

      flux=1d0/(2d0*mh2)
      avgfac=1d0/(2d0*(Nc**2-1d0))**2
      
      pf=flux*avgfac

      po=0
      icontr=0
      born2=SMEggh(po,icontr,mh2)

       po=1
      icontr=0
      born22=SMEggh(po,icontr,mh2)
           
      if (porder.eq.1) then
         po=1
         icontr=1
         squaredme=SMEggh(po,icontr,mh2)

         soft2=Nc*2d0*PI**2/3d0*born22
         soft2=as/(2d0*PI)*soft2

         if (imbscheme.eq.1) then
            Fmtscheme=-CF*(4d0 + 3d0*dlog(muT**2/mt**2))
            Fmbscheme=0d0
            Fms1scheme=-CF*(7d0+3d0*dlog(muS1**2/ms1**2))
            Fms2scheme=-CF*(7d0+3d0*dlog(muS2**2/ms2**2))
            Fmsb1scheme=-CF*(7d0+3d0*dlog(muSB1**2/msb1**2))
            Fmsb2scheme=-CF*(7d0+3d0*dlog(muSB2**2/msb2**2))
            Fgscheme=0d0
         elseif (imbscheme.eq.0) then
            Fmtscheme=-CF*(4d0 + 3d0*dlog(muT**2/mt**2))
            Fmbscheme=-CF*(4d0 + 3d0*dlog(muB**2/mb**2))
            Fms1scheme=-CF*(7d0+3d0*dlog(muS1**2/ms1**2))
            Fms2scheme=-CF*(7d0+3d0*dlog(muS2**2/ms2**2))
            Fmsb1scheme=-CF*(7d0+3d0*dlog(muSB1**2/msb1**2))
            Fmsb2scheme=-CF*(7d0+3d0*dlog(muSB2**2/msb2**2))
            Fgscheme=0d0
         endif
         po=1
         icontr=2
         scheme2= SMEggh(po,icontr,mh2)
         gluino2=as/(4d0*PI)*Kgluino*born22
         virtual2=(squaredme+soft2+scheme2+gluino2)

 

      endif



      born2=pf*born2
      born22=pf*born22
      virtual2=pf*virtual2



      return
      end

