CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     SMEgghg.f
C
C     Evaluates the squared matrix elements of gg -> gh

      function SMEgghg(s12,s13,s23)
      implicit none
      double precision SMEgghg
      double precision s12,s13,s23
      
      double complex rel

      double precision mesquared,prefac
      
      double complex meggppp,meggppm
      double complex meggpppmtop,meggppmmtop
      
      double complex dnorm
      double complex gg(4),tgg(4),dtgg(4),bgg(4),sgg(2,2),sbgg(2,2)
      double complex bub(1:4),trian(1:4),boxx(1:3)
      double complex bbub(1:4),btrian(1:4),bboxx(1:3)
 
      double complex bub2(1:4),trian2(1:4),boxx2(1:3)
      double complex bub3(1:4),trian3(1:4),boxx3(1:3)
      integer i,j

      external meggppp,meggppm
      external meggpppmtop,meggppmmtop


      double complex tbubs,tbubt,tbubu,tbubmh
      double complex ttrians,ttriant,ttrianu,ttrianmh
      double complex tboxst,tboxsu,tboxtu
      double complex bbubs,bbubt,bbubu,bbubmh
      double complex btrians,btriant,btrianu,btrianmh
      double complex bboxst,bboxsu,bboxtu
      common/tints/tbubs,tbubt,tbubu,tbubmh,ttrians,ttriant,
     &     ttrianu,ttrianmh,tboxst,tboxsu,tboxtu
      common/bints/bbubs,bbubt,bbubu,bbubmh,btrians,btriant,
     &     btrianu,btrianmh,bboxst,bboxsu,bboxtu

      double precision rnorm
      common/hpronorm/rnorm

      double precision tme,tbme,bme,sme
      double precision deltaMinfty

      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'


      SMEgghg=0d0

      
      do j=1,4
         tgg(j)=dcmplx(0d0,0d0)
         dtgg(j)=dcmplx(0d0,0d0)
         bgg(j)=dcmplx(0d0,0d0)
         do i=1,2
            sgg(i,j)=dcmplx(0d0,0d0)
            sbgg(i,j)=dcmplx(0d0,0d0)
         enddo
      enddo

C     C----------------------------------------------------
      linfty=linftyNLO

C     C----------------------------------------------------
      
      prefac=as**3/(32d0*PI)*(Nc**2-1d0)*Nc

      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ytth.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mt,tbubs,tbubt,tbubu,
     &              tbubmh,ttrians,ttriant,ttrianu,ttrianmh,
     &              tboxst,tboxsu,tboxtu)
            endif

            bub(1)=tbubs
            bub(2)=tbubt
            bub(3)=tbubu
            bub(4)=tbubmh
            trian(1)=ttrians
            trian(2)=ttriant
            trian(3)=ttrianu
            trian(4)=ttrianmh
            boxx(1)=tboxst
            boxx(2)=tboxsu
            boxx(3)=tboxtu


C     s12 <-> s13
            bub2(1)=bub(2)
            bub2(2)=bub(1)
            bub2(3)=bub(3)
            bub2(4)=bub(4)
            trian2(1)=trian(2)
            trian2(2)=trian(1)
            trian2(3)=trian(3)
            trian2(4)=trian(4)
            boxx2(1)=boxx(1)
            boxx2(2)=boxx(3)
            boxx2(3)=boxx(2)
            
C     s12 <-> s23
            bub3(1)=bub(3)
            bub3(2)=bub(2)
            bub3(3)=bub(1)
            bub3(4)=bub(4)
            trian3(1)=trian(3)
            trian3(2)=trian(2)
            trian3(3)=trian(1)
            trian3(4)=trian(4)
            boxx3(1)=boxx(3)
            boxx3(2)=boxx(2)
            boxx3(3)=boxx(1)
            
            tgg(1) = meggppp(s12,s13,s23,mh,mt,bub,trian,boxx)
            tgg(2) = meggppp(s13,s12,s23,mh,mt,bub2,trian2,boxx2)
            tgg(3) = meggppp(s23,s13,s12,mh,mt,bub3,trian3,boxx3)
            tgg(4) = meggppm(s12,s13,s23,mh,mt,bub,trian,boxx)
          endif
      endif
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ybbh.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mb,bbubs,bbubt,bbubu,
     &              bbubmh,btrians,btriant,btrianu,btrianmh,
     &              bboxst,bboxsu,bboxtu)
            endif

            bbub(1)=bbubs
            bbub(2)=bbubt
            bbub(3)=bbubu
            bbub(4)=bbubmh
            btrian(1)=btrians
            btrian(2)=btriant
            btrian(3)=btrianu
            btrian(4)=btrianmh
            bboxx(1)=bboxst
            bboxx(2)=bboxsu
            bboxx(3)=bboxtu
            
C     s12 <-> s13
            bub2(1)=bbub(2)
            bub2(2)=bbub(1)
            bub2(3)=bbub(3)
            bub2(4)=bbub(4)
            trian2(1)=btrian(2)
            trian2(2)=btrian(1)
            trian2(3)=btrian(3)
            trian2(4)=btrian(4)
            boxx2(1)=bboxx(1)
            boxx2(2)=bboxx(3)
            boxx2(3)=bboxx(2)
            
C     s12 <-> s23
            bub3(1)=bbub(3)
            bub3(2)=bbub(2)
            bub3(3)=bbub(1)
            bub3(4)=bbub(4)
            trian3(1)=btrian(3)
            trian3(2)=btrian(2)
            trian3(3)=btrian(1)
            trian3(4)=btrian(4)
            boxx3(1)=bboxx(3)
            boxx3(2)=bboxx(2)
            boxx3(3)=bboxx(1)
            
            bgg(1) = meggppp(s12,s13,s23,mh,mb,bbub,btrian,bboxx)
            bgg(2) = meggppp(s13,s12,s23,mh,mb,bub2,trian2,boxx2)
            bgg(3) = meggppp(s23,s13,s12,mh,mb,bub3,trian3,boxx3)
            bgg(4) = meggppm(s12,s13,s23,mh,mb,bbub,btrian,bboxx)
 
         endif
      endif

      dtgg(1) = meggpppmtop(s12,s13,s23,mh)
      dtgg(2) = meggpppmtop(s13,s12,s23,mh)
      dtgg(3) = meggpppmtop(s23,s13,s12,mh)
      dtgg(4) = meggppmmtop(s12,s13,s23,mh)
 
      irecalc=0

      mesquared=0d0

      tme=0d0
      tbme=0d0
      bme=0d0
      sme=0d0

      deltaMinfty=0d0
      do j=1,4
         deltaMinfty=deltaMinfty + zabs(ytth*dtgg(j))**2
      enddo

      do j=1,4
         gg(j)=0d0
         do i=1,2
            gg(j)=gg(j)+relt(i)*yssh(i,i)*sgg(i,j)
     $           +relb(i)*ysbsbh(i,i)*sbgg(i,j)
         enddo
         tme=tme+zabs(ytth*tgg(j))**2/deltaMinfty
         bme=bme+zabs(ybbh*bgg(j))**2/deltaMinfty
         tbme=tbme+((ytth*tgg(j)*dconjg(ybbh*bgg(j)) 
     $        + ybbh*bgg(j)*dconjg(ytth*tgg(j))))/deltaMinfty
         sme=sme+(ytth*tgg(j)*dconjg(gg(j)) 
     $        + gg(j)*dconjg(ytth*tgg(j)))/deltaMinfty
     $        + (ybbh*bgg(j)*dconjg(gg(j)) 
     $        + gg(j)*dconjg(ybbh*bgg(j)))/deltaMinfty
     $        + zabs(gg(j))**2/deltaMinfty
      enddo

      mesquared=2d0*(lbot*bme + ltopbot*tbme + sme) 
      mesquared=mesquared + 2d0*(ltop*tme+rnorm*linfty)
      mesquared=mesquared*deltaMinfty
      
      SMEgghg=prefac*mesquared


C      write(6,*)'SMEgghg= ',prefac,mesquared,SMEgghg

      return
      end
C==================================================================

      
