CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     SMEgqhq.f
C
C     Evaluates the squared matrix elements of gq -> qh

      function SMEgqhq(s12,s13,s23,lcross)
      implicit none
      double precision SMEgqhq
      double precision s12,s13,s23
      integer lcross
      
      double complex rel

      double precision mesquared,prefac
      
      double complex gq(2),tgq(2),dtgq(2),bgq(2),sgq(2,2),sbgq(2,2)
      
      double complex bub(1:4),trian(1:4),boxx(1:3)
      double complex bbub(1:4),btrian(1:4),bboxx(1:3)
      double complex bub2(1:4),trian2(1:4),boxx2(1:3)
      double complex bub3(1:4),trian3(1:4),boxx3(1:3)
      
      integer i,j

      double complex tbubs,tbubt,tbubu,tbubmh
      double complex ttrians,ttriant,ttrianu,ttrianmh
      double complex tboxst,tboxsu,tboxtu
      double complex bbubs,bbubt,bbubu,bbubmh
      double complex btrians,btriant,btrianu,btrianmh
      double complex bboxst,bboxsu,bboxtu
      common/tints/tbubs,tbubt,tbubu,tbubmh,ttrians,ttriant,
     &     ttrianu,ttrianmh,tboxst,tboxsu,tboxtu
      common/bints/bbubs,bbubt,bbubu,bbubmh,btrians,btriant,
     &     btrianu,btrianmh,bboxst,bboxsu,bboxtu


      double complex meqqpmp
      double complex meqqpmpmtop
      external meqqpmp
      external meqqpmpmtop

      double precision rnorm
      common/hpronorm/rnorm

      double precision tme,tbme,bme,sme
      double precision deltaMinfty


      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      SMEgqhq=0d0

C      write(6,*)'*** '
C      write(6,*)'*** SMEgqhq: ',s12,s13,s23,lcross

      do j=1,2
         tgq(j)=dcmplx(0d0,0d0)
         dtgq(j)=dcmplx(0d0,0d0)
         bgq(j)=dcmplx(0d0,0d0)
         do i=1,2
            sgq(i,j)=dcmplx(0d0,0d0)
            sbgq(i,j)=dcmplx(0d0,0d0)
         enddo
      enddo

C     C----------------------------------------------------
      linfty=linftyNLO
      
C     C----------------------------------------------------
      
      prefac=as**3*(Nc**2-1)/2d0/(4d0*PI)


      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then

C         write(6,*)'top'
         if (ytth.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mt,tbubs,tbubt,tbubu,
     &              tbubmh,ttrians,ttriant,ttrianu,ttrianmh,
     &              tboxst,tboxsu,tboxtu)
            endif


            if (lcross.eq.1) then
C     s12 <-> s13
               bub2(1)=tbubt
               bub2(2)=tbubs
               bub2(3)=tbubu
               bub2(4)=tbubmh
               trian2(1)=ttriant
               trian2(2)=ttrians
               trian2(3)=ttrianu
               trian2(4)=ttrianmh
               boxx2(1)=tboxst
               boxx2(2)=tboxtu
               boxx2(3)=tboxsu
            
C     s23 <-> s12
               bub3(1)=bub2(1)
               bub3(2)=bub2(3)
               bub3(3)=bub2(2)
               bub3(4)=bub2(4)
               trian3(1)=trian2(1)
               trian3(2)=trian2(3)
               trian3(3)=trian2(2)
               trian3(4)=trian2(4)
               boxx3(1)=boxx2(2)
               boxx3(2)=boxx2(1)
               boxx3(3)=boxx2(3)
                        
               tgq(1) = meqqpmp(s13,s12,s23,mh,mt,bub2,trian2)
               tgq(2) = meqqpmp(s13,s23,s12,mh,mt,bub3,trian3)
               
            elseif (lcross.eq.-1) then

C     s12 <-> s23
               bub2(1)=tbubu
               bub2(2)=tbubs
               bub2(3)=tbubt
               bub2(4)=tbubmh
               trian2(1)=ttrianu
               trian2(2)=ttrians
               trian2(3)=ttriant
               trian2(4)=ttrianmh
               boxx2(1)=tboxsu
               boxx2(2)=tboxtu
               boxx2(3)=tboxst
            
C     s13 <-> s12
               bub3(1)=bub2(1)
               bub3(2)=bub2(3)
               bub3(3)=bub2(2)
               bub3(4)=bub2(4)
               trian3(1)=trian2(1)
               trian3(2)=trian2(3)
               trian3(3)=trian2(2)
               trian3(4)=trian2(4)
               boxx3(1)=boxx2(2)
               boxx3(2)=boxx2(1)
               boxx3(3)=boxx2(3)
                        
               tgq(1) = meqqpmp(s23,s12,s13,mh,mt,bub2,trian2)
               tgq(2) = meqqpmp(s23,s13,s12,mh,mt,bub3,trian3)
               

            endif


         endif
      endif
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then
C         write(6,*)'bot'
         if (ybbh.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mb,bbubs,bbubt,bbubu,
     &              bbubmh,btrians,btriant,btrianu,btrianmh,
     &              bboxst,bboxsu,bboxtu)
            endif

            if (lcross.eq.1) then
C     s12 <-> s13
               bub2(1)=bbubt
               bub2(2)=bbubs
               bub2(3)=bbubu
               bub2(4)=bbubmh
               trian2(1)=btriant
               trian2(2)=btrians
               trian2(3)=btrianu
               trian2(4)=btrianmh
               boxx2(1)=bboxst
               boxx2(2)=bboxtu
               boxx2(3)=bboxsu
            
C     s23 <-> s12
               bub3(1)=bub2(1)
               bub3(2)=bub2(3)
               bub3(3)=bub2(2)
               bub3(4)=bub2(4)
               trian3(1)=trian2(1)
               trian3(2)=trian2(3)
               trian3(3)=trian2(2)
               trian3(4)=trian2(4)
               boxx3(1)=boxx2(2)
               boxx3(2)=boxx2(1)
               boxx3(3)=boxx2(3)
                        
               bgq(1) = meqqpmp(s13,s12,s23,mh,mb,bub2,trian2)
               bgq(2) = meqqpmp(s13,s23,s12,mh,mb,bub3,trian3)
               
            elseif (lcross.eq.-1) then

C     s12 <-> s23
               bub2(1)=bbubu
               bub2(2)=bbubs
               bub2(3)=bbubt
               bub2(4)=bbubmh
               trian2(1)=btrianu
               trian2(2)=btrians
               trian2(3)=btriant
               trian2(4)=btrianmh
               boxx2(1)=bboxsu
               boxx2(2)=bboxtu
               boxx2(3)=bboxst
            
C     s13 <-> s12
               bub3(1)=bub2(1)
               bub3(2)=bub2(3)
               bub3(3)=bub2(2)
               bub3(4)=bub2(4)
               trian3(1)=trian2(1)
               trian3(2)=trian2(3)
               trian3(3)=trian2(2)
               trian3(4)=trian2(4)
               boxx3(1)=boxx2(2)
               boxx3(2)=boxx2(1)
               boxx3(3)=boxx2(3)
                        
               bgq(1) = meqqpmp(s23,s12,s13,mh,mb,bub2,trian2)
               bgq(2) = meqqpmp(s23,s13,s12,mh,mb,bub3,trian3)
               

            endif



         

         endif


      endif

      if (lcross.eq.1) then
         dtgq(1) = meqqpmpmtop(s13,s12,s23,mh)
         dtgq(2) = meqqpmpmtop(s13,s23,s12,mh)
      elseif (lcross.eq.-1) then
         dtgq(1) = meqqpmpmtop(s23,s12,s13,mh)
         dtgq(2) = meqqpmpmtop(s23,s13,s12,mh)
      endif
      
      irecalc=0

      mesquared=0d0

      tme=0d0
      tbme=0d0
      bme=0d0
      sme=0d0

      deltaMinfty=0d0
      do j=1,4
         deltaMinfty=deltaMinfty + zabs(ytth*dtgq(j))**2
      enddo

      do j=1,2
         gq(j)=0d0
         do i=1,2
            gq(j)=gq(j)+relt(i)*yssh(i,i)*sgq(i,j)
     $           +relb(i)*ysbsbh(i,i)*sbgq(i,j)
         enddo
         tme=tme+zabs(ytth*tgq(j))**2/deltaMinfty
         bme=bme+zabs(ybbh*bgq(j))**2/deltaMinfty
         tbme=tbme+(ytth*tgq(j)*dconjg(ybbh*bgq(j)) 
     $        + ybbh*bgq(j)*dconjg(ytth*tgq(j)))/deltaMinfty
         sme=sme+(ytth*tgq(j)*dconjg(gq(j)) 
     $        + gq(j)*dconjg(ytth*tgq(j)))/deltaMinfty
     $        + (ybbh*bgq(j)*dconjg(gq(j)) 
     $        + gq(j)*dconjg(ybbh*bgq(j)))/deltaMinfty
     $        + zabs(gq(j))**2/deltaMinfty
      enddo

      mesquared=2d0*(lbot*bme + ltopbot*tbme + sme)
      mesquared=mesquared+ 2d0*(ltop*tme + rnorm*linfty)
      mesquared=mesquared*deltaMinfty

      SMEgqhq=prefac*mesquared

      return
      end
C==================================================================

      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Electroweak corrections including interference term with QCD
      subroutine dewkSMEgqhq(s12,s13,s23,lcross,gqewkup,gqewkdw)
      implicit none
      double precision s12,s13,s23
      double precision gqewkup,gqewkdw
      integer lcross


      double complex bub(1:4),trian(1:4),boxx(1:3)
      double complex bbub(1:4),btrian(1:4),bboxx(1:3)
      double complex wbub(1:4),wtrian(1:4),wboxx(1:3)
      double complex zbub(1:4),ztrian(1:4),zboxx(1:3)
      double complex bub2(1:4),trian2(1:4),boxx2(1:3)


      double complex tbubs,tbubt,tbubu,tbubmh
      double complex ttrians,ttriant,ttrianu,ttrianmh
      double complex tboxst,tboxsu,tboxtu
      double complex bbubs,bbubt,bbubu,bbubmh
      double complex btrians,btriant,btrianu,btrianmh
      double complex bboxst,bboxsu,bboxtu
      common/tints/tbubs,tbubt,tbubu,tbubmh,ttrians,ttriant,
     &     ttrianu,ttrianmh,tboxst,tboxsu,tboxtu
      common/bints/bbubs,bbubt,bbubu,bbubmh,btrians,btriant,
     &     btrianu,btrianmh,bboxst,bboxsu,bboxtu

      double complex wbub1mh,wbub2s,wbub2t,wbub2u,
     &     wtris,wtrit,wtriu,wboxst,wboxsu,wboxtu
      double complex zbub1mh,zbub2s,zbub2t,zbub2u,
     &     ztris,ztrit,ztriu,zboxst,zboxsu,zboxtu
      common/wints/wbub1mh,wbub2s,wbub2t,wbub2u,
     &     wtris,wtrit,wtriu,wboxst,wboxsu,wboxtu
      common/zints/zbub1mh,zbub2s,zbub2t,zbub2u,
     &     ztris,ztrit,ztriu,zboxst,zboxsu,zboxtu

      double complex f1w,f1z,f1t,f1b,df1t
      double complex formfvN
      external formfvN

      double precision zvecup,wvecup,zaxup,waxup,
     & zvecdw,wvecdw,zaxdw,waxdw,f1vecup,f1axup,f1vecdw,
     & f1axdw,f2vecup,f2axup,f2vecdw,f2axdw,tvecup,taxup,tvecdw,
     & taxdw,bvecup,baxup,bvecdw,baxdw
      
      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      
      double complex formfv,Box
      external formfv,Box

      double complex cf1w,cf1z

      double precision rnorm
      common/hpronorm/rnorm

      double complex meqqpmp
      double complex meqqpmpmtop
      external meqqpmp
      external meqqpmpmtop

      double precision deltaMinfty

      double precision prefac
      double complex IOne

      IOne=dcmplx(0d0,1d0)
      
C      write(6,*)'*** '
C      write(6,*)'*** dewkSMEgqhq: ',s12,s13,s23,lcross

      gqewkup=0d0
      gqewkdw=0d0

      linfty=linftyNLO

      prefac=as*(Nc**2-1)/2d0/(4d0*PI)**3

CCC   overall coupling factors

      zvecup = ghzz*(gvzu**2+gazu**2)
      wvecup = ghww*(gvw**2+gaw**2)

      zaxup = ghzz*2d0*gvzu*gazu
      waxup = ghww*2d0*gvw*gaw

      zvecdw = ghzz*(gvzd**2+gazd**2)
      wvecdw = ghww*(gvw**2+gaw**2)

      zaxdw = ghzz*2d0*gvzd*gazd
      waxdw = ghww*2d0*gvw*gaw

      tvecup = -4d0*pi*as*ytth*dsqrt(2d0)
      taxup = 0d0
      tvecdw = -4d0*pi*as*ytth*dsqrt(2d0)
      taxdw = 0d0
     
      bvecup = -4d0*pi*as*ybbh*dsqrt(2d0)
      baxup = 0d0
      bvecdw = -4d0*pi*as*ybbh*dsqrt(2d0)
      baxdw = 0d0


      f1t=0d0
      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ytth.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mt,tbubs,tbubt,
     &              tbubu,tbubmh,ttrians,ttriant,ttrianu,ttrianmh,
     &              tboxst,tboxsu,tboxtu)
            endif

            if (lcross.eq.1) then

               bub2(1)=tbubt
               bub2(2)=tbubs
               bub2(3)=tbubu
               bub2(4)=tbubmh
               trian2(1)=ttriant
               trian2(2)=ttrians
               trian2(3)=ttrianu
               trian2(4)=ttrianmh
               boxx2(1)=tboxst
               boxx2(2)=tboxtu
               boxx2(3)=tboxsu
            
               f1t = meqqpmp(s13,s12,s23,mh,mt,bub2,trian2,boxx2)
 
            elseif (lcross.eq.-1) then

               bub2(1)=tbubu
               bub2(2)=tbubs
               bub2(3)=tbubt
               bub2(4)=tbubmh
               trian2(1)=ttrianu
               trian2(2)=ttrians
               trian2(3)=ttriant
               trian2(4)=ttrianmh
               boxx2(1)=tboxsu
               boxx2(2)=tboxtu
               boxx2(3)=tboxst
            
               f1t = meqqpmp(s23,s12,s13,mh,mt,bub2,trian2,boxx2)
 
            endif
  
            f1t=f1t
         endif
      endif
      f1b=0d0
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ybbh.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mb,bbubs,bbubt,
     &              bbubu,bbubmh,btrians,btriant,btrianu,btrianmh,
     &              bboxst,bboxsu,bboxtu)
            endif

            if (lcross.eq.1) then

               bub2(1)=bbubt
               bub2(2)=bbubs
               bub2(3)=bbubu
               bub2(4)=bbubmh
               trian2(1)=btriant
               trian2(2)=btrians
               trian2(3)=btrianu
               trian2(4)=btrianmh
               boxx2(1)=bboxst
               boxx2(2)=bboxtu
               boxx2(3)=bboxsu            

               f1b = meqqpmp(s13,s12,s23,mh,mb,bub2,trian2,boxx2)

            elseif (lcross.eq.-1) then

               bub2(1)=bbubu
               bub2(2)=bbubs
               bub2(3)=bbubt
               bub2(4)=bbubmh
               trian2(1)=btrianu
               trian2(2)=btrians
               trian2(3)=btriant
               trian2(4)=btrianmh
               boxx2(1)=bboxsu
               boxx2(2)=bboxtu
               boxx2(3)=bboxst
           
               f1b = meqqpmp(s23,s12,s13,mh,mb,bub2,trian2,boxx2)

            endif
  
            f1b=f1b
         endif
      endif

      df1t=0d0
      if (lcross.eq.1) then
         df1t = meqqpmpmtop(s13,s12,s23,mh)
      elseif (lcross.eq.-1) then
         df1t = meqqpmpmtop(s23,s12,s13,mh)
      endif
      df1t=df1t
      
      deltaMinfty=zabs(tvecup*df1t)**2
C      deltaMinfty=1d0

      f1vecup=lbot*zabs(bvecup*f1b)**2/deltaMinfty
      f1vecup=f1vecup
     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))/deltaMinfty
      f1vecup=f1vecup
     &     +(ltop*zabs(tvecup*f1t)**2/deltaMinfty+rnorm*linfty)


c$$$      f1vecup=ltop*zabs(tvecup*f1t)**2+lbot*zabs(bvecup*f1b)**2
c$$$     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))
c$$$     &     +rnorm*linfty*zabs(tvecup*df1t)**2
      f1axup=0d0

c$$$      f1vecdw=ltop*zabs(tvecup*f1t)**2+lbot*zabs(bvecup*f1b)**2
c$$$     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))
c$$$     &     +rnorm*linfty*zabs(tvecup*df1t)**2
c$$$
c$$$
c$$$      write(6,*)'++ ',deltaMinfty,f1vecup,deltaMinfty*f1vecup/f1vecdw


      f1vecdw=f1vecup 
      f1axdw=0d0

C      write(6,*)'f1t= ',f1t
C      write(6,*)'f1b= ',f1b
C      write(6,*)'df1t= ',df1t

C      write(6,*)'*** ',f1t,f1b,df1t

      
C      write(6,*)'*** ',f1b
C      write(6,*)'*** ',df1t

      
      if (iewk2.eq.2) then

         if (irecalc2.eq.1) then
            call filloneloopintV(s12,s13,s23,mh,mw,wbub1mh,wbub2s,
     &           wbub2t,wbub2u,wtris,wtrit,wtriu,wboxst,wboxsu,wboxtu)
         endif

         if (lcross.eq.1) then
            f1w = formfvN(s13,s12,s23,mh,mw,wbub1mh,wbub2s,wbub2u,wtris,
     $           wtriu,wboxsu)
            f1w = IOne*f1w*dsqrt(dabs(s13))*s12*16d0*PI**2
         elseif (lcross.eq.-1) then
            f1w = formfvN(s23,s12,s13,mh,mw,wbub1mh,wbub2s,wbub2t,wtris,
     $           wtrit,wboxst)
            f1w = IOne*f1w*dsqrt(dabs(s23))*s12*16d0*PI**2
         endif

      
         if (irecalc2.eq.1) then
            call filloneloopintV(s12,s13,s23,mh,mz,zbub1mh,zbub2s,
     &       zbub2t,zbub2u,ztris,ztrit,ztriu,zboxst,zboxsu,zboxtu)
         endif

         if (lcross.eq.1) then
            f1z = formfvN(s13,s12,s23,mh,mz,zbub1mh,zbub2s,zbub2u,ztris,
     $           ztriu,zboxsu)
            f1z = IOne*f1z*dsqrt(dabs(s13))*s12*16d0*PI**2
         elseif (lcross.eq.-1) then
            f1z = formfvN(s23,s12,s13,mh,mz,zbub1mh,zbub2s,zbub2t,ztris,
     $           ztrit,zboxst)
            f1z = IOne*f1z*dsqrt(dabs(s23))*s12*16d0*PI**2
         endif
 
         

         f1vecup = f1vecup+(zabs(zvecup*f1z+wvecup*f1w)**2
     &        + 2d0*dble((zvecup*f1z+wvecup*f1w)*conjg(tvecup*f1t
     &        +bvecup*f1b)))/deltaMinfty
         f1axup = zabs(zaxup*f1z+waxup*f1w)**2/deltaMinfty

         f1vecdw = f1vecdw+(zabs(zvecdw*f1z+wvecdw*f1w)**2 
     &        + 2d0*dble((zvecdw*f1z+wvecdw*f1w)*conjg(tvecdw*f1t
     &        +bvecdw*f1b)))/deltaMinfty
         f1axdw = zabs(zaxdw*f1z+waxdw*f1w)**2/deltaMinfty


 
         
C         write(6,*)'f1w= ',f1w
C         write(6,*)'f1z= ',f1z
C         write(6,*)'*** ',f1w,f1z

      endif

      f1vecup = f1vecup*deltaMinfty
      f1axup = f1axup*deltaMinfty
      f1vecdw = f1vecdw*deltaMinfty
      f1axdw = f1axdw*deltaMinfty


      irecalc2=0
      irecalc=0


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      f1t=0d0
      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then


         if (lcross.eq.1) then
C     
            bub2(1)=tbubt
            bub2(2)=tbubu
            bub2(3)=tbubs
            bub2(4)=tbubmh
            trian2(1)=ttriant
            trian2(2)=ttrianu
            trian2(3)=ttrians
            trian2(4)=ttrianmh
            boxx2(1)=tboxtu
            boxx2(2)=tboxst
            boxx2(3)=tboxsu
            
            f1t = meqqpmp(s13,s23,s12,mh,mt,bub2,trian2,boxx2)

         elseif (lcross.eq.-1) then

C     
            bub2(1)=tbubu
            bub2(2)=tbubt
            bub2(3)=tbubs
            bub2(4)=tbubmh
            trian2(1)=ttrianu
            trian2(2)=ttriant
            trian2(3)=ttrians
            trian2(4)=ttrianmh
            boxx2(1)=tboxtu
            boxx2(2)=tboxsu
            boxx2(3)=tboxst
            
            f1t = meqqpmp(s23,s13,s12,mh,mt,bub2,trian2,boxx2)

         endif
  
         f1t=f1t
      endif

      f1b=0d0
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (lcross.eq.1) then
C     
            bub2(1)=bbubt
            bub2(2)=bbubu
            bub2(3)=bbubs
            bub2(4)=bbubmh
            trian2(1)=btriant
            trian2(2)=btrianu
            trian2(3)=btrians
            trian2(4)=btrianmh
            boxx2(1)=bboxtu
            boxx2(2)=bboxst
            boxx2(3)=bboxsu
            
            f1b = meqqpmp(s13,s23,s12,mh,mb,bub2,trian2,boxx2)
            
         elseif (lcross.eq.-1) then

C     
            bub2(1)=bbubu
            bub2(2)=bbubt
            bub2(3)=bbubs
            bub2(4)=bbubmh
            trian2(1)=btrianu
            trian2(2)=btriant
            trian2(3)=btrians
            trian2(4)=btrianmh
            boxx2(1)=bboxtu
            boxx2(2)=bboxsu
            boxx2(3)=bboxst
            
            f1b = meqqpmp(s23,s13,s12,mh,mb,bub2,trian2,boxx2)

         endif

         f1b=f1b
      endif

      df1t=0d0
      if (lcross.eq.1) then
         df1t = meqqpmpmtop(s13,s23,s12,mh)
      elseif (lcross.eq.-1) then
         df1t = meqqpmpmtop(s23,s13,s23,mh)
      endif
      df1t=df1t

      deltaMinfty=zabs(tvecup*df1t)**2
C      deltaMinfty=1d0

C      write(6,*)'f1t= ',f1t
C      write(6,*)'f1b= ',f1b
C      write(6,*)'df1t= ',df1t
C      write(6,*)'*** ',f1t,f1b,df1t
C      write(6,*)'*** ',f1b
C      write(6,*)'*** ',df1t


      f2vecup=lbot*zabs(bvecup*f1b)**2/deltaMinfty
      f2vecup=f2vecup
     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))/deltaMinfty
      f2vecup=f2vecup
     &     +(ltop*zabs(tvecup*f1t)**2/deltaMinfty+rnorm*linfty)



c$$$      f2vecup=ltop*zabs(tvecup*f1t)**2+lbot*zabs(bvecup*f1b)**2
c$$$     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))
c$$$     &     +rnorm*linfty*zabs(tvecup*df1t)**2
      f2axup=0d0


c$$$      f2vecdw=ltop*zabs(tvecup*f1t)**2+lbot*zabs(bvecup*f1b)**2
c$$$     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))
c$$$     &     +rnorm*linfty*zabs(tvecup*df1t)**2
c$$$
c$$$      write(6,*)'-- ',deltaMinfty,f2vecup,deltaMinfty*f2vecup/f2vecdw

      f2vecdw=f2vecup
      f2axdw=0d0
      
      if (iewk2.eq.2) then

         if (lcross.eq.1) then
            f1w = formfvN(s13,s23,s12,mh,mw,wbub1mh,wbub2u,wbub2s,wtriu,
     $           wtris,wboxsu)
            f1w = IOne*f1w*dsqrt(dabs(s13))*s23*16d0*PI**2
         elseif (lcross.eq.-1) then
            f1w = formfvN(s23,s13,s12,mh,mw,wbub1mh,wbub2t,wbub2s,wtrit,
     $           wtris,wboxst)
            f1w = IOne*f1w*dsqrt(dabs(s23))*s13*16d0*PI**2
         endif
  
         if (lcross.eq.1) then
            f1z = formfvN(s13,s23,s12,mh,mz,zbub1mh,zbub2u,zbub2s,ztriu,
     $           ztris,zboxsu)
            f1z = IOne*f1z*dsqrt(dabs(s13))*s23*16d0*PI**2
         elseif (lcross.eq.-1) then
            f1z = formfvN(s23,s13,s12,mh,mz,zbub1mh,zbub2t,zbub2s,ztrit,
     $           ztris,zboxst)
            f1z = IOne*f1z*dsqrt(dabs(s23))*s13*16d0*PI**2
         endif
  

         f2vecup =f2vecup+ (zabs(zvecup*f1z+wvecup*f1w)**2 
     &        + 2d0*dble((zvecup*f1z+wvecup*f1w)*conjg(tvecup*f1t
     &        +bvecup*f1b)))/deltaMinfty
         f2axup = zabs(zaxup*f1z+waxup*f1w)**2/deltaMinfty

         f2vecdw = f2vecdw+(zabs(zvecdw*f1z+wvecdw*f1w)**2 
     &        + 2d0*dble((zvecdw*f1z+wvecdw*f1w)*conjg(tvecdw*f1t
     &        +bvecdw*f1b)))/deltaMinfty
         f2axdw = zabs(zaxdw*f1z+waxdw*f1w)**2/deltaMinfty


 

C         write(6,*)'f1w= ',f1w
C         write(6,*)'f1z= ',f1z
      endif
 

      f2vecup = f2vecup*deltaMinfty
      f2axup = f2axup*deltaMinfty
      f2vecdw = f2vecdw*deltaMinfty
      f2axdw = f2axdw*deltaMinfty

      gqewkup=prefac*((f1vecup+f1axup)+(f2vecup+f2axup))

      gqewkdw=prefac*((f1vecdw+f1axdw)+(f2vecdw+f2axdw))
      

      return
      end

