CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     SMEqqhg.f
C
C     Evaluates the squared matrix elements of qq -> gh

      function SMEqqhg(s12,s13,s23)
      implicit none
      double precision SMEqqhg
      double precision s12,s13,s23
      
      double complex rel

      double precision mesquared,prefac
      
      
      double complex qq(2),tqq(2),dtqq(2),bqq(2),sqq(2,2),sbqq(2,2)
      double complex bub(1:4),trian(1:4),boxx(1:3)
      double complex bbub(1:4),btrian(1:4),bboxx(1:3)
      double complex bub2(1:4),trian2(1:4),boxx2(1:3)
      double complex bub3(1:4),trian3(1:4),boxx3(1:3)
      integer i,j

      double complex tbubs,tbubt,tbubu,tbubmh
      double complex ttrians,ttriant,ttrianu,ttrianmh
      double complex tboxst,tboxsu,tboxtu
      double complex bbubs,bbubt,bbubu,bbubmh
      double complex btrians,btriant,btrianu,btrianmh
      double complex bboxst,bboxsu,bboxtu
      common/tints/tbubs,tbubt,tbubu,tbubmh,ttrians,ttriant,
     &     ttrianu,ttrianmh,tboxst,tboxsu,tboxtu
      common/bints/bbubs,bbubt,bbubu,bbubmh,btrians,btriant,
     &     btrianu,btrianmh,bboxst,bboxsu,bboxtu
      
      double complex meqqpmp
      double complex meqqpmpmtop
      external meqqpmp
      external meqqpmpmtop

     

      double precision rnorm
      common/hpronorm/rnorm

      double precision tme,tbme,bme,sme

      
      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      SMEqqhg=0d0

      do j=1,2
         tqq(j)=dcmplx(0d0,0d0)
         dtqq(j)=dcmplx(0d0,0d0)
         bqq(j)=dcmplx(0d0,0d0)
         do i=1,2
            sqq(i,j)=dcmplx(0d0,0d0)
            sbqq(i,j)=dcmplx(0d0,0d0)
         enddo
      enddo

C     C----------------------------------------------------
      linfty=linftyNLO
C      write(6,*)'SMEqqhg: ',linfty,ltop,ltopbot
C     C----------------------------------------------------
      
      prefac=as**3*(Nc**2-1)/2d0/(4d0*PI)
C      write(6,*)as,Nc,PI

      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ytth.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mt,tbubs,tbubt,tbubu,
     &              tbubmh,ttrians,ttriant,ttrianu,ttrianmh,
     &              tboxst,tboxsu,tboxtu)
            endif

            bub(1)=tbubs
            bub(2)=tbubt
            bub(3)=tbubu
            bub(4)=tbubmh
            trian(1)=ttrians
            trian(2)=ttriant
            trian(3)=ttrianu
            trian(4)=ttrianmh
            boxx(1)=tboxst
            boxx(2)=tboxsu
            boxx(3)=tboxtu

C     s13 <-> s23
            bub2(1)=bub(1)
            bub2(2)=bub(3)
            bub2(3)=bub(2)
            bub2(4)=bub(4)
            trian2(1)=trian(1)
            trian2(2)=trian(3)
            trian2(3)=trian(2)
            trian2(4)=trian(4)
            boxx2(1)=boxx(2)
            boxx2(2)=boxx(1)
            boxx2(3)=boxx(3)
            

            
            tqq(1) = meqqpmp(s12,s13,s23,mh,mt,bub,trian,boxx)
            tqq(2) = meqqpmp(s12,s23,s13,mh,mt,bub2,trian2,boxx2)

C            write(6,*)tqq(1)
C            write(6,*)tqq(2)

         endif
      endif
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ybbh.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mb,bbubs,bbubt,bbubu,
     &              bbubmh,btrians,btriant,btrianu,btrianmh,
     &              bboxst,bboxsu,bboxtu)
            endif

            bbub(1)=bbubs
            bbub(2)=bbubt
            bbub(3)=bbubu
            bbub(4)=bbubmh
            btrian(1)=btrians
            btrian(2)=btriant
            btrian(3)=btrianu
            btrian(4)=btrianmh
            bboxx(1)=bboxst
            bboxx(2)=bboxsu
            bboxx(3)=bboxtu
              
C     s13 <-> s23
            bub2(1)=bbub(1)
            bub2(2)=bbub(3)
            bub2(3)=bbub(2)
            bub2(4)=bbub(4)
            trian2(1)=btrian(1)
            trian2(2)=btrian(3)
            trian2(3)=btrian(2)
            trian2(4)=btrian(4)
            boxx2(1)=bboxx(2)
            boxx2(2)=bboxx(1)
            boxx2(3)=bboxx(3)
            

            
            bqq(1) = meqqpmp(s12,s13,s23,mh,mb,bbub,btrian,bboxx)
            bqq(2) = meqqpmp(s12,s23,s13,mh,mb,bub2,trian2,boxx2)

         endif
      endif

      if (linfty.ne.0d0) then
         dtqq(1) = meqqpmpmtop(s12,s13,s23,mh)
         dtqq(2) = meqqpmpmtop(s12,s23,s13,mh)
      endif



      irecalc=0

      mesquared=0d0

      tme=0d0
      tbme=0d0
      bme=0d0
      sme=0d0
      do j=1,2
         qq(j)=0d0
         do i=1,2
            qq(j)=qq(j)+relt(i)*yssh(i,i)*sqq(i,j)
     $           +relb(i)*ysbsbh(i,i)*sbqq(i,j)
         enddo
         tme=tme+zabs(ytth*tqq(j))**2
         bme=bme+zabs(ybbh*bqq(j))**2
         tbme=tbme+(ytth*tqq(j)*dconjg(ybbh*bqq(j)) 
     $        + ybbh*bqq(j)*dconjg(ytth*tqq(j)))
         sme=sme+(ytth*tqq(j)*dconjg(qq(j)) 
     $        + qq(j)*dconjg(ytth*tqq(j)))
     $        + (ybbh*bqq(j)*dconjg(qq(j)) 
     $        + qq(j)*dconjg(ybbh*bqq(j)))
     $        + zabs(qq(j))**2
      enddo

      mesquared=2d0*(ltop*tme + lbot*bme + ltopbot*tbme + sme)
      do j=1,2
         mesquared=mesquared + 2d0*rnorm*linfty*zabs(ytth*dtqq(j))**2
      enddo

      
      SMEqqhg=prefac*mesquared

c$$$      write(6,*)'SMEqqhg: ',prefac,mesquared,tme,bme
c$$$      write(6,*)as,Nc,PI

      return
      end
C==================================================================

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Electroweak corrections including interference term with QCD
      subroutine dewkSMEqqhg(s12,s13,s23,qqewkup,qqewkdw)
      implicit none
      double precision s12,s13,s23
      double precision qqewkup,qqewkdw

 
      double complex bub(1:4),trian(1:4),boxx(1:3)
      double complex bbub(1:4),btrian(1:4),bboxx(1:3)
      double complex wbub(1:4),wtrian(1:4),wboxx(1:3)
      double complex zbub(1:4),ztrian(1:4),zboxx(1:3)
      double complex bub2(1:4),trian2(1:4),boxx2(1:3)


      double complex tbubs,tbubt,tbubu,tbubmh
      double complex ttrians,ttriant,ttrianu,ttrianmh
      double complex tboxst,tboxsu,tboxtu
      double complex bbubs,bbubt,bbubu,bbubmh
      double complex btrians,btriant,btrianu,btrianmh
      double complex bboxst,bboxsu,bboxtu
      common/tints/tbubs,tbubt,tbubu,tbubmh,ttrians,ttriant,
     &     ttrianu,ttrianmh,tboxst,tboxsu,tboxtu
      common/bints/bbubs,bbubt,bbubu,bbubmh,btrians,btriant,
     &     btrianu,btrianmh,bboxst,bboxsu,bboxtu

      double complex wbub1mh,wbub2s,wbub2t,wbub2u,
     &     wtris,wtrit,wtriu,wboxst,wboxsu,wboxtu
      double complex zbub1mh,zbub2s,zbub2t,zbub2u,
     &     ztris,ztrit,ztriu,zboxst,zboxsu,zboxtu
      common/wints/wbub1mh,wbub2s,wbub2t,wbub2u,
     &     wtris,wtrit,wtriu,wboxst,wboxsu,wboxtu
      common/zints/zbub1mh,zbub2s,zbub2t,zbub2u,
     &     ztris,ztrit,ztriu,zboxst,zboxsu,zboxtu

      double complex f1w,f1z,f1t,f1b,df1t
      double complex formfvN
      external formfvN

      double precision zvecup,wvecup,zaxup,waxup,
     & zvecdw,wvecdw,zaxdw,waxdw,f1vecup,f1axup,f1vecdw,
     & f1axdw,f2vecup,f2axup,f2vecdw,f2axdw,tvecup,taxup,tvecdw,
     & taxdw,bvecup,baxup,bvecdw,baxdw
      
      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'

      
      double complex formfv,Box
      external formfv,Box

      double complex cf1w,cf1z

      double precision rnorm
      common/hpronorm/rnorm

      double complex meqqpmp
      double complex meqqpmpmtop
      external meqqpmp
      external meqqpmpmtop

      double precision prefac

      qqewkup=0d0
      qqewkdw=0d0


      linfty=linftyNLO

      prefac=as*(Nc**2-1)/2d0/(4d0*PI)**3
      
CCC   overall coupling factors

      zvecup = ghzz*(gvzu**2+gazu**2)
      wvecup = ghww*(gvw**2+gaw**2)

      zaxup = ghzz*2d0*gvzu*gazu
      waxup = ghww*2d0*gvw*gaw

      zvecdw = ghzz*(gvzd**2+gazd**2)
      wvecdw = ghww*(gvw**2+gaw**2)

      zaxdw = ghzz*2d0*gvzd*gazd
      waxdw = ghww*2d0*gvw*gaw

      tvecup = -4d0*pi*as*ytth*dsqrt(2d0)
      taxup = 0d0
      tvecdw = -4d0*pi*as*ytth*dsqrt(2d0)
      taxdw = 0d0
     
      bvecup = -4d0*pi*as*ybbh*dsqrt(2d0)
      baxup = 0d0
      bvecdw = -4d0*pi*as*ybbh*dsqrt(2d0)
      baxdw = 0d0


      f1t=0d0
      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ytth.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mt,tbubs,tbubt,
     &              tbubu,tbubmh,ttrians,ttriant,ttrianu,ttrianmh,
     &              tboxst,tboxsu,tboxtu)
            endif

            bub(1)=tbubs
            bub(2)=tbubt
            bub(3)=tbubu
            bub(4)=tbubmh
            trian(1)=ttrians
            trian(2)=ttriant
            trian(3)=ttrianu
            trian(4)=ttrianmh
            boxx(1)=tboxst
            boxx(2)=tboxsu
            boxx(3)=tboxtu

            f1t = meqqpmp(s12,s13,s23,mh,mt,bub,trian,boxx)

         endif
      endif
      f1b=0d0
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then

         if (ybbh.ne.0d0) then
            if (irecalc.eq.1) then
               call filloneloopintT(s12,s13,s23,mh,mb,bbubs,bbubt,
     &              bbubu,bbubmh,btrians,btriant,btrianu,btrianmh,
     &              bboxst,bboxsu,bboxtu)
            endif

            bbub(1)=bbubs
            bbub(2)=bbubt
            bbub(3)=bbubu
            bbub(4)=bbubmh
            btrian(1)=btrians
            btrian(2)=btriant
            btrian(3)=btrianu
            btrian(4)=btrianmh
            bboxx(1)=bboxst
            bboxx(2)=bboxsu
            bboxx(3)=bboxtu

            
            f1b = meqqpmp(s12,s13,s23,mh,mb,bbub,btrian,bboxx)
            
         endif
      endif

      df1t=0d0
      if (linfty.ne.0d0) then
         df1t = meqqpmpmtop(s12,s13,s23,mh)
      endif


      f1vecup=(ltop*zabs(tvecup*f1t)**2+lbot*zabs(bvecup*f1b)**2
     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))
     &     +rnorm*linfty*zabs(tvecup*df1t)**2)
      f1axup=0d0

      f1vecdw=f1vecup
      f1axdw=0d0

      if (iewk2.eq.2) then
         if (irecalc2.eq.1) then
            call filloneloopintV(s12,s13,s23,mh,mw,wbub1mh,wbub2s,
     &           wbub2t,wbub2u,wtris,wtrit,wtriu,wboxst,wboxsu,wboxtu)
         endif
         f1w = formfvN(s12,s13,s23,mh,mw,wbub1mh,wbub2t,wbub2u,wtrit,
     $        wtriu,wboxtu)
         f1w = f1w*dsqrt(s12)*s13*16d0*PI**2
     
         if (irecalc2.eq.1) then
            call filloneloopintV(s12,s13,s23,mh,mz,zbub1mh,zbub2s,
     &           zbub2t,zbub2u,ztris,ztrit,ztriu,zboxst,zboxsu,zboxtu)
         endif
         f1z = formfvN(s12,s13,s23,mh,mz,zbub1mh,zbub2t,zbub2u,ztrit,
     $        ztriu,zboxtu)
         f1z = f1z*dsqrt(s12)*s13*16d0*PI**2


         f1vecup = f1vecup+zabs(zvecup*f1z+wvecup*f1w)**2 
     &        + 2d0*dble((zvecup*f1z+wvecup*f1w)*conjg(tvecup*f1t
     &        +bvecup*f1b))
         f1axup = zabs(zaxup*f1z+waxup*f1w)**2
         
         f1vecdw = f1vecdw+zabs(zvecdw*f1z+wvecdw*f1w)**2 
     &        + 2d0*dble((zvecdw*f1z+wvecdw*f1w)*conjg(tvecdw*f1t
     &        +bvecdw*f1b))
         f1axdw = zabs(zaxdw*f1z+waxdw*f1w)**2
      endif

      irecalc2=0
      irecalc=0

c$$$      write(6,*)f1t,f1b,f1w,f1z,df1t
c$$$      write(6,*)f1vecup,f1vecdw

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      f1t=0d0
      if ((ltop.ne.0d0).or.(ltopbot.ne.0d0)) then

         bub2(1)=bub(1)
         bub2(2)=bub(3)
         bub2(3)=bub(2)
         bub2(4)=bub(4)
         trian2(1)=trian(1)
         trian2(2)=trian(3)
         trian2(3)=trian(2)
         trian2(4)=trian(4)
         boxx2(1)=boxx(2)
         boxx2(2)=boxx(1)
         boxx2(3)=boxx(3)

         f1t = meqqpmp(s12,s23,s13,mh,mt,bub2,trian2,boxx2)
         
      endif

      f1b=0d0
      if ((lbot.ne.0d0).or.(ltopbot.ne.0d0)) then

         bub2(1)=bbub(1)
         bub2(2)=bbub(3)
         bub2(3)=bbub(2)
         bub2(4)=bbub(4)
         trian2(1)=btrian(1)
         trian2(2)=btrian(3)
         trian2(3)=btrian(2)
         trian2(4)=btrian(4)
         boxx2(1)=bboxx(2)
         boxx2(2)=bboxx(1)
         boxx2(3)=bboxx(3)

         f1b = meqqpmp(s12,s23,s13,mh,mb,bbub,btrian,bboxx)

      endif

      df1t=0d0
      if (linfty.ne.0d0) then
         df1t = meqqpmpmtop(s12,s23,s13,mh)
      endif

      f2vecup=(ltop*zabs(tvecup*f1t)**2+lbot*zabs(bvecup*f1b)**2
     &     +ltopbot*2d0*dble(tvecup*f1t*conjg(bvecup*f1b))
     &     +rnorm*linfty*zabs(tvecup*df1t)**2)
      f2axup=0d0

      f2vecdw=f2vecup
      f2axdw=0d0

      if (iewk2.eq.2) then
         f1w = formfvN(s12,s23,s13,mh,mw,wbub1mh,wbub2u,wbub2t,wtriu,
     $        wtrit,wboxtu)
         f1w = f1w*dsqrt(s12)*s23*16d0*PI**2

         f1z = formfvN(s12,s23,s13,mh,mz,zbub1mh,zbub2u,zbub2t,ztriu,
     $        ztrit,zboxtu)
         f1z = f1z*dsqrt(s12)*s23*16d0*PI**2

         f2vecup = f2vecup+zabs(zvecup*f1z+wvecup*f1w)**2 
     &        + 2d0*dble((zvecup*f1z+wvecup*f1w)*conjg(tvecup*f1t
     &        +bvecup*f1b))
         f2axup = zabs(zaxup*f1z+waxup*f1w)**2

         f2vecdw = f2vecdw+zabs(zvecdw*f1z+wvecdw*f1w)**2 
     &        + 2d0*dble((zvecdw*f1z+wvecdw*f1w)*conjg(tvecdw*f1t
     &        +bvecdw*f1b))
         f2axdw = zabs(zaxdw*f1z+waxdw*f1w)**2
      endif

      
c$$$      write(6,*)f1t,f1b,f1w,f1z,df1t
c$$$      write(6,*)f2vecup,f2vecdw
 
      qqewkup=prefac*((f1vecup+f1axup)+(f2vecup+f2axup))

      qqewkdw=prefac*((f1vecdw+f1axdw)+(f2vecdw+f2axdw))


      return
      end


      
