CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   Form Factor for weak corrections to qq -> gh and qg -> qh
CCC   arXiv:0905.2775 [hep-ph] 


      double complex function formfvN(rs,rt,ru,rmh,rmv,bub1mh,bub2t,
     $     bub2u,trit,triu,boxtu)
      double precision rs,rt,ru,rmh,rmv
      double complex bub1mh,bub2t,bub2u,trit,triu,boxtu
      double precision s,t,u,mh,mv
      double precision lfac
      double complex s1,ff,Bub1,Bub2,Tri,Box,cmv2
      external Bub1,Bub2,Tri,Box

      double precision pi
      parameter(pi = 3.1415926535897932385d0)


      lfac = 1D0/16D0/pi**2
CCC   Scale out overall dimensions; use 1/m^4 scaling

C      s=rs/rmh**2
C      t=rt/rmh**2
C      u=ru/rmh**2
C      mh=rmh/rmh
C      mv=rmv/rmh   

      s=rs
      t=rt
      u=ru
      mh=rmh
      mv=rmv

CCC   Account for the analytic continuation by giving m2
CCC   a small negative imaginary part.  Need because of the 
CCC   logs appearing here from Bub2; in the qg channel, get 
CCC   evaluated as ln(1-s/mv^2) 

      cmv2 = dcmplx(mv**2,-0.00000000001d0)

      ff = 2*(-t+mv**2)*(-t*u+mv**2*u+mv**2*t)/s/t**2*boxtu
     $+4/t/(t+s)*bub1mh-2/s/t*bub2t-2*(-t+mv**2
     $)*u/(-u+mv**2)/s/t**2*bub2u+2*(-t+mv**2)*(u+s)/s/t**2*trit
     $-2*(s**2*mv**2+2*mv**2*s*t+t**3-s**2*t-mv**2*t**2)/(
     $t+s)/s/t**2*triu+6*(-t+mv**2)/s/t**2*zlog(1-t/cmv2)
     $+2*(-5*t*u*s-3*t**2*u+3*s*u*mv**2+2*mv**2*s*t+3*mv**2*t*u)/s/t**2/
     $(t+s)/u*zlog(1-u/cmv2)+8*(mv**2*t**2+mv**2*t*u-3*t*u*s+2*mv**2*s*
     $t-2*t**2*u+s*u*mv**2)/t**2/s/(t+s)/(-u+mv**2)

C      formfvN = lfac*ff/rmh**4
      formfvN = lfac*ff

      RETURN
      END
