CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   HProInit.f

      subroutine HProInit(imod,AlS,ytr,ybr)
      implicit none
      integer imod
      double precision AlS,ytr,ybr

      include 'declar.f'
      include 'masses.f'
      include 'constants.f'


CCC   Set alpha_s
      call HProSetAlpha(AlS)
CCC   Set weak boson masses and widths
      call HProSetWeakParams(Gf,mW2,gamW,mZ2,gamZ)
CCC   Set C.o.M. energy
      call HProSetEnergy(scm)
CCC   Set renormalization and factorization scale
      call HProSetScales(mur,muf)
CCC   Set relative couplings
      call HProSetHCpls(ytr,ybr)
CCC   Set masses
      call HProSetMasses(m2,mt,mb,imbscheme)
CCC   Initialize couplings and mass parameters for the SM
      call InitSM()
CCC   Set some flags
      call HProSetFlags(imassive,imod,modeas,ndecay,iewk)
      return
      end

      subroutine HProSetAlpha(AlS)
      implicit none
      double precision AlS
      include 'xsection.f'
      as=AlS
      return
      end

      subroutine HProSetWeakParams(GFermi,MassW2,WidthW,MassZ2,WidthZ)
      implicit none
      double precision GFermi,MassW2,WidthW,MassZ2,WidthZ
      include 'model.f'
      include 'xsection.f'
      mW=dsqrt(MassW2)
      GammaW=WidthW
      mZ=dsqrt(MassZ2)
      GammaZ=WidthZ
      GF=GFermi
      return
      end

      subroutine HProSetEnergy(scm)
      implicit none
      double precision scm
      include 'model.f'
      include 'xsection.f'
      S=scm
      sqrtS=dsqrt(scm)
      return
      end

      subroutine HProSetScales(renscale,facscale)
      implicit none
      double precision renscale,facscale
      include 'model.f'
      include 'xsection.f'
      muR=renscale
      muF=facscale
      muT=muR
      muB=muR
      muS1=muR
      muS2=muR
      muSB1=muR
      muSB2=muR
      return
      end

      subroutine HProSetHCpls(ytr,ybr)
      implicit none
      double precision ytr,ybr
      include 'model.f'
      include 'hprocontrol.f'
      ytrel=ytr
      ybrel=ybr
      return
      end
      
      subroutine HProSetMasses(higgsmass2,topmass,botmass,imbsch)
      implicit none
      double precision higgsmass2,topmass,botmass
      integer imbsch
      double precision mbpole
      include 'model.f'
      include 'xsection.f'
      mh=dsqrt(higgsmass2)
      mt=topmass
      mb=botmass
      tauh=mh**2/S
      imbscheme=imbsch
      if (imbscheme.eq.1) then
         mbpole=mb
         mb=mbpole*dexp(-2d0*0.179d0/PI*dlog(muR/10d0))
      endif
      botmass=mb
      return
      end


      subroutine HProSetNewHigssMass(new_higgs_mass)
      implicit none
      double precision new_higgs_mass
      include 'model.f'
      include 'xsection.f'
      
      !mh=new_higgs_mass
      !call InitSM()
      !tauh=mh**2/S
      return
      end
      
      
      subroutine HProSetFlags(imassive,imod,modeas,ndecay,iewk)
      implicit none
      integer imassive,imod,modeas,ndecay,iewk
      integer j
      include 'model.f'
      include 'xsection.f'
      include 'hprocontrol.f'
      if (modeas.gt.0) then
         iorder=1
      else
         iorder=0
      endif
      do j=1,7
         channels(j)=.true.
      enddo
      fbrems=.true.
      idecay=ndecay
      Q2cut=1d-8
      imass=imassive
      imode=imod
      imodel=1
      iewk2=iewk
      return
      end

      subroutine HProSetMSSM(tanb,al,thstop,thsbot)
      implicit none
      double precision tanb,al,thstop,thsbot
      include 'model.f'
      include 'xsection.f'
      beta=datan(tanb)
      alpha=al*(PI/180d0)
      ths=thstop*(PI/180d0)
      thsb=thsbot*(PI/180d0)
      call InitMSSM
      end
