
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCC Auxiliary functions CCCCCCCCCCCCCCCCCCCCCCCCCC

      double precision function Diquad71(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+l1*(1-r*t)/2.0d0/r/(r+t)
      A1 = l1*l2*(1+u)**2/2.0d0
      A2 = (1-l1/2.0d0)*(1-l2)*Kp*r*(1-l1*Km/2.0d0/Kp)
      Diquad71 = l2*s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END

      double precision function Diquad721(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+(1-l1*l2/2.0d0)*(1-r*t)/r/(r+t)
      A1 = (1-l1*l2/2.0d0)*(1+u)**2
      A2 = l1/2.0d0*(1-l2)*Kp*r*(1-(1-l1*l2/2.0d0)*Km/Kp)
      Diquad721 = s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END
            
      double precision function Diquad722(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+(1-l1/2.0d0)*(1-r*t)/r/(r+t)
      A1 = (1-l1/2.0d0)*l2*(1+u)**2      
      A2 = 1/2.0d0*(1-l1*l2)*Kp*r*(1-(1-l1/2.0d0)*Km/Kp)
      Diquad722 = l2*s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END

      double precision function Dsquar311(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+(1-l1*l2)*(1-r*t)/r/(r+t)
      A1 = (1-l1*l2)*(1+u)**2
      A2 = l1*(1-l2)*Kp*r*(1-(1-l1*l2)*Km/Kp)
      Dsquar311 = s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END

      double precision function Dsquar312(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+(1-l1)*(1-r*t)/r/(r+t)
      A1 = l2*(1-l1)*(1+u)**2
      A2 = (1-l1*l2)*Kp*r*(1-(1-l1)*Km/Kp)
      Dsquar312 = l2*s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END

      double precision function Dsquar321(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+l1*l2*(1-r*t)/r/(r+t)
      A1 = l1*(1-l2)*(1+u)**2
      A2 = (1-l1*l2)*Kp*r*(1-l1*l2*Km/Kp)
      Dsquar321 = s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END

      double precision function Dsquar322(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,r,t,u,A1,A2,Kp,Km
      u = (l3-l3*z+z)/(1-l3+l3*z)
      r = dsqrt(u)
      t = dsqrt(z)
      Kp = (r+t)*(1+r*t)
      Km = (r-t)*(1-r*t)
      s1 = 1+l1*(1-r*t)/r/(r+t)
      A1 = (1-l1*l2)*(1+u)**2
      A2 = l2*(1-l1)*Kp*r*(1-l1*Km/Kp)
      Dsquar322 = l2*s1+(A1+A2+2.0d0*(2.0d0*l4-1)*dsqrt(A1*A2))
     & /Kp/r/s1
      RETURN
      END
  
      double precision function k1(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4
      t3 = l2*l3
      t11 = dsqrt(t3*(1-l2)*(1-l3))
      k1 = 1/(1-(1-z)*l1*(l2+l3-2*t3-2*(2*l4-1)*t11))
      RETURN
      END

      double precision function s13f(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4
      s13f = -l1*(1-z)*(1-l2)
      RETURN
      END

      double precision function s23f(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4
      s23f = -l1*l2*(1-z)
      RETURN
      END

      double precision function s14f(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,k1
      external k1
      t1 = k1(z,l1,l2,l3,l4)
      s14f = -t1*(1-z)*(1-l1)*(1-l3)
      RETURN
      END

      double precision function s24f(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,k1
      external k1
      t1 = k1(z,l1,l2,l3,l4)
      s24f = -t1*(1-z)*(1-l1)*l3
      RETURN
      END

      double precision function s3vf(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,s14f,s24f
      external s14f,s24f
      t1 = s14f(z,l1,l2,l3,l4)
      t2 = s24f(z,l1,l2,l3,l4)
      s3vf = 1+t1+t2
      RETURN
      END

      double precision function s4vf(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,s13f,s23f
      external s13f,s23f
      t1 = s13f(z,l1,l2,l3,l4)
      t2 = s23f(z,l1,l2,l3,l4)
      s4vf = 1+t1+t2
      RETURN
      END

      double precision function f1(y,z,l1)
      IMPLICIT double precision(s,t)
      double precision y,z,l1,r,t,u
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      t2 = (1+u)**2
      t3 = 1/r
      t7 = r*t
      f1 = t2*t3/(r+t)/(1+t7)*(1-l1*(r-t)*(1-t7)*t3/(1+z))
      RETURN
      END

      double precision function f2(y,z)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      t6 = (1+u)**2
      f2 = r*(r+t)*(1+r*t)/t6
      RETURN
      END

      double precision function f3(y,z)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      t2 = r*t
      f3 = (r-t)*(1-t2)/(r+t)/(1+t2)
      RETURN
      END

      double precision function s34r2(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      t2 = (1+u)**2
      s34r2 = t2/r/(r+t)/(1+r*t)
      RETURN
      END

      double precision function s23r2(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      s23r2 = 1+l1*(1-r*t)/r/(r+t)
      RETURN
      END

      double precision function s1vr2(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      s1vr2 = 1-l1*r*(1-r*t)/(r+t)
      RETURN
      END

      double precision function s2vr2(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      s2vr2 = 1-l1*(r-t)/r/(1+r*t)
      RETURN
      END

      double precision function s23rf(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      s23rf = -l2*(1+l1*(1-r*t)/r/(r+t))
      RETURN
      END

      double precision function s34rf(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      t2 = (1+u)**2
      s34rf = l1*t2/r/(r+t)/(1+r*t)
      RETURN
      END

      double precision function s1vrf(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      s1vrf = -1+l1*r*(1-r*t)/(r+t)
      RETURN
      END

      double precision function s13rf(z,l1,l2,y,l4)
      IMPLICIT double precision(s,t)
      double precision y,z,r,t,u,l1,l2,l4
      u = (y+z-y*z)/(1-y+y*z)
      r = dsqrt(u)
      t = dsqrt(z)
      t2 = r+t
      t4 = 1/r/t2
      t5 = r*t
      t6 = 1+t5
      t8 = 1-t5
      t14 = 1-l2
      t17 = (1+u)**2
      t19 = 1-l1
      t27 = r*t2*t6-l1*r*(r-t)*t8
      t36 = dsqrt(l1*l2*t19*t14*t17*t27)
      s13rf = -t4/t6/(1+l1*t8*t4)*(l1*t14*t17+l2*t19*t27+2*(2*l4-1)*t36)
      RETURN
      END

      double precision function s3vrf(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,s13rf,s23rf,s34rf
      external s13rf,s23rf,s34rf
      t1 = 1-l3
      t2 = 1-z
      t4 = s13rf(z,l1,l2,l3,l4)
      t7 = s23rf(z,l1,l2,l3,l4)
      t10 = t2**2
      t11 = s34rf(z,l1,l2,l3,l4)
      s3vrf = z-t1*t2*t4-l3*t2*t7-l3*t1*t10*t11
      RETURN
      END

      double precision function s4vrf(z,l1,l2,l3,l4)
      IMPLICIT double precision(s,t)
      double precision z,l1,l2,l3,l4,s13rf,s23rf
      external s13rf,s23rf
      t2 = 1-z
      t4 = s13rf(z,l1,l2,l3,l4)
      t7 = s23rf(z,l1,l2,l3,l4)
      s4vrf = 1+(1-l3)*t2*t4+l3*t2*t7
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      double precision function SSC(x,modeas)
      implicit real*8(a-h,o-z)
      real*8 Mz
      Integer modeas,i
 
      double precision asZlo, asZnlo, asZnnlo
      COMMON /alpha_initial/ asZlo, asZnlo, asZnnlo 

      if (modeas.eq.0) then
        
CCC   LO alpha_s/Pi

      b0= 1.916666667

      as0=asZlo/3.14159265358D0
      Mz=91.187D0
      step=dlog(x**2/Mz**2)/100

      do i=1,100
         as=as0 - step*b0*as0**2*(1.D0)
         as0 = as
      enddo
      SSC=as

      elseif (modeas.eq.1) then
 
CCC   NLO alpha_s/Pi
 
      b0= 1.916666667
      b1= 1.260869565
 
C     Initial condition alpha_s(M_Z) of 0.119
C     ! Note the initial condition should be
C     consistent with MSRT fitting
                                                                                                                                            
      as0=asZnlo/3.14159265358D0
      Mz=91.187D0
      step=dlog(x**2/Mz**2)/100
                                                                                                                                            
      do i=1,100
         as=as0 - step*b0*as0**2*(1.D0+b1*as0)
         as0 = as
      enddo
      SSC=as
      
      elseif (modeas.eq.2) then
                                                                                                                                            
      b0= 1.916666667
      b1=1.260869565
      b2=1.474788647
                                                                                                                                            
C     Initial condition alpha_s(M_Z) of 0.0.1155
C     This number should be comparable with MSRT fitting
                                                                                                                                            
      as0=asZnnlo/3.14159265358D0
      Mz=91.187D0
      step=dlog(x**2/Mz**2)/100D0
 
      do i=1,100
 
         as=as0 - step*b0*as0**2*(1.D0+b1*as0 + b2*as0**2 )
         as0 = as
      enddo
 
      SSC=as
 
      else
 
      SSC=0
 
      endif
 
      RETURN
      end

